#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

#define int long long

const int N = 12;
const int INF = 1e18 + 239;

int n, k;
int dp[N][N][2];

void mkdp(int s) {
    for (int i = 0; i < s; i++) {
        for (int j = 0; j <= n; j++) {
            dp[i][j][0] = -INF;
            dp[i][j][1] = -INF;
        }
    }
}

vector<int> solve_comp(vector<int> w) {
    vector<int> ans(n + 1);
    int s = (int)w.size();
    //first stays with it
    {
        mkdp(s);
        for (int df = 0; df + 1 <= n; df++) {
            dp[0][df + 1][1] = w[0] * ((df + k) >= 2 * k);
        }
        for (int df = 0; df + 1 <= n; df++) {
            dp[0][df + 1][0] = w[0] * ((df + 2 * k) >= 2 * k);
        }
        for (int i = 0; i + 1 < s; i++) {
            for (int alr = 0; alr <= n; alr++) {
                for (int df = 0; alr + df <= n; df++) {
                    for (int cn = 0; cn < 2; cn++) {
                        for (int we = 0; we < 2 && df + alr + we <= n; we++) {
                            if (!cn && we) continue;
                            //not stealing
                            dp[i + 1][alr + df + we + !cn][1] = max(dp[i + 1][alr + df + we + !cn][1], dp[i][alr][cn] + w[i + 1] * (df + k * we >= 2 * k));
                            //stealing
                            dp[i + 1][alr + df + we + !cn][0] = max(dp[i + 1][alr + df + we + !cn][0], dp[i][alr][cn] + w[i + 1] * (df + k * we + k >= 2 * k));
                        }
                    }
                }
            }
        }
        for (int i = 0; i <= n; i++) {
            ans[i] = max(ans[i], dp[s - 1][i][1]);
        }
    }
    //will be stealen
    {
        mkdp(s);
        for (int df = 0; df + 1 <= n; df++) {
            dp[0][df + 1][1] = w[0] * ((df) >= 2 * k);
        }
        for (int df = 0; df + 1 <= n; df++) {
            dp[0][df + 1][0] = w[0] * ((df + k) >= 2 * k);
        }
        for (int i = 0; i + 1 < s; i++) {
            for (int alr = 0; alr <= n; alr++) {
                for (int df = 0; alr + df <= n; df++) {
                    for (int cn = 0; cn < 2; cn++) {
                        for (int we = 0; we < 2 && df + alr + we <= n; we++) {
                            if (!cn && we) continue;
                            //not stealing
                            dp[i + 1][alr + df + we + !cn][1] = max(dp[i + 1][alr + df + we + !cn][1], dp[i][alr][cn] + w[i + 1] * (df + k * we >= 2 * k));
                            //stealing
                            dp[i + 1][alr + df + we + !cn][0] = max(dp[i + 1][alr + df + we + !cn][0], dp[i][alr][cn] + w[i + 1] * (df + k * we + k >= 2 * k));
                        }
                    }
                }
            }
        }
        for (int i = 0; i <= n; i++) {
            ans[i] = max(ans[i], dp[s - 1][i][1]);
            ans[i] = max(ans[i], dp[s - 1][i][0]);
        }
    }
    return ans;
}

int p[N];
int w[N];
int used[N];

int sdp[N][N];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> k;
    for (int i = 0; i < n; i++) {
        cin >> p[i] >> w[i];
    }
    vector<vector<int>> wcomps;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            vector<int> v;
            vector<int> vi;
            int pnt = i;
            while (!used[pnt]) {
                v.push_back(w[pnt]);
                vi.push_back(pnt);
                used[pnt] = 1;
                pnt = p[pnt];
            }
            wcomps.push_back(v);
        }
    }
    for (int i = 0; i < (int)wcomps.size(); i++) {
        vector<int> sol = solve_comp(wcomps[i]);
        for (int was = 0; was <= n; was++) {
            for (int nw = 0; was + nw <= n; nw++) {
                sdp[i + 1][was + nw] = max(sdp[i + 1][was + nw], sdp[i][was] + sol[nw]);
            }
        }
    }
    int ans = 0;
    ans = sdp[wcomps.size()][n];
    cout << ans << '\n';
}
