#ifndef LOCAL
#pragma GCC optimize("Ofast")
#endif

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

const int N = 1004;
const int INF = 2e9 + 239;

int n, k;

int ans[N];
int dp[N][N][2];

void mkdp(int s) {
    for (int i = 0; i < s; i++) {
        for (int j = 0; j <= n; j++) {
            dp[i][j][0] = -INF;
            dp[i][j][1] = -INF;
        }
    }
}

void cdp(int s, vector<int> w) {
    for (int i = 0; i + 1 < s; i++) {
        for (int alr = 0; alr <= n; alr++) {
            for (int cn = 0; cn < 2; cn++) {
                for (int we = 0; we < 2 && alr + !cn + we <= n; we++) {
                    if (!cn && we) continue;
                    for (int df = 0; df + alr + we + !cn <= n; df++) {
                        if (df + k * we != 2 * k && df + k * we + k != 2 * k && df > 0) continue;
                        //not stealing
                        dp[i + 1][alr + df + we + !cn][1] = max(dp[i + 1][alr + df + we + !cn][1], dp[i][alr][cn] + w[i + 1] * (df + k * we >= 2 * k));
                        //stealing
                        dp[i + 1][alr + df + we + !cn][0] = max(dp[i + 1][alr + df + we + !cn][0], dp[i][alr][cn] + w[i + 1] * (df + k * we + k >= 2 * k));
                    }
                }
                if (alr + 1 <= n) dp[i][alr + 1][cn] = max(dp[i][alr + 1][cn], dp[i][alr][cn]);
            }
        }
    }
}

void solve_comp(vector<int> w) {
    fill(ans, ans + n + 1, -INF);
    int s = (int)w.size();
    //wont be stolen
    {
        mkdp(s);
        //dont take 1
        for (int df = 0; df <= n; df++) {
            dp[0][df][1] = w[0] * ((df) >= 2 * k);
        }
        for (int df = 0; df <= n; df++) {
            dp[0][df][0] = w[0] * ((df + k) >= 2 * k);
        }
        //take 1
        for (int df = 0; df + 1 <= n; df++) {
            dp[0][df + 1][1] = w[0] * ((df + k) >= 2 * k);
        }
        for (int df = 0; df + 1 <= n; df++) {
            dp[0][df + 1][0] = w[0] * ((df + 2 * k) >= 2 * k);
        }
        cdp(s, w);
        for (int i = 0; i <= n; i++) {
            ans[i] = max(ans[i], dp[s - 1][i][1]);
        }
    }
    //will be stolen
    {
        mkdp(s);
        for (int df = 0; df + 1 <= n; df++) {
            dp[0][df + 1][1] = w[0] * ((df) >= 2 * k);
        }
        for (int df = 0; df + 1 <= n; df++) {
            dp[0][df + 1][0] = w[0] * ((df + k) >= 2 * k);
        }
        cdp(s, w);
        for (int i = 0; i <= n; i++) {
            ans[i] = max(ans[i], dp[s - 1][i][0]);
        }
    }
}

int p[N];
int w[N];
int used[N];

int sdp[N][N];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> k;
    for (int i = 0; i < n; i++) {
        cin >> p[i] >> w[i];
    }
    vector<vector<int>> wcomps;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            vector<int> v;
            int pnt = i;
            while (!used[pnt]) {
                v.push_back(w[pnt]);
                used[pnt] = 1;
                pnt = p[pnt];
            }
            wcomps.push_back(v);
        }
    }
    for (int i = 0; i < (int)wcomps.size(); i++) {
        solve_comp(wcomps[i]);
        // for (int was = 0; was <= n; was++) {
        //     cout << ans[was] << ' ';
        // }
        // cout << endl;
        for (int was = 0; was <= n; was++) {
            for (int nw = 0; was + nw <= n; nw++) {
                sdp[i + 1][was + nw] = max(sdp[i + 1][was + nw], sdp[i][was] + ans[nw]);
            }
        }
    }
    cout << sdp[wcomps.size()][n] << '\n';
}
