#ifndef LOCAL
#pragma GCC optimize("Ofast")
#endif

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

const int N = 1e4 + 6;
const int INF = 2e9 + 239;

int n, k;

int ans[N];

int odp[N][2];
int ndp[N][2];

void mkdp() {
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j < 2; j++) {
            odp[i][j] = -INF;
            ndp[i][j] = -INF;
        }
    }
}

void cdp(int s, vector<int> w) {
    for (int i = 0; i + 1 < s; i++) {
        for (int alr = 0; alr <= n; alr++) {
            for (int cn = 0; cn < 2; cn++) {
                for (int we = 0; we < 2 && alr + !cn + we <= n; we++) {
                    if (!cn && we) continue;
                    vector<int> cand = {2 * k - k * we, k - k * we, 0};
                    for (auto df : cand) {
                    // for (int df = 0; df + alr + we + !cn <= n; df++) {
                        if (df < 0 || df + alr + we + !cn > n) continue;
                        //not stealing
                        ndp[alr + df + we + !cn][1] = max(ndp[alr + df + we + !cn][1], odp[alr][cn] + w[i + 1] * (df + k * we >= 2 * k));
                        //stealing
                        ndp[alr + df + we + !cn][0] = max(ndp[alr + df + we + !cn][0], odp[alr][cn] + w[i + 1] * (df + k * we + k >= 2 * k));
                    }
                }
                if (alr + 1 <= n) odp[alr + 1][cn] = max(odp[alr + 1][cn], odp[alr][cn]);
            }
        }
        for (int alr = 0; alr <= n; alr++) {
            for (int cn = 0; cn < 2; cn++) {
                odp[alr][cn] = ndp[alr][cn];
                ndp[alr][cn] = -INF;
            }
        }
    }
}

void solve_comp(vector<int> w) {
    fill(ans, ans + n + 1, -INF);
    int s = (int)w.size();
    //wont be stolen
    {
        mkdp();
        //dont take 1
        for (int df = 0; df <= n; df++) {
            odp[df][1] = w[0] * ((df) >= 2 * k);
        }
        for (int df = 0; df <= n; df++) {
            odp[df][0] = w[0] * ((df + k) >= 2 * k);
        }
        //take 1
        for (int df = 0; df + 1 <= n; df++) {
            odp[df + 1][1] = w[0] * ((df + k) >= 2 * k);
        }
        for (int df = 0; df + 1 <= n; df++) {
            odp[df + 1][0] = w[0] * ((df + 2 * k) >= 2 * k);
        }
        cdp(s, w);
        for (int i = 0; i <= n; i++) {
            ans[i] = max(ans[i], odp[i][1]);
        }
    }
    //will be stolen
    {
        mkdp();
        for (int df = 0; df + 1 <= n; df++) {
            odp[df + 1][1] = w[0] * ((df) >= 2 * k);
        }
        for (int df = 0; df + 1 <= n; df++) {
            odp[df + 1][0] = w[0] * ((df + k) >= 2 * k);
        }
        cdp(s, w);
        for (int i = 0; i <= n; i++) {
            ans[i] = max(ans[i], odp[i][0]);
        }
    }
}

int p[N];
int w[N];
int used[N];

int odp2[N];
int ndp2[N];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> k;
    for (int i = 0; i < n; i++) {
        cin >> p[i] >> w[i];
    }
    vector<vector<int>> wcomps;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            vector<int> v;
            int pnt = i;
            while (!used[pnt]) {
                v.push_back(w[pnt]);
                used[pnt] = 1;
                pnt = p[pnt];
            }
            wcomps.push_back(v);
        }
    }
    {
        fill(odp2, odp2 + N, -INF);
        fill(ndp2, ndp2 + N, -INF);
        odp2[0] = 0;
    }
    for (int i = 0; i < (int)wcomps.size(); i++) {
        solve_comp(wcomps[i]);
        for (int was = 0; was <= n; was++) {
            if (odp2[was] == -INF) continue;
            for (int nw = 0; was + nw <= n; nw++) {
                ndp2[was + nw] = max(ndp2[was + nw], odp2[was] + ans[nw]);
            }
        }
        for (int was = 0; was <= n; was++) {
            odp2[was] = ndp2[was];
            ndp2[was] = 0;
        }
    }
    cout << odp2[n] << '\n';
}
