#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

const int N = 101;
const int MOD = 1e9 + 7;

int add(int a, int b) {
    if (a + b < MOD) {
        return a + b;
    }
    return a + b - MOD;
}

int sub(int a, int b) {
    if (a >= b) {
        return a - b;
    }
    return a - b + MOD;
}

int mul(int a, int b) {
    return 1LL * a * b % MOD;
}

int binpow(int a, int b) {
    int res = 1;
    while (b) {
        if (b & 1) {
            res = mul(res, a);
        }
        a = mul(a, a);
        b >>= 1;
    }
    return res;
}

int f[N];
int C[N][N];

void init() {
    for (int i = 0; i < N; i++) {
        C[i][0] = 1;
        C[i][i] = 1;
        for (int j = 1; j < i; j++) {
            C[i][j] = add(C[i - 1][j], C[i - 1][j - 1]);
        }
    }
    f[0] = 1;
    for (int i = 1; i < N; i++) {
        f[i] = mul(f[i - 1], i);
    }
}

int n, m;

int cnt(int x) {
    int def = 2;
    def = mul(def, C[n][x]);
    def = mul(def, C[m][x]);
    def = mul(def, f[x]);
    int fr = 1;
    {
        int free = (n * m) - ((n + m) * x - x * x);
        fr = mul(fr, binpow(2, free));
    }
    return mul(def, fr);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    init();

    cin >> n >> m;
    if (n < m) swap(n, m);
    if (n == 1 && m == 1) {
        cout << 0 << '\n';
        return 0;
    }
    if (m == 1) {
        cout << 2 << '\n';
        return 0;
    }
    int ans = binpow(2, n * m);
    int bad = 0;
    for (int c = 1; c <= min(n, m); c++) {
        if (c % 2 == 1) {
            bad = add(bad, cnt(c));
        } else {
            bad = sub(bad, cnt(c));
        }
    }
    cout << sub(ans, bad) << '\n';
}
