#include "sqsort.h"

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <random>

using namespace std;

mt19937 rng(20);

vector<pair<int, int>> solve(int n) {
    vector<pair<int, int>> ans;
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            ans.push_back({i, j});
        }
    }
    auto cmp_el = [&](int a, int b) {
        return cmp(a, a, b, b);
    };
    vector<int> ind(n);
    for (int i = 0; i < n; i++) {
        ind[i] = i;
    }
    sort(ind.begin(), ind.end(), cmp_el);
    vector<int> wr(n);
    for (int i = 0; i < n; i++) {
        wr[ind[i]] = i;
    }
    auto mcmp = [&](pair<int, int> a, pair<int, int> b) {
        if (wr[a.first] <= wr[b.first] && wr[a.second] <= wr[b.second]) {
            return true;
        }
        if (wr[a.first] >= wr[b.first] && wr[a.second] >= wr[b.second]) {
            return false;
        }
        return cmp(a.first, a.second, b.first, b.second);
    };
    shuffle(ans.begin(), ans.end(), rng);
    stable_sort(ans.begin(), ans.end(), mcmp);
    return ans;
}
