#include "sqsort.h"

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <random>

using namespace std;

mt19937 rng(20);

map<tuple<int, int, int, int>, int> mem;

bool rcmp(int a, int b, int c, int d) {
    if (a > b) swap(a, b);
    if (c > d) swap(c, d);
    tuple<int, int, int, int> tp = {a, b, c, d};
    if (!mem.count(tp)) {
        mem[tp] = cmp(a, b, c, d);
    }
    return mem[tp];
}

vector<pair<int, int>> solve(int n) {
    vector<pair<int, int>> ans;
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            ans.push_back({i, j});
        }
    }
    auto cmp_el = [&](int a, int b) {
        return rcmp(a, a, b, b);
    };
    vector<int> ind(n);
    for (int i = 0; i < n; i++) {
        ind[i] = i;
    }
    stable_sort(ind.begin(), ind.end(), cmp_el);
    vector<int> wr(n);
    wr[ind[0]] = 0;
    for (int i = 1; i < n; i++) {
        if (!cmp_el(ind[i - 1], ind[i])) {
            wr[ind[i]] = wr[ind[i - 1]];
        } else {
            wr[ind[i]] = wr[ind[i - 1]] + 1;
        }
    }
    auto mcmp = [&](pair<int, int> a, pair<int, int> b) {
        if (wr[a.first] <= wr[b.first] && wr[a.second] <= wr[b.second]) {
            return true;
        }
        if (wr[a.first] >= wr[b.first] && wr[a.second] >= wr[b.second]) {
            return false;
        }
        return rcmp(a.first, a.second, b.first, b.second);
    };
    shuffle(ans.begin(), ans.end(), rng);
    stable_sort(ans.begin(), ans.end(), mcmp);
    return ans;
}
