#include <iostream>
#include <vector>
#include <cassert>

using ll = long long;
#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#define MAX(a, b) (((a) < (b)) ? (b) : (a))

int const nmax = 10000;
int const inf = 1000000000;

int p[1 + nmax], cost[1 + nmax];

int dp[1 + 2 * nmax][2][2], seen[1 + nmax];
int dp2[1 + 2 * nmax][2][2];
int steps = 0;

void solve(int n, int start, int k) {
  std::vector<int> positions;
  int node = start;
  do {
    seen[node] = 1;
    positions.push_back(node);
    node = p[node];
  } while(node != start);

  for(int i = 0; i < positions.size(); i++) {
    int node = positions[i];

    for(int j = steps; j <= n + steps; j++)
      dp2[j][0][0] = dp2[j][0][1] = dp2[j][1][0] = dp2[j][1][1] = -inf;
    if(0 == i) {
      for(int j = steps; j <= n + steps; j++) {
        if(j < 2 * n) 
          dp2[j + 1][0][1] = MAX(dp2[j + 1][0][1], dp[j][0][0]);
        if(k <= j)
          dp2[j - k][0][1] = MAX(dp2[j - k][0][1], dp[j][0][0] + cost[node]);
        dp2[j][1][1] = MAX(dp2[j][1][1], dp[j][0][0] + cost[node]);

        dp2[j][0][0] = MAX(dp2[j][0][0], dp[j][0][0]);
      }
    } else {
      for(int j = steps; j <= n + steps; j++) {
        for(int h = 0; h < 2; h++)
          for(int h2 = 0; h2 < 2; h2++) {
            if(j < 2 * n && h == 0)
              dp2[j + 1][0][h2] = MAX(dp2[j + 1][0][h2], dp[j][h][h2]);
            if(k <= j && h == 0)
              dp2[j - k][0][h2] = MAX(dp2[j - k][0][h2], dp[j][h][h2] + cost[node]);
            if(h == 0)
              dp2[j][1][h2] = MAX(dp2[j][1][h2], dp[j][h][h2] + cost[node]);

            dp2[j][0][h2] = MAX(dp2[j][0][h2], dp[j][h][h2]);
          }
      }
    }
    steps++;
    for(int j = steps; j <= n + steps; j++)
      for(int h = 0; h < 2; h++)
        for(int h2 = 0; h2 < 2; h2++)
          dp[j][h][h2] = dp2[j][h][h2];
  }

  for(int j = 0; j <= n * 2; j++)
    dp[j][0][0] = MAX(MAX(dp[j][0][1], dp[j][1][0]), dp[j][0][0]);
}

int main() {
  std::ios::sync_with_stdio(0);
  std::cin.tie(0);

  int n, k;
  std::cin >> n >> k;
  for(int i = 0;i < n; i++) 
    std::cin >> p[i] >> cost[i];
  for(int i = 0; i <= 2 * n; i++)
    dp[i][0][0] = dp[i][0][1] = dp[i][1][0] = dp[i][1][1] = -inf;
  dp[n][0][0] = 0;

  for(int i = 0;i < n; i++)
    if(seen[i] == 0)
      solve(n, i, k);
  int result = 0;
  for(int i = n; i <= 2 * n; i++)
    result = std::max(result, dp[i][0][0]);
  std::cout << result;
  return 0;
}
