#include <iostream>
#include <vector>
#include <cassert>

using ll = long long;
#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#define MAX(a, b) (((a) < (b)) ? (b) : (a))

int const nmax = 50;
int const modulo = 1000000007;

int comb[1 + nmax][1 + nmax];
int fact[1 + nmax];

void computecomb() {
  fact[0] = 1;
  for(int i = 1; i <= nmax; i++)
    fact[i] = 1LL * fact[i - 1] * i % modulo;

  comb[0][0] = 1;
  for(int i = 1; i <= nmax; i++) {
    comb[i][0] = 1;
    for(int j = 1; j <= i; j++) {
      comb[i][j] = comb[i - 1][j - 1] + comb[i - 1][j];
      if(modulo <= comb[i][j])
        comb[i][j] -= modulo;
    }
  }
}

int lgpow(int a, int b) {
  if(b == 0)
    return 1;
  else if(b == 1)
    return a;
  else {
    int result = lgpow(a, b / 2);
    if(b % 2 == 0)
      return 1LL * result * result % modulo;
    else
      return 1LL * result * result % modulo * a % modulo;
  }
}

int main() {
  int n, m;
  std::cin >> n >> m;
  computecomb();
  int result = lgpow(2, n * m);
  for(int i = 1; i <= std::min(n, m); i++) {
    result += 1LL * comb[n][i] * comb[m][i] % modulo * lgpow(2, (n - i) * (m - i) + 1) % modulo * lgpow(modulo - 1, i) % modulo * fact[i] % modulo;
    if(modulo <= result)
      result -= modulo;
  }
  std::cout << result;
  return 0;
}
