#include "sqsort.h"
#include <vector>
#include <algorithm>
#include <cassert>
#include <iostream>

std::vector<int> id;

bool compare(std::pair<int,int> f1, std::pair<int,int> f2) {
  if(f1.second < f1.first)
    std::swap(f1.first, f1.second);
  if(f2.second < f2.first)
    std::swap(f2.second, f2.first);
  std::pair<int, int> fs1 = f1, fs2 = f2;
  if(id[fs1.first] > id[fs1.second])
    std::swap(fs1.first, fs1.second);
  if(id[fs2.first] > id[fs2.second])
    std::swap(fs2.first, fs2.second);
   
  if(id[fs1.first] < id[fs2.first] && id[fs1.second] < id[fs1.second]){
    return 1;
  }
  if(id[fs1.first] > id[fs2.first] && id[fs1.second] > id[fs1.second]) {
    return 0;
  }
  
  return cmp(f1.first, f1.second, f2.first, f2.second);
}

bool compare2(int val, int val2) {
  return cmp(val, val, val2, val2);
}

void precompute(int n) {

  id.resize(n);
  std::vector<int> ord(n);
  for(int i = 0; i < n; i++)
    ord[i] = i;
 
  std::sort(ord.begin(), ord.end(), compare2);
  for(int i = 0;i < n; i++)
    id[ord[i]] = i;
}

std::vector<std::pair<int,int>> solve(int n) {
  precompute(n);
  std::vector<std::pair<int,int>> ans;
  for(int i = 0; i < n; i++)
    for(int j = i; j < n; j++)
      ans.push_back({i, j});
  std::sort(ans.begin(), ans.end(), compare);
  return ans;
}
