#include "sqsort.h"
#include <vector>
#include <algorithm>
#include <cassert>
#include <iostream>

std::vector<int> id;
std::vector<int> orb;

bool compare(std::pair<int,int> f1, std::pair<int,int> f2) {
  if(f1.second < f1.first)
    std::swap(f1.first, f1.second);
  if(f2.second < f2.first)
    std::swap(f2.second, f2.first);
  std::pair<int, int> fs1 = f1, fs2 = f2;
  if(id[fs1.first] > id[fs1.second])
    std::swap(fs1.first, fs1.second);
  if(id[fs2.first] > id[fs2.second])
    std::swap(fs2.first, fs2.second);
   
  if(id[fs1.first] <= id[fs2.first] && id[fs1.second] <= id[fs2.second]){
    return 1;
  }
  if(id[fs1.first] >= id[fs2.first] && id[fs1.second] >= id[fs2.second]) {
    return 0;
  }
  
  return cmp(f1.first, f1.second, f2.first, f2.second);
}

bool compare2(int val, int val2) {
  return cmp(val, val, val2, val2);
}

void precompute(int n) {
  id.resize(n);
  orb.resize(n);
  for(int i = 0; i < n; i++)
    orb[i] = i;

  std::sort(orb.begin(), orb.end(), compare2);
  for(int i = 0;i < n; i++)
    id[orb[i]] = i;
}

std::vector<std::pair<int,int>> solve(int n) {
  precompute(n);
  
  std::vector<std::vector<std::pair<int,int>>> ord;
  ord.resize(n);
  for(int i = 0; i < orb.size(); i++)
    for(int j = i; j < orb.size(); j++)
      ord[i].push_back({orb[i], orb[j]});

  for(int jump = 1; jump < n; jump *= 2) {
    for(int i = 0; i < n - jump ; i += 2 * jump) {
      std::vector<std::pair<int,int>> aux(ord[i].size() + ord[i + jump].size());
      std::merge(ord[i].begin(), ord[i].end(), ord[i + jump].begin(), ord[i + jump].end(), aux.begin(), compare);
      ord[i] = aux;
    }
  }

  return ord[0];
}
