#include "sqsort.h"
#include <algorithm>
#include <random>
using namespace std;
#define ii pair<int,int>
#define x first
#define y second

bool mycmp(const ii &x, const ii &y){
    return cmp(x.x,x.y,y.x,y.y);
}
void merge_sort(vector<ii> &v, int i,int n){
    if(n<=1){
        return;
    }
    int mid=n/2;
    merge_sort(v,i,mid);
    merge_sort(v,i+mid,n-mid);
    vector<ii> c;
    int il=0,ir=0;
    while(il<mid&&ir<n-mid){
        if(mycmp(v[i+il],v[i+mid+ir])){
            c.push_back(v[i+il]);
            il++;
        }
        else{
            c.push_back(v[i+mid+ir]);
            ir++;
        }
    }
    while(il<mid){
        c.push_back(v[i+il]);
        il++;
    }
    while(ir<n-mid){
        c.push_back(v[i+mid+ir]);
        ir++;
    }
    for(int j=0; j<n; j++){
        v[i+j]=c[j];
    }
}
bool idxcmp(int i, int j){
    return cmp(i,i,i,j);
}
vector<ii> merge(const vector<ii> &a, const vector<ii> &b){
    vector<ii> ret;
    int il=0,ir=0;
    while(il<a.size()&&ir<b.size()){
        if(mycmp(a[il],b[ir])){
            ret.push_back(a[il]);
            il++;
        }
        else{
            ret.push_back(b[ir]);
            ir++;
        }
    }
    while(il<a.size()) {
        ret.push_back(a[il]);
        il++;
    }
    while(ir<b.size()){
        ret.push_back(b[ir]);
        ir++;
    }
    return ret;
}
std::vector<std::pair<int, int>> solve(int n){
    vector<ii> sol;
    vector<vector<ii>> subs(n);
    vector<int> idx;
    for(int i=0; i<n; i++){
        idx.push_back(i);
    }
    sort(idx.begin(),idx.end(),idxcmp);
    for(int i=0; i<n; i++){
        for(int j=i; j<n; j++){
            subs[i].emplace_back(idx[i],idx[j]);
        }
    }
    //sort(sol.begin(),sol.end(),mycmp);
//    merge_sort(sol,0,sol.size());
    std::random_device rd;
    std::mt19937 g(rd());

    std::shuffle(subs.begin(), subs.end(), g);
    while(subs.size()>1){
        vector<vector<ii>> subs2;
        for(int i=0; i+1<subs.size(); i+=2){
            subs2.push_back(merge(subs[i],subs[i+1]));
        }
        if(subs.size()%2==1){
            subs2.push_back(subs[subs.size()-1]);
        }

        subs=subs2;
    }

    return subs[0];
}