#include<iostream>
#include<bitset>
#include<set>
#include<vector>
#include<cmath>
#include<algorithm>
using namespace std;

typedef unsigned long long num;
typedef vector<num> vn;
typedef vector<vn> vvn;
typedef vector<vvn> vvvn;

int M, N;

#define PRIME 1000000007
#define fr(i, n) for(int i = 0; i < n; i++)
#define frs(i, s, n) for(int i = s; i < n; i++)
#define frv(i, s, n) for(int i = n-1; i >= s; i--)

inline num smartPow(num base, num expo)
{
	num res = 1;
	while (expo)
	{
		if (expo & 1)
		{
			res *= base;
			res %= PRIME;
		}
		expo >>= 1;
		base *= base;
		base %= PRIME;
	}
	return res;
}

inline num inverse(num base)
{
	return smartPow(base, PRIME - 2);
}


#define MN_RANGE_MAX 51
num factorial[51];

inline void calcFactorial()
{
	factorial[0] = 1;
	frs(i, 1, MN_RANGE_MAX)
	{
		factorial[i] = factorial[i - 1] * i;
		factorial[i] %= PRIME;
	}
}

inline num choose(int n, int k)//n!/k!(n-k)!
{
	num res = factorial[n - k] * factorial[k];
	res %= PRIME;
	res = factorial[n] * inverse(res);
	return res % PRIME;
}

inline num smartCHOOSE(int m, int n, int k)
{
	num res = choose(n, k) * choose(m, k);
	res %= PRIME;
	res *= factorial[k];
	return res % PRIME;
}

vvvn BALONE;//BALONE[n][m][k] = #k alone blues in n*m (n <= m)
/*if (n == 1)
	{
		BALONE[n][m][1] = m;
	}*/
inline void alone(int n, int m, int k)
{
	if (k == 0)
	{
		BALONE[n][m][k] = smartPow(2, m * n);
	}
}


inline void calcBALNOE2ORLESS(int N, int M)
{
	M++; N++;
	fr(i, M)
	{
		BALONE[0][i][0] = 1;
	}
	fr(i, M)
	{
		BALONE[1][i][0] = 1;
	}
	fr(i, N)
	{
		BALONE[i][0][0] = 1;
	}


}



inline void calcBALNOESANDMORE(int N, int M)
{
	N++; M++;//inc edjes
	frs(n, 1, N)
	{
		frs(m, n, M)
		{
			BALONE[n][m][0] = smartPow(2, m * n);
			frv(k, 1, min(n, m)+1)
			{
				BALONE[n][m][k] = (smartCHOOSE(m,n,k) * BALONE[n-k][m-k][0]) % PRIME;
				BALONE[n][m][0] += PRIME - BALONE[n][m][k];
				BALONE[n][m][0] %= PRIME;
			}
		}
	}
}




int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	calcFactorial();
	cin >> N >> M;
	if (N > M)
	{
		swap(N, M);
	}
	BALONE = vvvn(N + 1, vvn(M + 1, vn(N + 1)));
	fr(i, M+1)
	{
		BALONE[0][i][0] = 1;
	}
	fr(i, M+1)
	{
		BALONE[1][i][0] = 1;
	}
	calcBALNOESANDMORE(N, M);

	num res;
	if (N != 2 && M != 2)
	{
		res = (2 * BALONE[N][M][0]) % PRIME;
		res += PRIME - smartPow(2, M*N);
		res %= PRIME;
		
	}
	else
	{
		if (N != 2)
		{
			swap(M, N);
		}
		if (1 == M)
		{
			res = 2;
		}
		else if (2 == M)
		{
			res = 6;
		}
		else
		{
			res = 2 * (BALONE[N][M][0] - M) % PRIME;
			res += PRIME - smartPow(2, M*N);
			res %= PRIME;
		}
	}

	cout << res << endl;
	return 0;
}