#include "sqsort.h"
#include <list>
#include <algorithm>
using namespace std;
#define fr(i, n) for(int i = 0; i < n; i++)
#define frs(i, s, n) for(int i = s; i < n; i++)
#define frv(i, s, n) for(int i = n-1; i >= s; i--)

typedef list<int> lst;
typedef pair<int, int> point;

int N;
vector<int> sorted;
vector<int> sortedReverse;

#define ENDING -1
bool mySmallerThan(int a, int b, int c, int d)
{
	if (b == ENDING)
	{
		return false;
	}
	else if(d == ENDING)
	{
		return true;
	}
	else
	{
		return cmp(a, b, c, d);
	}
}

bool secondSmallerThan(int a, int b, int c, int d)
{
	if (b == ENDING)
	{
		return false;
	}
	else if (d == ENDING)
	{
		return true;
	}
	else if ((sortedReverse[a] >= sortedReverse[c] && sortedReverse[b] >= sortedReverse[d]) ||
			 (sortedReverse[a] <= sortedReverse[c] && sortedReverse[b] <= sortedReverse[d]))
	{
		return (sortedReverse[a] <= sortedReverse[c] && sortedReverse[b] <= sortedReverse[d]);
	}
	else
	{
		return cmp(a, b, c, d);
	}
}

lst mergeSort(int lower, int upper)
{
	if (lower + 1 == upper)
	{
		lst a = { lower, ENDING };
		return a;
	}
	else
	{
		int middle = (lower + upper) / 2;
		lst left = mergeSort(lower, middle);
		lst right = mergeSort(middle, upper);
		lst res;
		while (!left.empty() && !right.empty())
		{
			if (mySmallerThan(left.front(), left.front(), right.front(), right.front()))
			{
				res.push_back(left.front());
				left.pop_front();
			}
			else
			{
				res.push_back(right.front());
				right.pop_front();
			}
		}
		return res;
	}
}

list<point> addAnotherLevel(list<point> tilNow, list<point> compeating)
{
	list<point> res;
	while (!tilNow.empty() && !compeating.empty())
	{
		if (secondSmallerThan(tilNow.front().first, tilNow.front().second, compeating.front().first, compeating.front().second))
		{
			res.push_back(tilNow.front());
			tilNow.pop_front();
		}
		else
		{
			res.push_back(compeating.front());
			compeating.pop_front();
		}
	}
	return res;
}

inline list<point> createListForIndex(int lower)
{
	list<point> a;
	frs(i, lower, N - lower)
	{
		a.push_back(point(min(sorted[lower], sorted[i]), max(sorted[lower], sorted[i])));
	}
	frs(i, lower + 1, N - lower)
	{
		a.push_back(point(min(sorted[N - lower - 1], sorted[i]), max(sorted[N - lower - 1], sorted[i])));
	}
	a.push_back(point(ENDING, ENDING));
	return a;
}

list<point> mergeSortLists(int lower, int upper)
{
	if (lower + 1 == upper)
	{
		return createListForIndex(lower);
	}
	else
	{
		int middle = (lower + upper) / 2;
		list<point> left =  mergeSortLists(lower, middle);
		list<point> right = mergeSortLists(middle, upper);
		return addAnotherLevel(left, right);
	}
}

list<point> mergeSortBALANCEDLists(int upper)
{
	vector< list<point>> allToMERGE(upper);
	fr(i, (upper+1)/2)
	{
		allToMERGE[(upper - 1) - 2 * i] = createListForIndex(2*i);
	}
	fr(i, (upper) / 2)
	{
		allToMERGE[(2 * i + 1)] = createListForIndex(2*i+1);
	}

	while (allToMERGE.size() != 1)
	{
		vector< list<point>> next((upper+1)/2);
		fr(i, (upper) / 2)
		{
			next[i] = addAnotherLevel(allToMERGE[2*i], allToMERGE[2*i + 1]);
		}
		if (upper % 2)
		{
			next[(upper + 1) / 2 - 1] = allToMERGE[upper - 1];
		}
		upper = (upper + 1) / 2;
		allToMERGE = next;
	}
	return allToMERGE[0];
}


std::vector<std::pair<int, int>> solve(int n)
{
	lst curr = mergeSort(0, n);
	N = n;
	sorted = vector<int>(curr.begin(), curr.end());
	sortedReverse = vector<int>(n);
	fr(i, N)
	{
		sortedReverse[sorted[i]] = i;
	}
	list<point> allSorted;
	list<point> res = /*mergeSortBALANCEDLists((n + 1) / 2);*/mergeSortLists(0, (n+1)/2);
	res.pop_back();
	return std::vector<std::pair<int, int>>(res.begin(), res.end());
}