#ifndef SQSORT_H
#define SQSORT_H

#include <vector>
#include <queue>
#include <utility>

bool cmp(int a, int b, int c, int d);
using namespace std;

vector<pair<int, int> > merge(vector<pair<int, int> > a, vector<pair<int, int> > b)
{
    vector<pair<int, int> > res;
    int i = 0;
    int j = 0;
    while (i < a.size() && j < b.size())
    {
        if (cmp(a[i].first, a[i].second, b[j].first, b[j].second))
        {
            res.push_back(a[i]);
            ++i;
        }
        else
        {
            res.push_back(b[j]);
            ++j;
        }
    }
    while (i < a.size())
    {
        res.push_back(a[i]);
        ++i;
    }
    while (j < b.size())
    {
        res.push_back(b[j]);
        ++j;
    }
    return res;
}

std::vector<std::pair<int, int>> solve(int n)
{
    vector<int> a;
    vector<bool> used(n);
    for (int j = 0; j < n; ++j)
    {
        int mx = -1;
        for (int i = 0; i < n; ++i)
        {
            if (used[i]) continue;
            if (mx == -1 || cmp(0, mx, 0, i)) mx = i;
        }
        a.push_back(mx);
        used[mx] = true;
    }
    reverse(a.begin(), a.end());
    deque<vector<pair<int, int> > > all;
    for (int i = 0; i < n; ++i)
    {
        vector<pair<int, int> > now;
        for (int j = i; j < n; ++j)
        {
            now.push_back({a[i], a[j]});
        }
        all.push_back(now);
    }

    while (all.size() > 1)
    {
        all.push_back(merge(all[0], all[1]));
        all.pop_front();
        all.pop_front();
    }
    return all[0];

}

#endif
