#ifndef SQSORT_H
#define SQSORT_H

#include <vector>
#include <queue>
#include <utility>
#include <bits/stdc++.h>

bool cmp(int a, int b, int c, int d);
using namespace std;


vector<int> pos;


vector<pair<pair<int, int>, pair<int, int>>> all;

bool less(pair<int, int> a, pair<int, int> b)
{
    if (pos[a.first] <= pos[b.first] && pos[a.second] <= pos[b.second]) return true;
    return false;
}

bool comp(int a, int b, int c, int d)
{
    pair<int, int> t1 = {a, b};
    pair<int, int> t2 = {c, d};
    if (less(t1, t2)) return true;
    if (less(t2, t1)) return false;
    for (int i = 0; i < all.size(); ++i)
    {
        if (less(t1, all[i].first) && less(all[i].second, t2)) return true;
        if (less(t2, all[i].first) && less(all[i].second, t1)) return false;
    }

    bool w = cmp(a, b, c, d);
    if (w)
        all.push_back(make_pair(make_pair(a, b), make_pair(c, d)));
    else
        all.push_back(make_pair(make_pair(c, d), make_pair(a, b)));

}

vector<pair<int, int> > merge(vector<pair<int, int> > a, vector<pair<int, int> > b)
{
    vector<pair<int, int> > res;
    int i = 0;
    int j = 0;
    while (i < a.size() && j < b.size())
    {
        if (comp(a[i].first, a[i].second, b[j].first, b[j].second))
        {
            res.push_back(a[i]);
            ++i;
        }
        else
        {
            res.push_back(b[j]);
            ++j;
        }
    }
    while (i < a.size())
    {
        res.push_back(a[i]);
        ++i;
    }
    while (j < b.size())
    {
        res.push_back(b[j]);
        ++j;
    }
    return res;
}

std::vector<std::pair<int, int>> solve(int n)
{
    vector<int> a;
    vector<bool> used(n);
    for (int j = 0; j < n; ++j)
    {
        int mx = -1;
        for (int i = 0; i < n; ++i)
        {
            if (used[i]) continue;
            if (mx == -1 || cmp(0, mx, 0, i)) mx = i;
        }
        a.push_back(mx);
        used[mx] = true;
    }
    reverse(a.begin(), a.end());
    pos.resize(n);
    for (int i = 0; i < n; ++i) pos[a[i]] = i;
    deque<vector<pair<int, int> > > all;
    for (int i = 0; i < n; ++i)
    {
        vector<pair<int, int> > now;
        for (int j = i; j < n; ++j)
        {
            now.push_back({a[j - i], a[j]});
        }
        all.push_back(now);
    }
    while (all.size() > 1)
    {
        all.push_back(merge(all[0], all[1]));
        all.pop_front();
        all.pop_front();
    }
    return all[0];

}

#endif
