#include "sqsort.h"
#include <bits/stdc++.h>

std::vector<std::pair<int, int>> go(int l, int r, std::vector<std::vector<std::pair<int, int>>>& rows) {
    if(r - l == 1) {
        return rows[l];
    }
    int totallen = 0;
    for(int i = l; i < r; i++) {
        totallen += rows[i].size();
    }
    int m = l;
    int len = 0;
    while(len * 2 <= totallen && m + 1 < r) {
        len += rows[m].size();
        m++;
    }
    auto a = go(l, m, rows);
    auto b = go(m, r, rows);
    std::vector<std::pair<int, int>> res(a.size() + b.size());
    merge(a.begin(), a.end(), b.begin(), b.end(), res.begin(), [](auto a, auto b) {
        return cmp(a.first, a.second, b.first, b.second);
    });
    return res;
}

std::vector<std::pair<int, int>> solve(int n) {
    std::vector<int> orderedvals(n);
    for(int i = 0; i < n; i++) {
        orderedvals[i] = i;
    }
    stable_sort(orderedvals.begin(), orderedvals.end(), [](int a, int b) {
        return cmp(0, a, 0, b);
    });

    std::vector<std::vector<std::pair<int, int>>> rows(n);
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < n; j++) {
            if(orderedvals[j] >= i) {
                rows[i].emplace_back(i, orderedvals[j]);
            }
        }
    }
    return go(0, n, rows);
}
