#include "sqsort.h"
#include <bits/stdc++.h>

std::vector<std::pair<int, int>> solve(int n) {
    std::vector<int> orderedvals(n);
    for(int i = 0; i < n; i++) {
        orderedvals[i] = i;
    }
    std::stable_sort(orderedvals.begin(), orderedvals.end(), [](int a, int b) {
        return cmp(0, a, 0, b);
    });

    std::list<std::pair<int, int>> lst;
    std::vector< std::vector<decltype(lst.begin())> > ptr_to(n, std::vector<decltype(lst.begin())>(n, lst.end()));
    for(int j = 0; j < n; j++) {
        lst.emplace_back(j, j);
        ptr_to[j][j] = --lst.end();
    }
    for(int i = 1; i < n; i++) {
        for(int j = 0; i + j < n; j++) {
            auto p1 = ptr_to[j][i + j - 1];
            auto p2 = ptr_to[j + 1][i + j];
            auto it = std::lower_bound(p1, p2, std::make_pair(j, i + j), [&](auto a, auto b) {
                return cmp(orderedvals[a.first], orderedvals[a.second], orderedvals[b.first], orderedvals[b.second]);
            });
            auto pp = ptr_to[it->first][it->second];
            lst.insert(pp, std::make_pair(j, i + j));
            ptr_to[j][i + j] = --pp;
        }
    }

    std::vector<std::pair<int, int>> res;
    for(auto p: lst) {
        res.emplace_back(orderedvals[p.first], orderedvals[p.second]);
    }
    return res;
}
