#include <bits/stdc++.h>
#ifndef DEBUG
    #include "sqsort.h"
#endif

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; }
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; }
void debug_out() { cerr << endl; }
template<typename T1, typename... T2> void debug_out(T1 A, T2... B) { cerr << ' ' << A; debug_out(B...); }
#ifdef DEBUG
    #define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
    #define debug(...) 1337
#endif

mt19937 rng(time(0));

#ifdef DEBUG
int A[2003];
int queries;
bool cmp(int a, int b, int c, int d)
{
    ++queries;
    return A[a] + A[b] < A[c] + A[d];
}
#endif


vector<pii> solve(int n)
{
    vector<int> ord(n);
    iota(all(ord), 0);
    shuffle(all(ord), rng);
    sort(all(ord), [&](int i, int j) -> bool
    {
        return cmp(i, i, j, j);
    });
    vector<int> where(n);
    for (int i = 0; i < n; ++i)
        where[ord[i]] = i;

    auto my_cmp = [&](pii A, pii B) -> bool
    {
        if (where[B.fi] <= where[A.fi] && where[B.se] <= where[A.se])
            return false;
        return cmp(A.fi, A.se, B.fi, B.se);
    };

    vector<int> rord(n);
    iota(all(rord), 0);
    shuffle(all(rord), rng);

    function< vector<pii>(int, int) > dfs = [&](int l, int r) -> vector<pii>
    {
        if (l == r)
        {
            int i = rord[l];
            vector<pii> ans(n - i);
            for (int k = 0; k < n - i; ++k)
                ans[k] = {ord[i], ord[i + k]};
            return ans;
        }
        int mid = (l + r) >> 1;
        auto A = dfs(l, mid);
        auto B = dfs(mid + 1, r);
        vector<pii> ans;
        int i = 0, j = 0;
        while (i < A.size() && j < B.size())
        {
            if (where[A[i].fi] <= where[B[j].fi] && where[A[i].se] <= where[B[j].se] || my_cmp(A[i], B[j]))
                ans.push_back(A[i++]);
            else
                ans.push_back(B[j++]);
        }
        while (i < A.size())
            ans.push_back(A[i++]);
        while (j < B.size())
            ans.push_back(B[j++]);
        return ans;
    };
    return dfs(0, n - 1);

    vector<pii> ans;
    for (int i = 0; i < n; ++i)
        for (int j = i; j < n; ++j)
        {
            int u = ord[i];
            int v = ord[j];
            if (u > v) swap(u, v);
            ans.emplace_back(u, v);
        }
    sort(all(ans), my_cmp);
    return ans;
}

#ifdef DEBUG
signed main()
{
    int N = 2000;
    for (int i = 0; i < N; ++i)
        A[i] = rng() % 10000000;
    solve(N);
    debug(queries);
    return 0;
}
#endif