#include <bits/stdc++.h>
#ifndef DEBUG
    #include "sqsort.h"
#endif

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; }
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; }
void debug_out() { cerr << endl; }
template<typename T1, typename... T2> void debug_out(T1 A, T2... B) { cerr << ' ' << A; debug_out(B...); }
#ifdef DEBUG
    #define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
    #define debug(...) 1337
#endif

const int maxN = 2003;
mt19937 rng(time(0));

#ifdef DEBUG
int A[maxN];
int queries;
bool cmp(int a, int b, int c, int d)
{
    ++queries;
    return A[a] + A[b] < A[c] + A[d];
}
#endif

int where[maxN];

vector<pii> solve(int n)
{
    vector<int> ord(n);
    iota(all(ord), 0);
    shuffle(all(ord), rng);
    sort(all(ord), [&](int i, int j) -> bool
    {
        return cmp(i, i, j, j);
    });
    for (int i = 0; i < n; ++i)
        where[ord[i]] = i;

    auto my_cmp = [&](pii A, pii B) -> bool
    {
        if (where[B.fi] <= where[A.fi] && where[B.se] <= where[A.se])
            return false;
        return cmp(A.fi, A.se, B.fi, B.se);
    };

    /*vector<pii> pq;

    auto Ins = [&](pii A)
    {
        int vl = -1;
        int vr = pq.size();
        while (vr - vl > 1)
        {
            int vm = (vl + vr) >> 1;
            pii B = pq[vm];
            if (where[A.fi] <= where[B.fi] && where[A.se] <= where[B.se] || my_cmp(A, B))
                vr = vm;
            else
                vl = vm;
        }
        pq.push_back({-1, -1});
        for (int i = (int)pq.size() - 2; i >= vr; --i)
            pq[i + 1] = pq[i];
        pq[vr] = A;
    };

    auto Get = [&]() -> pii
    {
        pii A = pq[0];
        for (int i = 1; i < pq.size(); ++i)
            pq[i - 1] = pq[i];
        pq.pop_back();
        return A;
    };

    vector<pii> V[n / 2 + 1];
    for (int l = 0; l < n; ++l)
    {
        for (int r = l; r < n; ++r)
        {
            V[l].emplace_back(ord[l], ord[r]);
        }
    }
    int ptr[n];
    memset(ptr, 0, sizeof ptr);
    for (int l = 0; l < n; ++l)
        Ins(V[l][0]);
    vector<pii> nans;
    while (!pq.empty())
    {
        pii A = Get();
        nans.pb(A);
        int l = where[A.fi];
        if (++ptr[l] < V[l].size())
            Ins(V[l][ptr[l]]);
    }
    return nans;/**/

    int sz = (n + 1) / 2;
    vector<int> rord(sz);
    iota(all(rord), 0);
    /*for (int i = 0; i < sz; ++i)
    {
        rord.pb(i);
        rord.pb(sz - i - 1);
    }
    if (sz & 1)
        rord.pb(sz / 2);/**/

    function< vector<pii>(int, int) > dfs = [&](int l, int r) -> vector<pii>
    {
        if (l == r)
        {
            int i = rord[l];
            vector<pii> ans;
            for (int j = i; j <= n - i - 1; ++j)
                ans.emplace_back(ord[i], ord[j]);
            for (int j = i + 1; j <= n - i - 1; ++j)
                ans.emplace_back(ord[j], ord[n - i - 1]);
            return ans;/**/

            /*vector<pii> ans(n - i);
            for (int k = 0; k < n - i; ++k)
                ans[k] = {ord[i], ord[i + k]};
            return ans;/**/
        }
        int mid = (l + r) >> 1;
        auto A = dfs(l, mid);
        auto B = dfs(mid + 1, r);
        vector<pii> ans;
        int i = 0, j = 0;
        while (i < A.size() && j < B.size())
        {
            if (where[A[i].fi] <= where[B[j].fi] && where[A[i].se] <= where[B[j].se] || my_cmp(A[i], B[j]))
                ans.push_back(A[i++]);
            else
                ans.push_back(B[j++]);
        }
        while (i < A.size())
            ans.push_back(A[i++]);
        while (j < B.size())
            ans.push_back(B[j++]);
        return ans;
    };
    return dfs(0, (int)rord.size() - 1);/**/

    /*vector<pii> ans;
    for (int i = 0; i < n; ++i)
        for (int j = i; j < n; ++j)
        {
            int u = ord[i];
            int v = ord[j];
            if (u > v) swap(u, v);
            ans.emplace_back(u, v);
        }
    sort(all(ans), [&](pii A, pii B) -> bool { return A.fi + A.se < B.fi + B.se; });
    sort(all(ans), my_cmp);
    return ans;/**/
}

#ifdef DEBUG
signed main()
{
    int N = 2000;
    for (int i = 0; i < N; ++i)
        A[i] = rng() % 10000000;
    solve(N);
    debug(queries);
    return 0;
}
#endif