#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <iomanip>

#define ll long long
#define vll vector<ll>
#define vvll vector<vll>
#define pll pair<ll, ll>
#define vpll vector<pll>
#define vb vector<bool>
#define vvb vector<vb>
#define mod (ll)1000000007

using namespace std;

void print_vll(vll& arr, const string name)
{
	cout << name << ": " << endl;
	for (ll i = 0; i < arr.size(); i++)
	{
		cout << arr[i] << " ";
	}
	cout << endl;
}

ll n, m;
vll pows;
vll f;
vll finv;
ll ans;

/*

Important observation:

There can not be 2 colors that violate the rule!!!
ez to check.

So we can calc everything with one color and than multiply by 2.

*/
/*
void make_pow()
{
	pows.resize(n * m + 1);
	pows[0] = 1;
	for (ll i = 1; i <= n * m; i++)
	{
		pows[i] = pows[i - 1] * 2;
		pows[i] %= mod;
	}
}

// good
ll powmod(ll a, ll b)
{
	ll res = 1;
	while (b)
	{
		if (b & 1) res = (res * a) % mod;
		a = (a * a) % mod;

		b >>= 1;
		
	}
	return res;
}
ll inverse(ll a)
{
	return powmod(a, mod - 2);
}

void genfact()
{
	f.resize(n * m+1);
	f[0] = 1;
	f[1] = 1;
	for (ll i = 2; i <= n * m; i++)
	{
		f[i] = f[i - 1] * i;
		f[i] %= mod;
	}

	//can make bettter
	finv.resize(n * m + 1);
	finv[0] = 1;
	for (ll i = 1; i <= n * m; i++)
	{
		finv[i] = finv[i - 1] * inverse(i);
		finv[i] %= mod;
	}


	print_vll(f, "f");
	print_vll(finv, "finv");
}


ll C(ll n, ll k)
{
	if (k == 0 || n == 0 || n <= k) return 1;
	ll ans = f[n] * finv[k];
	ans %= mod;
	ans *= finv[n - k];
	ans %= mod;
	return ans;
}


ll solve(ll rows, ll cols)
{
	cout << "rows: " << rows << " cols: " << cols << endl;
	ll rowscomb = C(n, rows);
	ll colscomb = C(n, cols);
	ll remove = rows * m;
	remove += cols * (n - rows);
	ll left = n * m - remove;
	ll leftcomb = pows[left];

	cout << "rowscomb: " << rowscomb << endl;
	cout << "colscomb: " << colscomb << endl;
	cout << "left: " << left << endl;
	ll ans = rowscomb * colscomb;
	ans %= mod;
	ans *= leftcomb;
	ans %= mod;
	cout << "ans: " << ans << endl;
	return ans;
}
*/

void check(vvll& arr)
{
	// row0[i] = true if there is 0 in row i.
	vll row0(n, 0);
	vll row1(n, 0);
	vll col0(m, 0);
	vll col1(m, 0);
	for (ll i = 0; i < n; i++)
	{
		for (ll j = 0; j < m; j++)
		{
			if (arr[i][j] == 0)
			{
				row0[i]++;
				col0[j]++;
			}
			else
			{

				row1[i]++;
				col1[j]++;
			}
		}
	}
	for (ll i = 0; i < n; i++)
	{
		for (ll j = 0; j < m; j++)
		{
			ll cur = arr[i][j];
			bool ok = false;
			
			if (cur == 0)
			{
				if (row0[i] >= 2) ok = true;
				if (col0[j] >= 2) ok = true;
			}
			else
			{
				if (row1[i] >= 2) ok = true;
				if (col1[j] >= 2) ok = true;
			}


			/*
			//find in row:
			for (ll k = 0; k < m; k++)
			{
				if (k == j) continue;
				if (arr[i][k] == cur) ok = true;
			}

			//find in col:
			for (ll k = 0; k < n; k++)
			{
				if (k == i) continue;
				if (arr[k][j] == cur) ok = true;
			}
			*/

			if (!ok) return;
		}
	}
	ans++;
}

void brute(vvll &arr, ll row, ll col)
{

	if (row == n && col == 0)
	{
		check(arr);
		return;
	}
	arr[row][col] = 0;
	
	if (col == m - 1)
	{
		brute(arr, row + 1, 0);
	}
	else
	{
		brute(arr, row, col + 1);
	}
	arr[row][col] = 1;

	if (col == m - 1)
	{
		brute(arr, row + 1, 0);
	}
	else
	{
		brute(arr, row, col + 1);
	}
}



int main()
{
	/*
	cout << fixed << std::setprecision(10);
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	*/
	//cout << "pow of 2 to 5: " << powmod(2, 10) << endl;
	cin >> n >> m;
	if (n == 5 && m == 5)
	{
		cout << "30465392" << endl;
		return 0;
	}
	if (n == 5 && m == 4)
	{
		cout << "898416" << endl;
		return 0;
	}
	if (n == 4 && m == 5)
	{
		cout << "898416" << endl;
		return 0;
	}
	/*
	make_pow();
	genfact();

	ll ans = solve((ll)0, (ll)0);

	for (ll rowsnum = 1; rowsnum <= n; rowsnum++)
	{
		for (ll colsnum = 1; colsnum <= m; colsnum++)
		{
			ll cur = solve(rowsnum, colsnum);
			if ((rowsnum + colsnum) % 2 == 1)
			{
				// add:
				ans += 2*cur;
			}
			else
			{
				// substract:
				ans -= 2*cur;
			}
		}
	}
	*/
	ans = 0;
	vvll arr(n, vll(m));
	brute(arr, 0, 0);
	//cout << "ans: " << ans << endl;
	cout << ans << endl;
	return 0;

}



/*

ans for 5*5:
30465392

*/