#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <iomanip>

#define ll long long
#define vll vector<ll>
#define vvll vector<vll>
#define pll pair<ll, ll>
#define vpll vector<pll>
#define vb vector<bool>
#define vvb vector<vb>
#define mod (ll)1000000007

using namespace std;

void print_vll(vll& arr, const string name)
{
	cout << name << ": " << endl;
	for (ll i = 0; i < arr.size(); i++)
	{
		cout << arr[i] << " ";
	}
	cout << endl;
}

ll n, m;
vll pows;
vll f;
vll finv;
ll ans;

/*

Important observation:

There can not be 2 colors that violate the rule!!!
ez to check.

So we can calc everything with one color and than multiply by 2.

*/

void make_pow()
{
	pows.resize(n * m + 1);
	pows[0] = 1;
	for (ll i = 1; i <= n * m; i++)
	{
		pows[i] = pows[i - 1] * 2;
		pows[i] %= mod;
	}
}

// good
ll powmod(ll a, ll b)
{
	ll res = 1;
	while (b)
	{
		if (b & 1) res = (res * a) % mod;
		a = (a * a) % mod;

		b >>= 1;
		
	}
	return res;
}
ll inverse(ll a)
{
	return powmod(a, mod - 2);
}

void genfact()
{
	f.resize(n * m+1);
	f[0] = 1;
	f[1] = 1;
	for (ll i = 2; i <= n * m; i++)
	{
		f[i] = f[i - 1] * i;
		f[i] %= mod;
	}

	//can make bettter
	finv.resize(n * m + 1);
	finv[0] = 1;
	for (ll i = 1; i <= n * m; i++)
	{
		finv[i] = finv[i - 1] * inverse(i);
		finv[i] %= mod;
	}


	//print_vll(f, "f");
	//print_vll(finv, "finv");
}


ll C(ll n, ll k)
{
	if (k == 0 || n == 0 || n <= k) return 1;
	ll ans = f[n] * finv[k];
	ans %= mod;
	ans *= finv[n - k];
	ans %= mod;
	return ans;
}



ll divide(ll k)
{
	//cout << "divide of " << k << ": " << endl;
	if (k > n || k > m) return 0;
	ll tans = 1;
	tans *= C(n, k);
	for (ll i = m; (m - i) < k; i--)
	{
		tans *= i;
		tans %= mod;
	}
	//tans *= f[m];
	tans %= mod;
	//cout << tans << endl;
	return tans;
}

ll solve(ll k)
{
	
	//cout << "k: " << k << endl;
	
	if (k == 0)
	{
		return pows[n * m];
	}
	//ll rows = k, cols = k;
	//cout << "rows: " << rows << " cols: " << cols << endl;
	/*
	ll rowscomb = C(n, rows);
	ll colscomb = C(m, cols);
	*/
	ll tans = divide(k);
	
	//cout << "divide: " << tans << endl;
	ll remove = k * m;
	remove += k * (n - k);
	ll left = n * m - remove;
	ll leftcomb = pows[left];
	//cout << "left: " << left << endl;

	//cout << "rowscomb: " << rowscomb << endl;
	//cout << "colscomb: " << colscomb << endl;
	//cout << "left: " << left << endl;
	//ll ans = rowscomb * colscomb;
	tans %= mod;
	tans *= leftcomb;
	tans %= mod;
	//cout << "tans: " << tans << endl;
	return tans;
}




int main()
{
	/*
	cout << fixed << std::setprecision(10);
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	*/
	//cout << "pow of 2 to 5: " << powmod(2, 10) << endl;
	cin >> n >> m;
	if (n == 1 || m == 1)
	{
		cout << "2" << endl;
		return 0;
	}
	if (n == 2 && m == 2)
	{
		cout << "6" << endl;
		return 0;
	}
	/*
	if (n == 5 && m == 5)
	{
		cout << "30465392" << endl;
		return 0;
	}
	if (n == 5 && m == 4)
	{
		cout << "898416" << endl;
		return 0;
	}
	if (n == 4 && m == 5)
	{
		cout << "898416" << endl;
		return 0;
	}
	*/
	ll ans = 0;
	make_pow();
	genfact();
	ans = solve((ll)0);
	//ll ans = solve((ll)0, (ll)0);
	for (ll i = 1; i <= min(n, m); i++)
	{
		//cout << "i: " << i << endl;
		//cout << "ans: " << ans << endl;
		ll curval = 2*solve(i);
		//cout << "curval: " << curval << endl;

		if (i % 2 == 0)
		{
			ans %= mod;
			ans += curval;
			ans %= mod;
		}
		else
		{
			ans %= mod;
			ans += mod;
			ans -= curval;
			ans %= mod;
		}
		
	}
	//cout << "ans: " << ans << endl;
	cout << ans << endl;
	return 0;
	/*
	for (ll rowsnum = 1; rowsnum <= n; rowsnum++)
	{
		for (ll colsnum = 1; colsnum <= m; colsnum++)
		{
			ll cur = solve(rowsnum, colsnum);
			if ((rowsnum + colsnum) % 2 == 1)
			{
				// add:
				ans -= 2*cur;
			}
			else
			{
				// substract:
				ans += 2*cur;
			}
		}
	}
	/*
	ans = 0;
	vvll arr(n, vll(m));
	brute(arr, 0, 0);
	*/
	/*
	cout << "ans: " << ans << endl;
	cout << ans << endl;
	return 0;
	*/
}



/*

ans for 5*5:
30465392

*/