#undef MANSON
#include <iostream>
#include <random>
#include <chrono>
using namespace std;
using llong = long long;
#ifdef MANSON
#define BUGO(x) cerr << #x << " = " << (x) << '\n';
#define BUGOARR(a) {cerr << #a << ": "; for (auto i: a) cerr << i << ' '; cerr << '\n';}
ostream& operator<<(ostream& out, const pair<auto, auto>& p) {
	return out << "{" << p.first << ", " << p.second << "}";
}
#else
#define BUGO(x) {}
#define BUGOARR(x) {}
#endif
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline int rnd(int l, int r) { return uniform_int_distribution<int>(l, r)(rng); }
const int mod = 1000'000'007;
const int maxN = 55;
const int maxM = 55;
int pw2[maxN * maxM], fact[maxN * maxM], C[maxN * maxM][maxN * maxM];

inline void Mod(int& x) { if (x >= mod) x -= mod; }
inline int Mult(llong a, llong b) {
    return (a * b) % mod;
}
inline int Mult(llong a, llong b, llong c) {
    a *= b;
    a %= mod;
    a *= c;
    return a %= mod;
}
inline int Mult(llong a, llong b, llong c, llong d) {
    a *= b;
    a %= mod;
    a *= c;
    a %= mod;
    a *= d;
    return a %= mod;
}

int Brutos(int n, int m)
{
    int b[maxN][maxM], dp[maxN][maxM];
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            dp[i][j] = 0;
    int ans = 0;
    for (int mask = 0; mask < (1 << (n * m)); ++mask)
    {
        for (int i = 0; i < n; ++i)
            for (int j = 0; j < m; ++j)
                b[i][j] = bool(mask & (1 << (i * m + j)));
        bool ok = true;
        for (int j = 0; ok && j < m; ++j)
            for (int i = 0; ok && i < n; ++i)
            {
                bool curok = false;
                for (int x = 0; !curok && x < n; ++x)
                    if (x != i && b[x][j] == b[i][j])
                        curok = true;
                for (int x = 0; !curok && x < m; ++x)
                    if (x != j && b[i][x] == b[i][j])
                        curok = true;
                if (!curok) {
                    ++dp[i][j];
                    ok = false;
                }
            }
        ans += ok;
    }
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            cerr << "brut[" << i << "][" << j << "] = " << dp[i][j] / 2 << '\n';
    return ans;
}

int dp[maxN][maxM];
int SmallN(int n, int m)
{
    if (n == 1)
    {
        if (m == 1) return 0;
        if (m == 2) return 2;
        return (pw2[m] - 2 * m + mod) % mod;
    }
    else if (n == 2)
    {
        if (m == 2)
            return 6;
        int ans = 0;
        for (int x = 0, o = m; x <= m; ++x, --o)
            for (int X = 0, O = m; X <= m; ++X, --O)
            {
                if (x == 1 || o == 1 || X == 1 || O == 1)
                {
                    if ((x == 1 || o == 1) && (X == 1 || O == 1))
                    {
                        if (x == 1 && O == 1)
                            ans += m, Mod(ans);
                        else if (o == 1 && X == 1)
                            ans += m, Mod(ans);
                        else
                            ans += m * (m - 1), Mod(ans);
                    }
                    else
                    {
                        if (x == 1)
                            ans += Mult(m, C[m - 1][X]), Mod(ans);
                        else if (X == 1)
                            ans += Mult(m, C[m - 1][x]), Mod(ans);
                        else if (o == 1)
                            ans += Mult(m, C[m - 1][O]), Mod(ans);
                        else if (O == 1)
                            ans += Mult(m, C[m - 1][o]), Mod(ans);
                        else
                            throw;
                    }
                }
                else {
                    ans += Mult(C[m][x], C[m][X]);
                    Mod(ans);
                }
            }
        return ans;
    }
    throw;
}
int binpow(llong a, int p)
{
    if (p == 0) return 1;
    if (p % 2) return (a * binpow(a, p - 1)) % mod;
    return binpow((a * a) % mod, p / 2);
}
int Solve(int n, int m);
int Magic(int n, int m)
{
    if (n > m) swap(n, m);
    if (n == 0)
        return 1;
    if (n == 1) {
        if (m == 1)
            return 1;
        else if (m == 2)
            return 2;
        return (pw2[m] - m + mod) % mod;
    }
    int raw = Solve(n, m);
    int total = pw2[n * m];
    int magic = raw + Mult(total - raw + mod, binpow(2, mod - 2));
    if (n == 2 && m == 2)
        BUGO(raw)
    if (n == 2 && m == 2)
        BUGO(magic)
    if (n == 2)
    { // magic -= yndhanur
        if (m == 2)
        {
            magic -= 1;
            magic += mod;
            Mod(magic);
        }
        else {
            magic -= m;
            magic += mod;
            Mod(magic);
        }
        if (n == 2 && m == 2)
            BUGO(magic)
    }
    return magic;
}
int Solve(int n, int m)
{
    if (n > m) swap(n, m);
    if (!n) return 1;
    if (dp[n][m] != -1)
        return dp[n][m];
    if (n <= 2)
        return dp[n][m] = SmallN(n, m);
    dp[n][m] = 0;
    for (int x = 0; x < n; ++x)
        for (int y = 0; y < m; ++y)
        {
            int totcur = 0;
            for (int menak = 0; menak <= min(n - 1, y); ++menak)
            {
                if (x == 0 && y == 2 && 0)
                    BUGO(menak)
                int cur = Mult(C[n - 1][menak], C[y][menak], fact[menak]);
                if (x == 0 && y == 2 && 0)
                    BUGO(cur);
                cur = Mult(cur, Magic(n - 1 - menak, y - menak)/*, pw2[(n - 1 - menak) * (y - menak)]*/);
                if (x == 0 && y == 2 && menak == 0) {
                    BUGO(cur);
                }
                cur = Mult(cur, pw2[(m - y - 1) * (n - 1 - menak)],
                           binpow((pw2[m - y - 1] - 1 + mod) % mod, menak));
                            //menak/*n - 1 - y*/, (pw2[m - y - 1] - 1 + mod) % mod);
                if (x == 0 && y == 2 && 0)
                    BUGO(cur);
                dp[n][m] -= cur;
                totcur += cur;
                dp[n][m] += mod;
                Mod(dp[n][m]);
            }
           // cerr << x << ", " << y << ": " << totcur << '\n';
        }
    dp[n][m] *= 2;
    Mod(dp[n][m]);
    dp[n][m] += pw2[n * m];
    Mod(dp[n][m]);
    return dp[n][m];
}
int main()
{
    for (int i = 0; i < maxN; ++i)
        for (int j = 0; j < maxM; ++j)
            dp[i][j] = -1;
    pw2[0] = 1; fact[0] = 1;
    C[0][0] = 1;
    for (int i = 1; i < maxN * maxM; ++i) {
        pw2[i] = pw2[i - 1] + pw2[i - 1];
        Mod(pw2[i]);
        fact[i] = ((llong)fact[i - 1] * i) % mod;

        C[i][0] = C[i][i] = 1;
        for (int j = 1; j < i; ++j) {
            C[i][j] = C[i - 1][j - 1] + C[i - 1][j];
            Mod(C[i][j]);
        }
    }
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
    cout << Solve(n, m);
    // cout << '\n' << Brutos(n, m) << " - Brutos\n";
}
