#include <algorithm>
#include <iostream>
#include <vector>
#include <random>
#include <chrono>
#include "sqsort.h"
using namespace std;
using llong = long long;
#ifdef MANSON
#define BUGO(x) cerr << #x << " = " << (x) << '\n';
#define BUGOARR(a) {cerr << #a << ": "; for (auto i: a) cerr << i << ' '; cerr << '\n';}
ostream& operator<<(ostream& out, const pair<auto, auto>& p) {
	return out << "{" << p.first << ", " << p.second << "}";
}
#else
#define BUGO(x)
#define BUGOARR(x)
#endif
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline int rnd(int l, int r) { return uniform_int_distribution<int>(l, r)(rng); }

std::vector<std::pair<int, int>> solve(int n)
{
    vector<pair<int, int>> ans; ans.reserve(n * (n - 1) / 2);
    for (int i = 0; i < n; ++i)
        for (int j = i; j < n; ++j)
            ans.push_back({i, j});
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        a[i] = i;
    sort(a.begin(), a.end(), [](int i, int j) {
         return cmp(1, i, 1, j);
    });
    auto b = a;
    for (int i = 0; i < n; ++i)
        a[b[i]] = i;
    sort(ans.begin(), ans.end(), [&a](const pair<int, int>& l, const pair<int, int>& r) {
         if (l == r) return false;
         if (max(a[l.first], a[l.second]) <= min(a[r.first], a[r.second]))
            return true;
         if (max(a[r.first], a[r.second]) <= min(a[l.first], a[l.second]))
            return false;
        return cmp(l.first, l.second, r.first, r.second);
    });
    return ans;
}
