#include <algorithm>
#include <iostream>
#include <vector>
#include <random>
#include <chrono>
#include <queue>
#include "sqsort.h"
using namespace std;
using llong = long long;
#ifdef MANSON
#define BUGO(x) cerr << #x << " = " << (x) << '\n';
#define BUGOARR(a) {cerr << #a << ": "; for (auto i: a) cerr << i << ' '; cerr << '\n';}
ostream& operator<<(ostream& out, const pair<auto, auto>& p) {
	return out << "{" << p.first << ", " << p.second << "}";
}
#else
#define BUGO(x)
#define BUGOARR(x)
#endif
#ifdef MANSON
mt19937 rng(824723);
#else
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
#endif
inline int rnd(int l, int r) { return uniform_int_distribution<int>(l, r)(rng); }

    // int gorc = 0;
std::vector<std::pair<int, int>> solve(int n)
{
    vector<pair<int, int>> ans(n * (n + 1) / 2);
    /*for (int i = 0; i < n; ++i)
        for (int j = i; j < n; ++j)
            ans.push_back({i, j});*/
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        a[i] = i;
    sort(a.begin(), a.end(), [/*&gorc*/](int i, int j) {
         // ++gorc;
         return cmp(1, i, 1, j);
    });
    auto b = a;
    for (int i = 0; i < n; ++i)
        a[b[i]] = i;
    /*shuffle(ans.begin(), ans.end(), rng);
    sort(ans.begin(), ans.end(), [&a](const pair<int, int>& l, const pair<int, int>& r) {
         if (l == r) return false;
         if (a[l.first] <= a[r.first] && a[l.second] <= a[r.second])
            return true;
         if (a[r.first] <= a[l.first] && a[r.second] <= a[l.second])
            return false;
        return cmp(l.first, l.second, r.first, r.second);
    });*/
    /*auto Comp = [&a](const pair<int, int>& l, const pair<int, int>& r){
        // if (l == r) return -1;
        if (a[l.first] <= a[r.first] && a[l.second] <= a[r.second])
            return 1;
        // if (a[r.first] <= a[l.first] && a[r.second] <= a[l.second])
            // return -1;
        return 0;
    };*/
    vector<int> inds(n);
    for (int i = 0; i < n; ++i) inds[i] = i;
    sort(inds.begin(), inds.end(), [&a](int l, int r) {
         return a[l] < a[r];
    });
    vector<int> best(n);
    for (int i = 0; i < n; ++i)
        best[inds[i]] = i;
    struct QComp {
        bool operator()(const pair<int, int>& l, const pair<int, int>& r) const {
            // ++gorc;
            return cmp(r.first, r.second, l.first, l.second);
        }
    };
    priority_queue<pair<int, int>, vector<pair<int, int>>, QComp> q;
    vector<int> isin(n);
    for (int x = 0; x < n * (n + 1) / 2; ++x)
    {
        // int poss = 0;
        int previ = -1;
        // int besti = -1;
        for (int i: inds)
        {
            if (best[i] == n) continue;
            if (previ == -1 || a[inds[best[i]]] < a[inds[best[previ]]]) {
                previ = i;
                if (!isin[i]) {
                    q.push({i, inds[best[i]]});
                    isin[i] = true;
                }
                // if (besti == -1 || cmp(i, inds[best[i]], besti, inds[best[besti]]))
                    // besti = i;
           //     ++poss;
            }
        }
        /*int poss1 = 0;
        for (int i = 0; i < n; ++i)
        {
            if (best[i] == n) continue;
            bool may = true;
            for (int j = 0; j < n; ++j)
                if (best[j] < n && Comp({j, best[j]}, {i, best[i]}) == 1) {
                    may = false;
                    break;
                }
            poss1 += may;
        }*/
        // cout << log(poss) / log(2) << ' ';
        // gorc += (log(poss)/log(2) + 1);//poss - 1;
        // BUGO(q.size())
        pair<int, int> p = q.top(); q.pop();
        isin[p.first] = false;
        // pair<int, int> p = {besti, inds[best[besti]]};
        ++best[p.first];
        ans[x] = p;
    }
    // BUGOARR(ans)
    // cout << pow((2. * n * n + 1.) / (gorc + 1.), 1.25) * 100. << '\n';
    return ans;
}
