#include<vector>
#include<algorithm>
#include<unordered_map>
#include<map>
#include "sqsort.h"

bool cmp(int a_, int b, int c, int d);

int comp_pair(std::pair<int, int> a, std::pair<int, int> b, std::unordered_map<int, int>& check) {
	if (check[a.first] < check[b.first] && check[a.second] <= check[b.second] || check[a.first] < check[b.second] && check[a.second] <= check[b.first])
		return 1;
	if (check[a.first] <= check[b.first] && check[a.second] < check[b.second] || check[a.first] <= check[b.second] && check[a.second] < check[b.first])
		return 1;
	if (check[a.first] >= check[b.first] && check[a.second] >= check[b.second] || check[a.first] >= check[b.second] && check[a.second] >= check[b.first])
		return 2;
	return 0;
}

std::vector<std::pair<int, int>> solve(int n) {
	std::vector<std::pair<int, int>> ans;
	ans.reserve(n * (n + 1) / 2);
	for (int i = 0; i < n; ++i)
		for (int j = i; j < n; ++j)
			ans.emplace_back(i, j);
	std::vector<int> sorted(n);
	for (int i = 0; i < n; ++i)
		sorted[i] = i;
	sort(sorted.begin(), sorted.end(), [](int a, int b) {return cmp(0, a, 0, b); });
	std::unordered_map<int, int> check;
	for (int i = 0; i < n; ++i)
		check[sorted[i]] = i;
	std::map<std::pair<int, int>, std::pair<int, int>> minn;
	sort(ans.begin(), ans.end(), [&minn, &check](std::pair<int, int> first, std::pair<int, int> second) {
		if (minn.find(first) != minn.end() && comp_pair(minn[first], second, check) == 1)
			return true;
		if (minn.find(second) != minn.end() && comp_pair(minn[second], first, check) == 1)
			return false;
		bool res = cmp(first.first, first.second, second.first, second.second);
		if (res && minn.find(first) == minn.end())
			minn[first] = second;
		else if (res && comp_pair(second, minn[first], check) == 1)
			minn[first] = second;
		else if (!res && minn.find(second) == minn.end())
			minn[second] = first;
		else if (!res && comp_pair(first, minn[second], check) == 1)
			minn[second] = first;
		return res;
		}
	);
	return ans;
}