#include "sqsort.h"

using namespace std;

vector<pair<int, int>> qs;

void merge_sort(int l, int r) {
    if (l == r)
        return;
    int md = (l + r) / 2;
    merge_sort(l, md);
    merge_sort(md + 1, r);
    int l1 = l;
    int r1 = md + 1;
    vector<pair<int, int>> q1;
    while (l1 <= md && r1 <= r) {
        if (l1 > md) {
            q1.push_back(qs[r1]);
            ++r1;
        } else if (r1 > r) {
            q1.push_back(qs[l1]);
            ++l1;
        } else {
            if (cmp(qs[l1].first, qs[l1].second, qs[r1].first, qs[r1].second)) {
                q1.push_back(qs[l1]);
                ++l1;
            } else {
                q1.push_back(qs[r1]);
                ++r1;
            }
        }
    }
    for (int i = l; i <= r; ++i) {
        qs[i] = q1[i - l];
    }
}

vector<pair<int, int>> solve(int n) {
    int per = n * (n + 1) / 2;
    int last = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            qs.push_back({i, j});
            ++last;
        }
    }
    merge_sort(0, last - 1);
    return qs;
}