#include "sqsort.h"
#include <map>

using namespace std;

void merge_sort(int l, int r, vector<int> &qs1) {
    if (l == r)
        return;
    int md = (l + r) / 2;
    merge_sort(l, md, qs1);
    merge_sort(md + 1, r, qs1);
    int l1 = l;
    int r1 = md + 1;
    vector<int> q1 (r - l + 1);
    int last = 0;
    while (l1 <= md || r1 <= r) {
        if (l1 > md) {
            q1[last] = qs1[r1];
            ++r1;
        } else if (r1 > r) {
            q1[last] = qs1[l1];
            ++l1;
        } else {

            if (cmp(0, qs1[l1], 0, qs1[r1])) {
                q1[last] = qs1[l1];
                ++l1;
            } else {
                q1[last] = qs1[r1];
                ++r1;
            }
        }
        ++last;
    }
    for (int i = l; i <= r; ++i) {
        qs1[i] = q1[i - l];
    }
}

vector<pair<int, int>> solve(int n) {
    vector<int> qs1;
    for (int i = 0; i < n; ++i) {
        qs1.push_back(i);
    }
    merge_sort(0, qs1.size() - 1, qs1);
    map<int, int> mp;
    for (int i = 0; i < n; ++i) {
        mp[i] = qs1[i];
    }
    vector<pair<int, int>> qs2 ((n * (n + 1) / 2));
    int last = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            qs2[last] = {qs1[i], qs1[j]};
            ++last;
        }
    }
    for (int n1 = qs2.size() - 4; n1 >= 0; --n1) {
        int n2 = n1;
        while (true) {
            int l1 = qs2[n2].first;
            int l2 = qs2[n2].second;
            int r1 = qs2[n2 + 1].first;
            int r2 = qs2[n2 + 1].second;
            if ((l1 <= r1 && l2 <= r2) || !cmp(mp[r1], mp[r2], mp[l1], mp[l2])) break;
            swap(qs2[n2], qs2[n2 + 1]);
            ++n2;
        }
    }
    for (int i = 0; i < qs2.size(); ++i) {
        qs2[i] = {mp[qs2[i].first], mp[qs2[i].second]};
    }
    return qs2;
}