#include <vector>
#include <iostream>
#include <queue>
#include <set>
#include <algorithm>
#include "sqsort.h"

using namespace std;

vector<int> s;

struct 
{
    bool operator()(int x, int b) const
    {   
        return cmp(x,x,b,b);
    }   
}comp;

vector<pair<int,int>> solve(int n)
{
    s = vector<int>(n);
    for(int i=0; i<n; i++)
        s[i] = i;
    
    sort(s.begin(), s.end(), comp);
    
    auto comp2 = [](pair<int,int> x, pair<int,int> b) {return !cmp(s[x.first], s[x.second], s[b.first], s[b.second]);};
    priority_queue<pair<int,int>, vector<pair<int,int>>, decltype(comp2)> q(comp2);

    set<pair<int,int>> d;
    vector<pair<int,int>> res;


    q.push(make_pair(0, 0));
    while(!q.empty())
    {
        
        auto p = q.top();
//        cout<<p.first<<" "<<p.second<<endl;
        q.pop();
        if(p.first <= p.second && d.find(p) == d.end())
        {
            d.insert(p);
            res.push_back(make_pair(s[p.first], s[p.second]));
            if(p.first < n-1)
                q.push(make_pair(p.first + 1, p.second));
            if(p.second < n-1)
                q.push(make_pair(p.first, p.second+1));
        }
    }
    return res;
}