#include <vector>
#include <iostream>
#include <queue>
#include <set>
#include <algorithm>
#include "sqsort.h"

using namespace std;

vector<int> s;

struct 
{
    bool operator()(int x, int b) const
    {   
        return cmp(x,x,b,b);
    }   
}comp;

vector<pair<int,int>> solve(int n)
{
    s = vector<int>(n);
    for(int i=0; i<n; i++)
        s[i] = i;
    
    sort(s.begin(), s.end(), comp);
    
    auto comp2 = [](pair<int,int> x, pair<int,int> b) {return !cmp(s[x.first], s[x.second], s[b.first], s[b.second]);};
    priority_queue<pair<int,int>, vector<pair<int,int>>, decltype(comp2)> q(comp2);

    set<pair<int,int>> d;
    vector<pair<int,int>> res;
    vector<vector<bool>> vis(n, vector<bool>(n,false));

    q.push(make_pair(0, 0));
    while(!q.empty())
    {
        
        int i = q.top().first, j = q.top().second;
//        cout<<p.first<<" "<<p.second<<endl;
        q.pop();
        res.push_back(make_pair(s[i],s[j]));
        
        vis[i][j] = true; vis[j][i] = true;
        if(j < n-1 && (i == 0 || vis[i-1][j+1]))
            q.push(make_pair(i, j+1));
        if(i < n-1 && i != j && vis[i+1][j-1])
            q.push(make_pair(i+1, j));
        
    }
/*    for(auto p:res)
        cout<<p.first<<","<<p.second<<" ";
    cout<<endl;*/
    return res;
}