#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>

#define endl '\n'
#define mp make_pair
#define pb push_back
#define sqr(x) ((x) * (x))
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vii;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;

int rec(int i, vc& p, vi& t, vi& w, int n, int k) {
	if (i == n) {
		int ans = 0;
		int r = 0;
		vc used(n);
		for (int j = 0; j < n; ++j) {
			if (p[j]) {
				if (!used[t[j]] && !p[t[j]]) {
					used[t[j]] = 1;
					ans += w[j];
					used[j] = 1;
				}
			}
		}
		for (int j = 0; j < n; ++j) {
			if (p[j] && !used[j]) {
				int cnt = 0;
				while (r < n && cnt < k) {
					if (used[r] || p[r]) {
						++r;
						continue;
					}
					used[r] = 1;
					++cnt;
					++r;
				}
				if (cnt == k)
					ans += w[j];
			}
		}
		vi v;
		for (int j = 0; j < n; ++j) {
			if (!p[j] && !used[j])
				v.push_back(w[j]);
		}
		sort(v.rbegin(), v.rend());
		for (int j = 0; j < (int)v.size() / (2 * k); ++j)
			ans += v[j];
		return ans;
	}
	int ans = rec(i + 1, p, t, w, n, k);
	p[i] = 1;
	ans = max(ans, rec(i + 1, p, t, w, n, k));
	p[i] = 0;
	return ans;
}

int solve(int n, int k, vi& p, vi& w, int x) {
	vvi dp(n + 1, vi(2 * n + 1, -INF));
	dp[0][x + n] = 0;
	for (int i = 1; i <= n; ++i) {
		for (int j = -n; j <= n; ++j) {
			int maxx = max(dp[i - 1][min(j + k, n) + n], dp[i - 1][min(j + 2 * k - 1, n) + n]);
			if (i != 1)
				maxx = max(maxx, max(dp[i - 2][j + n], w[p[i - 2]] + dp[i - 2][min(j + 2 * k, n) + n]));
			dp[i][j + n] = w[p[i - 1]] + maxx;
			dp[i][j + n] = max(dp[i][j + n], dp[i - 1][max(j - 1, -n) + n]);
		}
	}
	int maxx = 0;
	for (int i = 0; i <= n; ++i)
		maxx = max(maxx, dp[n][i + n]);
	return maxx;
}

signed main() {
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, k;
	cin >> n >> k;
	vi t(n), w(n);
	for (int i = 0; i < n; ++i)
		cin >> t[i] >> w[i];
	if (n <= 10) {
		vc p(n);
		cout << rec(0, p, t, w, n, k);
	}
	else {
		vi p(n);
		for (int i = 0; i < n - 1; ++i)
			p[i + 1] = t[p[i]];
		int x = w[p[n - 1]], y = w[p[0]];
		reverse(p.begin(), p.end());
		int ans = solve(n, k, p, w, 0);
		p.erase(p.begin());
		p.pop_back();
		n -= 2;
		ans = max(ans, solve(n, k, p, w, 0) + x);
		ans = max(ans, solve(n, k, p, w, -2 * k) + x + y);
		cout << ans;
	}

	return 0;
}