#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>
#include <bits/stdc++.h>
#include "sqsort.h"
#define fs first
#define sc second
using namespace std;

//static const int HARD_LIMIT = 50000000;
//
//static int n;
//static std::vector<int> a;
//
//static bool valid_pos(int i) {
//	return 0 <= i && i < n;
//}
//
//static int Q;
//bool cmp(int a_, int b, int c, int d) {
//	if(!valid_pos(a_) || !valid_pos(b) || !valid_pos(c) || !valid_pos(d)) {
//		std::cerr << "Invalid query." << std::endl;
//		std::cout << -1 << std::endl;
//		exit(0);
//	}
//
//	Q++;
//	if(Q > HARD_LIMIT) {
//		std::cerr << "Too many queries." << std::endl;
//		std::cout << -1 << std::endl;
//		exit(0);
//	}
//
//	return a[a_] + a[b] < a[c] + a[d];
//}
//
//static bool check_valid(const std::vector<std::pair<int, int>> &a) {
//	if(n * (n + 1) / 2 != (int)a.size()) {
//		return false;
//	}
//
//	std::vector<std::vector<bool>> used(n, std::vector<bool>(n, false));
//	for(int i = 0; i < (int)a.size(); i++) {
//		if(!valid_pos(a[i].first) || !valid_pos(a[i].second) || used[a[i].first][a[i].second]) {
//			return false;
//		}
//
//		used[a[i].first][a[i].second] = true;
//		used[a[i].second][a[i].first] = true;
//	}
//
//	return true;
//}

int AR[4000];


vector<int> merge_sort1(vector<int> a, int n){

    if(n <= 1) return a;

    vector<int> b1(n/2);
    vector<int> b2(n-n/2);
    for(int i = 0; i < n; i++){
        if(i < n/2){
            b1[i] = a[i];
        }
        else{
            b2[i-n/2] = a[i];
        }
    }
    b1 = merge_sort1(b1, n/2);
    b2 = merge_sort1(b2, n-n/2);

    if(b1.size() == 0)
        return b2;

    int i1 = 0, i2 = 0;



    for(int i = 0; i < n; i++){
        if(i1 == n/2){
            a[i] = b2[i2]; i2++;
            continue;
        }
        if(i2 == n-n/2){
            a[i] = b1[i1]; i1++;
            continue;
        }
        bool z = cmp(b1[i1], b1[i1], b2[i2], b1[i1]);
        if(z){
            a[i] = b1[i1]; i1++;
        }
        else{
            a[i] = b2[i2]; i2++;
        }
    }
    return a;
}



vector<pair<int, int>> merge_sort(vector<pair<int, int>> a, int n){

    if(n <= 1) return a;

    vector<pair<int, int>> b1(n/2);
    vector<pair<int, int>> b2(n-n/2);
    for(int i = 0; i < n; i++){
        if(i < n/2){
            b1[i] = a[i];
        }
        else{
            b2[i-n/2] = a[i];
        }
    }
    b1 = merge_sort(b1, n/2);
    b2 = merge_sort(b2, n-n/2);

    if(b1.size() == 0)
        return b2;

    int i1 = 0, i2 = 0;



    for(int i = 0; i < n; i++){
        if(i1 == n/2){
            a[i] = b2[i2]; i2++;
            continue;
        }
        if(i2 == n-n/2){
            a[i] = b1[i1]; i1++;
            continue;
        }

        int x1 = AR[b1[i1].fs];
        int x2 = AR[b1[i1].sc];
        int x3 = AR[b2[i2].fs];
        int x4 = AR[b2[i2].sc];
        if(max(x1, x2) <= min(x3, x4)){
            a[i] = b1[i1]; i1++;
            continue;
        }
        if(min(x1, x2) >= max(x3, x4)){
            a[i] = b2[i2]; i2++;
            continue;
        }

        bool z = 0;

        if(x1 == x3){
            z = x4 > x2;
        }
        else{
            if(x3 + x4 - x1 - x2 >= n/2)
                z = 1;
            else
                if(x1 + x2 - x3 - x4 >= n/3*2)
                    z = 0;
                else
                    z = cmp(b1[i1].fs, b1[i1].sc, b2[i2].fs, b2[i2].sc);
        }
        if(z){
            a[i] = b1[i1]; i1++;
        }
        else{
            a[i] = b2[i2]; i2++;
        }
    }
    return a;
}

vector<pair<int, int>> solve(int n){
    vector<pair<int, int> > a;

    vector<int> b(n);


    for(int i = 0; i < n; i++){
        b[i] = i;
    }

    b = merge_sort1(b, n);


    for(int i = 0; i < n; i++){
        AR[b[i]] = i;
    }

    for(int i = 0; i < n; i++){
        for(int j = i; j < n; j++){
            a.push_back({b[i], b[j]});
        }
    }


    a = merge_sort(a, a.size());
    return a;
}
//
//int main() {
//	cin >> n;
//	a.resize(n);
//	for(int i = 0; i < n; i++) {
//		a[i] = 3 * i % n;
//	}
//
//	Q = 0;
//
//	std::vector<std::pair<int, int>> ret = solve(n);
//
//	if(!check_valid(ret)) {
//		std::cerr << "Invalid output." << std::endl;
//		std::cout << -1 << std::endl;
//		return 0;
//	}
//
//	for(int i = 1; i < (int) ret.size(); i++) {
//		if(a[ret[i].first] + a[ret[i].second] < a[ret[i - 1].first] + a[ret[i - 1].second]) {
//			std::cerr << "Output not sorted." << std::endl;
//			std::cout << -1 << std::endl;
//			return 0;
//		}
//	}
//
//	std::cerr << "Correct!" << std::endl;
//	std::cout << Q << std::endl;
//	return 0;
//}
