#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>

using namespace std;

#define int long long
#define all(v) (v).begin(),(v).end()

#define mod 1000000007LL

int mul(int a, int b) {
    return a * b % mod;
}

int add(int a, int b) {
    int res = a + b;
    if (res < 0) {
        res += mod;
    }
    if (res >= mod) {
        res -= mod;
    }
    return res;
}

int fapow(int a, int x) {
    if (x == 0) {
        return 1;
    }
    if (x % 2 == 0) {
        int res = fapow(a, x / 2);
        return mul(res, res);
    }
    return mul(a, fapow(a, x - 1));
}

int fpw(int x) {
    return fapow(2, x);
}


int ans = 1;
int n, m;
int ind = 0;

int iterate() {
    ans = mul(ans, (n * m - n * ind - m * ind + ind * ind) % mod);
    ans = mul(ans, fapow(ind + 1, mod - 2));
    ind++;
    return ans;

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    if (n > m) {
        swap(n, m);
    }
    if (n == 1 && m == 1) {
        cout << 0;
    } else if (n == 1 && m == 2) {
        cout << 2;
    } else if (n == 2 && m == 2) {
        cout << 6;
    } else if (n == 2) {
        int res = fpw(n * m);
        {
            int possib = n * m;
            int lines = m + 1;
            res = add(res, -mul(possib, fpw(n * m - lines + 1)));
        }
        {
            int possib = m * m;
            int lines = n * m;
            res = add(res, +mul(possib, fpw(n * m - lines + 1)));
        }
        cout << res;
    } else {
        int res = fpw(n * m);
        for (int cnt = 1; cnt <= n; ++cnt) {
            int possib = iterate();
            int lines = n * cnt + m * cnt - cnt * cnt;
            if (cnt % 2 == 1) {
                res = add(res, -mul(possib, fpw(n * m - lines + 1)));
            } else {
                res = add(res, mul(possib, fpw(n * m - lines + 1)));
            }
        }
        cout << res;
    }
    return 0;
}