//
// Created by Dmitry Dubrovin on 11/20/20.
//

#include "sqsort.h"
#include <vector>
#include <algorithm>

using namespace std;

bool comp(pair<int, int> a, pair<int, int> b) {
    return cmp(a.first, a.second, b.first, b.second);
}

vector<pair<int, int>> bufer;

void mrg(vector<pair<int, int>> &vec, int l1, int r1, int l2, int r2) {
    int s = l1;
    while (l1 < r1 && l2 < r2) {
        if (comp(vec[l1], vec[l2])) {
            bufer.push_back(vec[l1++]);
        } else {
            bufer.push_back(vec[l2++]);
        }
    }
    while (l1 < r1) {
        bufer.push_back(vec[l1++]);
    }
    while (l2 < r2) {
        bufer.push_back(vec[l2++]);
    }
    for (int i = 0; i < bufer.size(); ++i) {
        vec[s + i] = bufer[i];
    }
    bufer.clear();
}

void msort(vector<pair<int, int>> &vec, int l, int r) {
    if (r == l + 1) {
        return;
    }
    int m = (r + l) / 2;
    msort(vec, l, m);
    msort(vec, m, r);
    mrg(vec, l, m, m, r);
}

std::vector<std::pair<int, int>> solve(int n) {
    vector<pair<int, int>> res;
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            res.push_back({i, j});
        }
    }
    msort(res, 0, res.size());
    return res;
}
