//
// Created by Dmitry Dubrovin on 11/20/20.
//

#include "sqsort.h"
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

map<pair<pair<int, int>, pair<int, int>>, bool> cache;

bool comp(pair<int, int> a, pair<int, int> b) {
    if (cache.count(make_pair(a, b))) {
        return cache[{a, b}];
    }
    return cache[{a, b}] = cmp(a.first, a.second, b.first, b.second);
}

vector<int> indexes;


vector<pair<int, int>> bufer;

int mless(int a, int b) {
    return indexes[a] < indexes[b];
}

bool true_comp(pair<int, int> a, pair<int, int> b) {
    if (cache.count(make_pair(a, b))) {
        return cache[{a, b}];
    }
    if (!mless(a.first, a.second)) {
        swap(a.first, a.second);
    }
    if (!mless(b.first, b.second)) {
        swap(b.first, b.second);
    }
    if (mless(a.first, b.first) && mless(a.second, b.second)) {
        return true;
    }
    if (!mless(a.first, b.first) && !mless(a.second, b.second)) {
        return false;
    }
    if (a.first > a.second) {
        swap(a.first, a.second);
    }
    if (b.first > b.second) {
        swap(b.first, b.second);
    }
    return comp(a, b);
}

void mrg(vector<pair<int, int>> &vec, int l1, int r1, int l2, int r2) {
    int s = l1;
    while (l1 < r1 && l2 < r2) {
        if (true_comp(vec[l1], vec[l2])) {
            bufer.push_back(vec[l1++]);
        } else {
            bufer.push_back(vec[l2++]);
        }
    }
    while (l1 < r1) {
        bufer.push_back(vec[l1++]);
    }
    while (l2 < r2) {
        bufer.push_back(vec[l2++]);
    }
    for (int i = 0; i < bufer.size(); ++i) {
        vec[s + i] = bufer[i];
    }
    bufer.clear();
}

void msort(vector<pair<int, int>> &vec, int l, int r) {
    if (r == l + 1) {
        return;
    }
    int m = (r + l) / 2;
    msort(vec, l, m);
    msort(vec, m, r);
    mrg(vec, l, m, m, r);
}


std::vector<std::pair<int, int>> solve(int n) {
    vector<pair<int, int>> tmp(n);
    for (int i = 0; i < n; ++i) {
        tmp[i] = {i, i};
    }
    sort(tmp.begin(), tmp.end(), comp);
    indexes.resize(n);
    for (int i = 0; i < n; ++i) {
        indexes[tmp[i].first] = i;
    }
    vector<pair<int, int>> res;
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            res.push_back({i, j});
        }
    }
    msort(res, 0, res.size());
    return res;
}
