#include <bits/stdc++.h>
using namespace std;

#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
#define x first
#define y second

typedef long long ll;
typedef long double ld;

#ifdef DEBUG
vector<pair<int, int>> solve(int n);

static const int HARD_LIMIT = 50000000;

static int n;
static vector<int> a;

static bool valid_pos(int i) {
	return 0 <= i && i < n;
}

static int Q;
bool cmp(int a_, int b, int c, int d) {
	if(!valid_pos(a_) || !valid_pos(b) || !valid_pos(c) || !valid_pos(d)) {
		cout << "Invalid query." << endl;
		cout << -1 << endl;
		exit(0);
	}

	Q++;
	if(Q > HARD_LIMIT) {
		cout << "Too many queries." << endl;
		cout << -1 << endl;
		exit(0);
	}

	return a[a_] + a[b] < a[c] + a[d];
}

static bool check_valid(const vector<pair<int, int>> &a) {
	if(n * (n + 1) / 2 != (int)a.size()) {
		return false;
	}

	vector<vector<bool>> used(n, vector<bool>(n, false));
	for(int i = 0; i < (int)a.size(); i++) {
		if(!valid_pos(a[i].first) || !valid_pos(a[i].second) || used[a[i].first][a[i].second]) {
			return false;
		}

		used[a[i].first][a[i].second] = true;
		used[a[i].second][a[i].first] = true;
	}

	return true;
}

int main() {
	cin >> n;
	a.resize(n);
	for(int i = 0; i < n; i++) {
		cin >> a[i];
	}

	Q = 0;
	cout << "STARTED SOLUTION" << endl;
	vector<pair<int, int>> ret = solve(n);	
	for (auto u : ret) {
		cout << "(" << u.x << "; " << u.y << ") ";
	}
	cout << endl;

	if(!check_valid(ret)) {
		cout << "Invalid output." << endl;
		cout << -1 << endl;
		return 0;
	}

	for(int i = 1; i < (int) ret.size(); i++) { 
		if(a[ret[i].first] + a[ret[i].second] < a[ret[i - 1].first] + a[ret[i - 1].second]) {
			cout << "Output not sorted." << endl;
			cout << -1 << endl;
			return 0;
		}
	}
	
	cout << "Correct!" << endl;
	cout << Q << endl;
	return 0;
}
#else
#include "sqsort.h"
#endif

bool sort_cmp(const pair<int, int> &a, const pair<int, int> &b) {
	return cmp(a.x, a.y, b.x, b.y);
}

vector<pair<int, int>> solve(int n) {
	vector<pair<int, int>> result;
	for (int i = 0; i < n; ++i) {
		for (int j = i; j < n; ++j)
			result.push_back({i, j});
	}
	sort(all(result), sort_cmp);
	return result;
}