#include <bits/stdc++.h>
using namespace std;

#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
#define x first
#define y second

typedef long long ll;
typedef long double ld;

#ifdef DEBUG
vector<pair<int, int>> solve(int n);

static const int HARD_LIMIT = 50000000;

static int n;
static vector<int> a;

static bool valid_pos(int i) {
	return 0 <= i && i < n;
}

static int Q;
bool cmp(int a_, int b, int c, int d) {
	if(!valid_pos(a_) || !valid_pos(b) || !valid_pos(c) || !valid_pos(d)) {
		cout << "Invalid query." << endl;
		cout << -1 << endl;
		exit(0);
	}

	Q++;
	if(Q > HARD_LIMIT) {
		cout << "Too many queries." << endl;
		cout << -1 << endl;
		exit(0);
	}

	return a[a_] + a[b] < a[c] + a[d];
}

static bool check_valid(const vector<pair<int, int>> &a) {
	if(n * (n + 1) / 2 != (int)a.size()) {
		return false;
	}

	vector<vector<bool>> used(n, vector<bool>(n, false));
	for(int i = 0; i < (int)a.size(); i++) {
		if(!valid_pos(a[i].first) || !valid_pos(a[i].second) || used[a[i].first][a[i].second]) {
			return false;
		}

		used[a[i].first][a[i].second] = true;
		used[a[i].second][a[i].first] = true;
	}

	return true;
}

int main() {
	cin >> n;
	a.resize(n);
	for(int i = 0; i < n; i++) {
		cin >> a[i];
	}

	Q = 0;
	cout << "STARTED SOLUTION" << endl;
	vector<pair<int, int>> ret = solve(n);	
	// for (auto u : ret) {
	// 	cout << "(" << u.x << "; " << u.y << ") ";
	// }
	// cout << endl;

	if(!check_valid(ret)) {
		cout << "Invalid output." << endl;
		cout << -1 << endl;
		return 0;
	}

	for(int i = 1; i < (int) ret.size(); i++) { 
		if(a[ret[i].first] + a[ret[i].second] < a[ret[i - 1].first] + a[ret[i - 1].second]) {
			cout << "Output not sorted." << endl;
			cout << -1 << endl;
			return 0;
		}
	}
	
	cout << "Correct!" << endl;
	cout << "Queries: " << Q << endl << "Score: " << min(ld(1), pow((2 * n * n + 1) / ld(Q + 1), 1.25)) * 100 << endl;
	return 0;
}
#else
#include "sqsort.h"
#endif

const int N = 2e3 + 10;

int ind[N], rev[N];

bool ind_cmp(int a, int b) {
	return cmp(a, a, b, b);
}

bool sort_cmp(const pair<int, int> &a, const pair<int, int> &b) {
	if (a.x == a.y && b.x == b.y)
		return a.x < b.x;
	if (max(a.x, a.y) < min(b.x, b.y))
		return true;
	if (max(b.x, b.y) < min(a.x, a.y))
		return false;
	return cmp(ind[a.x], ind[a.y], ind[b.x], ind[b.y]);
}

mt19937 rnd(1);

vector<pair<int, int>> solve(int n) {
	vector<pair<int, int>> result;
	iota(ind, ind + n, 0);
	stable_sort(ind, ind + n, ind_cmp);
	for (int i = 0; i < n; ++i)
		rev[ind[i]] = i;
	for (int i = 0; i < n; ++i) {
		int prev = 0;
		for (int j = i; j < n; ++j) {
			// cout << "at " << i << " " << j << endl;
			// cout << "prev is " << prev << endl;
			bool flag = 0;
			for (int iter = 0; prev < sz(result) && iter < 2; ++iter) {
				if (sort_cmp(result[prev], {i, j}))
					++prev;
				else {
					flag = 1;
					break;
				}
			}
			if (flag) {
				result.insert(begin(result) + prev, {i, j});
				continue;
			}
			int lpos = prev - 1, rpos = sz(result);
			while (rpos - lpos > 1) {
				int mid = (lpos + rpos) / 2;
				if (sort_cmp(result[mid], {i, j}))
					lpos = mid;
				else
					rpos = mid;
			}
			prev = max(0, lpos - 1);
			result.insert(begin(result) + rpos, {i, j});
		}
	}
	// stable_sort(all(result), sort_cmp);
	for (auto &e : result) {
		e.x = ind[e.x];
		e.y = ind[e.y];
		if (e.x > e.y)
			swap(e.x, e.y);
	}
	return result;
}