#include <bits/stdc++.h>
using namespace std;

#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
#define x first
#define y second

typedef long long ll;
typedef long double ld;

#ifdef DEBUG
vector<pair<int, int>> solve(int n);

static const int HARD_LIMIT = 50000000;

static int n;
static vector<int> a;

static bool valid_pos(int i) {
	return 0 <= i && i < n;
}

static int Q;
bool cmp(int a_, int b, int c, int d) {
	if(!valid_pos(a_) || !valid_pos(b) || !valid_pos(c) || !valid_pos(d)) {
		cout << "Invalid query." << endl;
		cout << -1 << endl;
		exit(0);
	}

	Q++;
	if(Q > HARD_LIMIT) {
		cout << "Too many queries." << endl;
		cout << -1 << endl;
		exit(0);
	}

	return a[a_] + a[b] < a[c] + a[d];
}

static bool check_valid(const vector<pair<int, int>> &a) {
	if(n * (n + 1) / 2 != (int)a.size()) {
		return false;
	}

	vector<vector<bool>> used(n, vector<bool>(n, false));
	for(int i = 0; i < (int)a.size(); i++) {
		if(!valid_pos(a[i].first) || !valid_pos(a[i].second) || used[a[i].first][a[i].second]) {
			return false;
		}

		used[a[i].first][a[i].second] = true;
		used[a[i].second][a[i].first] = true;
	}

	return true;
}

int main() {
	cin >> n;
	a.resize(n);
	for(int i = 0; i < n; i++) {
		cin >> a[i];
	}

	Q = 0;
	cout << "STARTED SOLUTION" << endl;
	vector<pair<int, int>> ret = solve(n);	
	// for (auto u : ret) {
	// 	cout << "(" << u.x << "; " << u.y << ") ";
	// }
	// cout << endl;

	if(!check_valid(ret)) {
		cout << "Invalid output." << endl;
		cout << -1 << endl;
		return 0;
	}

	for(int i = 1; i < (int) ret.size(); i++) { 
		if(a[ret[i].first] + a[ret[i].second] < a[ret[i - 1].first] + a[ret[i - 1].second]) {
			cout << "Output not sorted." << endl;
			cout << -1 << endl;
			return 0;
		}
	}
	
	cout << "Correct!" << endl;
	cout << "Queries: " << Q << endl << "Score: " << min(ld(1), pow((2 * n * n + 1) / ld(Q + 1), 1.25)) * 100 << endl;
	return 0;
}
#else
#include "sqsort.h"
#endif

const int N = 2e3 + 10;

int ind[N], rev[N];

bool ind_cmp(int a, int b) {
	return cmp(a, a, b, b);
}

bool sort_cmp(const pair<int, int> &a, const pair<int, int> &b) {
	if (a.x == a.y && b.x == b.y)
		return a.x < b.x;
	if (max(a.x, a.y) < min(b.x, b.y))
		return true;
	if (max(b.x, b.y) < min(a.x, a.y))
		return false;
	return cmp(ind[a.x], ind[a.y], ind[b.x], ind[b.y]);
}

mt19937 rnd(1);

const int NODES = 1e7 + 10;

struct Node {
	int l, r, sz, y;
	pair<int, int> value;
} _[NODES];

int next_free = 1;

int allocNode(pair<int, int> v) {
	_[next_free].l = 0, _[next_free].r = 0;
	_[next_free].sz = 1, _[next_free].y = rnd();
	_[next_free].value = v;
	return next_free++;
}

int size(int v) {
	if (!v)
		return 0;
	return _[v].sz;
}

void pull(int v) {
	_[v].sz = size(_[v].l) + size(_[v].r) + 1;
}

int merge(int a, int b) {
	if (!a)
		return b;
	if (!b)
		return a;
	if (_[a].y < _[b].y) {
		_[a].r = merge(_[a].r, b);
		pull(a);
		return a;
	} else {
		_[b].l = merge(a, _[b].l);
		pull(b);
		return b;
	}
}

// k in left
pair<int, int> split_k(int v, int k) {
	if (!v)
		return {0, 0};
	if (size(_[v].l) >= k) {
		auto splt = split_k(_[v].l, k);
		_[v].l = 0;
		splt.y = merge(splt.y, v);
		pull(splt.y);
		return splt;
	} else {
		auto splt = split_k(_[v].r, k - 1 - size(_[v].l));
		_[v].r = 0;
		splt.x = merge(v, splt.x);
		pull(splt.x);
		return splt;
	}
}

pair<int, int> get_k(int v, int k) {
	if (size(_[v].l) > k)
		return get_k(_[v].l, k);
	if (size(_[v].l) == k)
		return _[v].value;
	return get_k(_[v].r, k - 1 - size(_[v].l));
}

vector<pair<int, int>> rres;

void recover(int v) {
	if (!v)
		return;
	recover(_[v].l);
	rres.push_back(_[v].value);
	recover(_[v].r);
}

vector<pair<int, int>> solve(int n) {
	int result = 0;
	iota(ind, ind + n, 0);
	stable_sort(ind, ind + n, ind_cmp);
	for (int i = 0; i < n; ++i)
		rev[ind[i]] = i;
	if (n <= 1010) {
	for (int i = 0; i < n; ++i) {
		int prev = 0;
		for (int j = i; j < n; ++j) {
			int lpos = max(-1, prev), rpos = size(result);
			while (rpos - lpos > 1) {
				// cout << lpos << " " << rpos << endl;
				int mid = (lpos + rpos) / 2;
				if (sort_cmp(get_k(result, mid), {i, j}))
					lpos = mid;
				else
					rpos = mid;
			}
			prev = lpos - 1;
			// cout << "pos is " << rpos << endl;
			auto splt = split_k(result, rpos);
			// cout << "splitted" << size(splt.x) << " " << size(splt.y) << endl;
			result = merge(splt.x, merge(allocNode({i, j}), splt.y));
			// cout << "merged" << size(result) << endl;
			// result.insert(begin(result) + rpos, {i, j});
		}
	}
	recover(result);
	} else {
		for (int i = 0; i < n; ++i) {
			for (int j = i; j < n; ++j)
				rres.push_back({i, j});
		}
		stable_sort(all(rres), sort_cmp);
	}
	for (auto &e : rres) {
		e.x = ind[e.x];
		e.y = ind[e.y];
		if (e.x > e.y)
			swap(e.x, e.y);
	}
	return rres;
}