#include <bits/stdc++.h>
#include "sqsort.h"
using namespace std;
#define app push_back
#define ii pair <int, int> 
#define f first
#define s second

const int N = 2007;
bool used[N][N];
int ord[N];

struct Pair {
    int i, j;
    bool operator < (Pair p) const {
        if (i <= p.i && j <= p.j && (i != p.i || j != p.j))
            return 1;
        if (i >= p.i && j >= p.j && (i != p.i || j != p.j))
            return 0;
        return cmp(ord[i], ord[j], ord[p.i], ord[p.j]);            
    }   
};

struct Heap {

int ptr;
Pair h[N * N];

Heap () {
    ptr = 1;
}   

void push(Pair a) {
    h[ptr] = a;
    int u = ptr;
    ptr++;
    while (u > 1 && h[u] < h[u/2]) {
        swap(h[u], h[u/2]);
        u /= 2;                
    }   
}   

int size() {
    return ptr - 1;
}   

void pop() {
    assert(ptr > 1);
    if (ptr == 2) {
        ptr = 1;
    }   
    else {
        ptr--;
        h[1] = h[ptr];
        int u = 1;
        while (1) {
            if (u * 2 >= ptr)
                break;
            if (u * 2 + 1 >= ptr) {
                if (h[u*2] < h[u]) {
                    swap(h[u], h[u * 2]);
                    u *= 2;
                }   
                else {
                    break;
                }   
            }   
            else {
                //u * 2 + 1 < ptr
                int mn = -1;
                if (h[u*2] < h[u*2+1]) {
                    mn = u * 2;
                }   
                else {
                    mn = u * 2 + 1;
                }   

                if (h[mn] < h[u]) {
                    swap(h[u], h[mn]);
                    u = mn;
                }   
                else {
                    break;
                }   
            }   
                
        }   
    }   
}   

Pair top() {
    assert(ptr > 1);
    return h[1];
}   

} q;  

vector <ii> solve(int n) {
    vector <ii> ans;
    for (int i = 0; i < n; ++i)
        ord[i] = i;

    auto comp1 = [&] (int i, int j) {
        return cmp(i, i, j, j);
    };  
    sort(ord, ord + n, comp1);
    vector <int> num(n);
    for (int i = 0; i < n; ++i)
        num[ord[i]] = i;

    auto add = [&] (int i, int j) {
        if (i <= j && i < n && j < n && !used[i][j]) {
            used[i][j] = 1;
            q.push({i, j});
        }   
    };  

    add(0, 0);
    while (q.size()) {
        auto c = q.top(); q.pop();
        int i = c.i, j = c.j;
        ans.app({ord[i], ord[j]});
        add(i + 1, j);
        add(i, j + 1);
    }                           

    return ans;
}   