//#include<iostream>
//#include<vector>
//#include<algorithm>
//#include<set>
//#include<map>
//#include "sqsort.h"
//
//using namespace std;
//const int INF = 1e9;
//
//std::vector<std::pair<int, int>> solve(int n) {
//	vector<int> a(n);
//	for (int i = 0; i < n; ++i)
//		a[i] = i;
//	merge_sort(a);
//	vector<vector<int>> pairs;
//	for (int i = 0; i < n; ++i) {
//		for (int j = i + 1; j < n; ++j) {
//			pairs[i][j] += j * (j + 1) / 2 - (j - i - 1) * (j - i) / 2;
//			int l = i + 1, r = j - 1, m;
//			while (r > l + 1) {
//				m = (r + l) / 2;
//				if (cmp(a[i], a[j], a[m], a[j - 1]))
//					r = m;
//				else
//					l = m;
//			}
//		}
//	}
//}
//
//void merge_sort(vector<int>& a) {
//	if (a.size() == 1)
//		return;
//	vector<int> left(a.size() / 2), right(a.size() - a.size() / 2);
//	for (int i = 0; i < a.size() / 2; ++i)
//		left[i] = a[i];
//	for (int i = 0; i < a.size() - a.size() / 2; ++i)
//		right[i] = a[a.size() / 2 + i];	
//	merge_sort(left); merge_sort(right);
//	int i = 0, j = 0;
//	while (i < a.size() / 2) {
//		while (j < a.size() - a.size() / 2 && !cmp(left[i], left[i], right[j], right[j])) {
//			a[i + j] = right[j];
//			++j;
//		}
//		a[i + j] = left[i];
//		++i;
//	}
//	while (i < a.size() / 2) {
//		a[i + j] = left[i];
//		++i;
//	}
//	while (j < a.size() - a.size() / 2) {
//		a[i + j] = right[j];
//		++j;
//	}
//}

#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>

using namespace std;
const int INF = 1e9, mod = 1e9 + 7;

int main() {
	int n, m;
	cin >> n >> m;
	int ans = 0;
	for (int mask = 0; mask < (1 << (n * m)); ++mask) {
		vector<vector<int>> desk(n, vector<int>(m));
		vector<int> cols(m, 0), rows(n, 0);
		for (int i = 0; i < n * m; ++i) {
			desk[i / m][i % m] = (bool)(mask & (1 << i));
			cols[i % m] += desk[i / m][i % m];
			rows[i / m] += desk[i / m][i % m];
		}
		bool good = true;
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < m; ++j)
				if (!((desk[i][j] && cols[j] + rows[i] > 2) || (!desk[i][j] && cols[j] + rows[i] < n + m - 2)))
					good = false;
		ans = (ans + good) % mod;
	}
	cout << ans;
}