#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include "sqsort.h"

using namespace std;
const int INF = 1e9;

vector<pair<int, int>> pair_merge_sort(vector<pair<int, int>> a, vector<pair<int, int>> b) {
	vector<pair<int, int>> res(a.size() + b.size());
	int i = 0, j = 0;
	while (i < a.size()) {
		while (j < b.size() && cmp(a[i].first, a[i].second, b[i].first, b[i].second)) {
			res[i + j] = a[i];
			++j;
		}
		res[i + j] = b[j];
		++j;
	}
	while (i < a.size()) {
		res[i + j] = a[i];
		++i;
	}
	while (j < b.size()) {
		res[i + j] = b[j];
		++j;
	}
	return res;
}

void merge_sort(vector<int>& a) {
	if (a.size() == 1)
		return;
	vector<int> left(a.size() / 2), right(a.size() - a.size() / 2);
	for (int i = 0; i < a.size() / 2; ++i)
		left[i] = a[i];
	for (int i = 0; i < a.size() - a.size() / 2; ++i)
		right[i] = a[a.size() / 2 + i];
	merge_sort(left);
	merge_sort(right);
	int i = 0, j = 0;
	while (i < a.size() / 2) {
		while (j < a.size() - a.size() / 2 && cmp(left[i], left[i], right[j], right[j])) {
			a[i + j] = left[j];
			++j;
		}
		a[i + j] = left[i];
		++i;
	}
	while (i < a.size() / 2) {
		a[i + j] = left[i];
		++i;
	}
	while (j < a.size() - a.size() / 2) {
		a[i + j] = right[j];
		++j;
	}
}

vector<pair<int, int>> solve(int n) {
	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		a[i] = i;
	merge_sort(a);
	vector<vector<pair<int, int>>> pairs;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			pairs[i].push_back({ a[i], a[j] });
		}
	}
	vector<pair<int, int>> res = pair_merge_sort(pairs[0], pairs[1]);
	for (int i = 2; i < n; ++i) {
		res = pair_merge_sort(res, pairs[i]);
	}
	return res;
}


