#include <bits/stdc++.h>
#include "sqsort.h"

using namespace std;

vector<pair<int, int>> v;
vector<int> order;
vector<int> id;


vector<pair<int, int>> merge(vector<pair<int, int>> x, vector<pair<int, int>> y) {
    int p1 = 0;
    int p2 = 0;
    vector<pair<int, int>> res;
    while (p1 < x.size() && p2 < y.size()) {
        int i1 = x[p1].first;
        int i2 = x[p1].second;
        int i3 = y[p2].first;
        int i4 = y[p2].second;
        if (id[i1] <= id[i3] && id[i2] <= id[i4]) {
            res.push_back(x[p1++]);
        } else if (id[i1] >= id[i3] && id[i2] >= id[i4]) {
            res.push_back(y[p2++]);
        } else {
            if (cmp(x[p1].first, x[p1].second, y[p2].first, y[p2].second)) {
                res.push_back(x[p1++]);
            } else res.push_back(y[p2++]);
        }
    }
    while (p1 < x.size())res.push_back(x[p1++]);
    while (p2 < y.size())res.push_back(y[p2++]);
    return res;
}

vector<pair<int, int>> msort(int l, int r) {
    if (l == r)return {v[l]};
    else {
        int m = (l + r) / 2;
        auto v1 = msort(l, m);
        auto v2 = msort(m + 1, r);
        return merge(v1, v2);
    }
}

void shuffle() {
    int sz = v.size();
    for (int i = 0; i < 100; ++i) {
        int v1 = rand();;
        int v2 = rand();;
        v1 = (v1 % sz + sz) % sz;
        v2 = (v2 % sz + sz) % sz;
        swap(v[v1], v[v2]);
    }
}

vector<pair<int, int>> solve(int n) {
    id.resize(n);
    order.push_back(0);
    for (int i = 1; i < n; ++i) {
        int l = 0;
        int r = order.size();
        while (l != r) {
            int m = (l + r) / 2;
            if (cmp(0, i, 0, order[m]))r = m;
            else l = m + 1;
        }
        int j = l;
        vector<int> nw;
        for (int k = 0; k < j; ++k)nw.push_back(order[k]);
        nw.push_back(i);
        for (int k = j; k < order.size(); ++k)nw.push_back(order[k]);
        order.clear();
        order = nw;
    }
    for (int i = 0; i < n; ++i)id[order[i]] = i;
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            v.push_back({i, j});
        }
    }
    shuffle();
    return msort(0, (int) v.size() - 1);
}