#include <bits/stdc++.h>
#include "sqsort.h"

using namespace std;

int alcomp[2005][2005];
bool used[2005][2005];

vector<int> indices;

map<pair<pair<int,int>, pair<int,int>>, bool> cache;

bool tmpc(pair<int,int> x, pair<int,int> y)
{
    x.first = indices[x.first];
    y.first = indices[y.first];
    y.second = indices[y.second];
    x.second = indices[x.second];
    if(alcomp[x.first][y.first] == alcomp[x.second][y.second]) return alcomp[x.first][y.first];
    if(alcomp[x.first][y.second] == alcomp[x.second][y.first]) return alcomp[x.first][y.second];
    if(cache.find(make_pair(x, y)) != cache.end()) return cache[make_pair(x, y)];
    cache[make_pair(x, y)] = cmp(x.first, x.second, y.first, y.second);
    return cache[make_pair(x, y)];
}

bool compare_indices(int x, int y)
{
    return !cmp(0, x, 0, y);
}

vector<pair<int, int>> eq_pool;

bool check_in_pool(vector<pair<int,int>> pool, pair<int, int> pr)
{
    for(auto _pr : pool) if(pr == _pr) return 1;
    return 0;
}

int splits = 0;

struct node
{
    node *left = nullptr, *right = nullptr;
    pair<int, int> val;
    int sz, depth;
};
node *head;

int get_sz(node *x)
{
    if(x == nullptr) return 0;
    return x->sz;
}

int get_depth(node *x)
{
    if(x == nullptr) return 0;
    return x->depth;
}

void lev_ref(node *root, int lev)
{
    if(root == nullptr) return;
    if(lev < 0) return;

    lev_ref(root->left, lev - 1);
    lev_ref(root->right, lev - 1);

    root->sz = get_sz(root->left) + get_sz(root->right) + 1;
    root->depth = max(get_depth(root->left), get_depth(root->right)) + 1;
}

node *rotate_left(node *x)
{
    node *y = x->right;
    node *t2 = y->left;

    y->left = x;
    x->right = t2;

    return y;
}

node *rotate_right(node *y)
{
    node *x = y->left;
    node *t2 = x->right;

    x->right = y;
    y->left = t2;

    return x;
}

node* ins(node* root, pair<int, int> key)
{
    if(root == nullptr)
    {
        root = new node;
        root->val = key;
        root->sz = 1;
        return root;
    }


    if(tmpc(root->val, key))
    {
        root->right = ins(root->right, key);

        if(get_sz(root->right) > get_sz(root->left) + 1)
            root = rotate_left(root);

        lev_ref(root, 2);
    }
    else
    {
        root->left = ins(root->left, key);

        if(get_sz(root->left) > get_sz(root->right) + 1) {
            root = rotate_right(root);
        }
        lev_ref(root, 2);
    }

    //cout << root << endl;
    return root;
}

node* del(node *root, pair<int, int> key)
{
    if(root->val == key)
    {
        if(root->left == nullptr && root->right == nullptr)
            return nullptr;
        if(get_sz(root->left) > get_sz(root->right)) {
            root = rotate_right(root);
            root->right = del(root->right, key);
            return root;
        }
        else
        {
            root = rotate_left(root);
            root->left = del(root->left, key);
            return root;
        }
    }

    if(tmpc(root->val, key))
    {
        root->right = del(root->right, key);
    }
    else
    {
        root->left = del(root->left, key);
    }

    return root;
}

pair<int, int> left_most_key(node *root)
{
    if(root->left == nullptr) return root->val;
    else return left_most_key(root->left);
}

bool check_used(pair<int,int> x)
{
    return used[x.first][x.second];
}

void split_in_pool(vector<pair<int,int>>& pool, int n)
{
    //cout << splits++ << "\n";
    pair<int, int> spliter = left_most_key(head);
    used[spliter.first][spliter.second] = 1;
    head = del(head, spliter);
    //eq_pool.push_back(spliter);
    //for(auto e : pool)
    //    cerr << e.first << " " << e.second << endl;
    //cerr << endl;
    //pool.erase(pool.begin());
    int step = (1<<20);
    int index = -1;

    pair<int,int> re1 = spliter;

    re1.first++;

    if(re1.first <= re1.second && re1.second < n && check_used(re1) == false) {
        /*for(; step > 0; step /= 2)
        {
            if(index + step >= pool.size()) continue;

            if(tmpc(pool[index + step], re1) == true)
                index += step;
        }

        //if(index >= 0) index++;
        //cout << index << endl;

        pool.push_back(re1);
        for(int i = pool.size() - 1; i >= index + 2; i--)
            pool[i] = pool[i-1];

        pool[index + 1] = re1;*/

        //depth = 0;
        head = ins(head, re1);
        used[re1.first][re1.second] = 1;
    }

    re1.first--;
    re1.second++;

    if(re1.first <= re1.second && re1.second < n && check_used(re1) == false) {
        /*step = (1<<20);
        index = -1;
        for(; step > 0; step /= 2)
        {
            if(index + step >= pool.size()) continue;

            if(tmpc(pool[index + step], re1) == true)
                index += step;
        }

        //if(index >= 0) index++;
        //cout << index << endl;

        pool.push_back(re1);
        for(int i = pool.size() - 1; i >= index + 2; i--)
            pool[i] = pool[i-1];

        pool[index + 1] = re1;*/

        //depth = 0;
        head = ins(head, re1);
        used[re1.first][re1.second] = 1;
    }

    /*for(int i = 0; i < (int)pool.size()-1; i++)
    {
        cout << pool[i].first << " " << pool[i].second << endl;
        cout << pool[i+1].first << " " << pool[1+i].second << endl;
        cout << endl;
        //assert(!tmpc(pool[i+1], pool[i]));
        //assert(!cmp(pool[i+1].first, pool[i+1].second, pool[i].first, pool[i].second));
    }*/
}

std::vector<std::pair<int, int>> solve(int n)
{
    for(int i = 0; i < n; i++)
        indices.push_back(i);

    sort(indices.begin(), indices.end(), compare_indices);
    reverse(indices.begin(), indices.end());

    //cerr << "Indices sorted" << endl;

    vector<int> reverse_indices(n);
    for(int i = 0; i < n; i++)
    {
        reverse_indices[indices[i]] = i;
    }

    for(int i = 0; i < n; i++)
    for(int j = i+1; j < n; j++) {
        alcomp[i][j] = (reverse_indices[i] < reverse_indices[j]);
        alcomp[j][i] = !alcomp[i][j];
    }

    vector<pair<int, int>> ret;
    /*for(int i = 0; i < n; i++)
    for(int j = i; j < n; j++)
        ret.push_back(make_pair(i, j));
    */

    vector<pair<int, int>> pair_pool;

    head = ins(head, make_pair(0, 0));
    //pair_pool.push_back(make_pair(0, 0));

    ret.clear();

    while(head != nullptr)
    {
        //cout << "In loop" << endl;
        //cout << pair_pool.size() << endl;
        ret.push_back(left_most_key(head));
        split_in_pool(pair_pool, n);
    }

    //sort(ret.begin(), ret.end(), tmpc);

    for(int i = 0; i < ret.size(); i++)
    {
        auto& e = ret[i];
        e.first = indices[e.first];
        e.second = indices[e.second];

        if(e.first > e.second) swap(e.first, e.second);

        //cerr << e.first << " " << e.second << endl;
    }
    //cerr << endl;

    return ret;
}
