#include <bits/stdc++.h>
#include "sqsort.h"

struct Pair {
	int i, j, x, y;
	
	// *this > x in relation to cmp. Operator is inversed
	bool operator<(const Pair other) const {
		// Useless query
		// *this <= other  =>  other >= *this  =>  *this < other is false
		//if(x <= other.x && y <= other.y) return false;

		//if(x >= other.x && y >= other.y) return false;

		return cmp(i, j, other.i, other.j);
	}
};

const int MAX_N = 2000;
int freq[MAX_N][MAX_N];

std::vector<std::pair<int, int> > solve(int n) {
	std::vector<Pair> elem;
	
	// Sort the elements
	for(int i = 0; i < n; ++i)
		elem.push_back({i, i});
	
	srand(time(NULL));
	std::random_shuffle(elem.begin(), elem.end());
	std::sort(elem.begin(), elem.end()); // NlogN
	//std::reverse(elem.begin(), elem.end());

	std::multiset<Pair> pq;
	pq.insert({elem[0].i, elem[0].i, 0, 0});

	std::vector<std::pair<int, int> > ans;
	
	for(int i = 0; i < n; ++i) {
		freq[0][i]++;
		freq[i][i]++;
	}
	
	while(!pq.empty()) {
		Pair e = *pq.begin();
		pq.erase(pq.begin());
		ans.push_back({e.i, e.j});

		//printf("pair: %d %d %d %d\n", e.i, e.j, e.x, e.y);

		if(e.x + 1 <= e.y) {
			//printf("Affected: %d %d\n", e.x + 1, e.y);
			freq[e.x + 1][e.y]++;
			if(freq[e.x + 1][e.y] == 2) {
				//printf("Add: %d %d\n", e.x + 1, e.y);
				pq.insert({elem[e.x + 1].i, elem[e.y].i, e.x + 1, e.y});
			}
		}
		if(e.y + 1 < n) {
			//printf("Affected: %d %d\n", e.x, e.y + 1);
			freq[e.x][e.y + 1]++;
			if(freq[e.x][e.y + 1] == 2)
				pq.insert({elem[e.x].i, elem[e.y + 1].i, e.x, e.y + 1});
		}
	}
	
	//printf("Done\n");

	return ans;
}
