#include "sqsort.h"

#include <bits/stdc++.h>

#define F first
#define S second

using namespace std;
using vi = vector<int>;
using pi = pair<int, int>;
using vpi = vector<pi>;

vector<pi> solve(int n) {
    vector<vi> st(n, vi(n));
    vector<vector<vpi>> g(n, vector<vpi>(n));
    for (int i = 0; i < n; ++i)
    for (int j = 0; j <= i; ++j) {
        if (i < n-1) g[i][j].emplace_back(i+1, j), ++st[i+1][j];
        if (j < i)   g[i][j].emplace_back(i, j+1), ++st[i][j+1];
    }

    vi p(n); iota(p.begin(), p.end(), 0);
    sort(p.begin(), p.end(), [&](int l, int r) {
         return cmp(l, l, r, r);
    });

    mt19937 rng(1337228);

    vpi cand { {0, 0} }, res;
    while (!cand.empty()) {
        shuffle(cand.begin(), cand.end(), rng);

        pi a = cand[0];
        for (pi b : cand) {
            if (b == a) continue;
            if (cmp(p[b.F], p[b.S], p[a.F], p[a.S]))
                swap(a, b);
            g[a.F][a.S].emplace_back(b.F, b.S);
            st[b.F][b.S]++;
        }
        cand.resize(0);
        res.emplace_back(p[a.F], p[a.S]);

        for (pi b : g[a.F][a.S]) {
            st[b.F][b.S]--;
            if(st[b.F][b.S] == 0) cand.push_back(b);
        }
    }
    return res;
}
