#include <iostream>
#include <vector>
#include <queue>

using namespace std;

const int NMAX = 1000;

int S, D, cnt;

int N, K;
int T[NMAX], L[NMAX];
int Coresp[NMAX];

int Jeton[NMAX], Jeton_K[NMAX], Jeton_1[NMAX];
int Codif_Node[NMAX];

///
int C[NMAX][NMAX], F[NMAX][NMAX];
vector < int > G[NMAX];
///

int father[NMAX];

bool Sel[NMAX];

///
static inline void Add_Edge (int X, int Y, int c)
{
    G[X].push_back(Y), G[Y].push_back(X);

    C[X][Y] = c;

    return;
}

static inline void CreateNetwork ()
{
    cnt = 0;

    ///
    S = (++cnt);

    for(int i = 1; i <= N; ++i)
    {
        Jeton[i] = (++cnt);
        Add_Edge(S, Jeton[i], K);

        Jeton_K[i] = (++cnt);
        Add_Edge(Jeton[i], Jeton_K[i], K);

        Jeton_1[i] = (++cnt);
        Add_Edge(Jeton[i], Jeton_1[i], 1);
    }

    for(int i = 1; i <= N; ++i)
        Codif_Node[i] = (++cnt);

    D = (++cnt);

    for(int i = 1; i <= N; ++i)
        Add_Edge(Codif_Node[i], D, 2 * K);
    ///

    for(int i = 1; i <= N; ++i)
        for(int j = 1; j <= N; ++j)
        {
            if(j == Coresp[i] || j == i)
                Add_Edge(Jeton_K[i], Codif_Node[j], K);
            else Add_Edge(Jeton_1[i], Codif_Node[j], 1);
        }

    return;
}
///

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N >> K;

    for(int i = 1; i <= N; ++i)
        cin >> T[i] >> L[i], ++T[i], Coresp[T[i]] = i;

    CreateNetwork();

    return;
}

static inline bool BFS (int S, int D)
{
    for(int i = 1; i <= cnt; ++i)
        father[i] = -1;

    queue < int > Q;
    father[S] = 0, Q.push(S);

    while(!Q.empty())
    {
        int Node = Q.front();
        Q.pop();

        for(auto it : G[Node])
            if(father[it] == -1 && F[Node][it] < C[Node][it])
            {
                father[it] = Node;

                if(it == D)
                    return 1;

                Q.push(it);
            }
    }

    return 0;
}

static inline int my_min (int a, int b)
{
    return ((a < b) ? a : b);
}

static inline int MaxFlow (int S, int D)
{
    int ans = 0;

    while(BFS(S, D))
    {
        for(auto it : G[D])
            if(father[it] != -1)
            {
                int flow = C[it][D] - F[it][D];

                int Node = it;
                while(Node != S)
                {
                    int Dad = father[Node];
                    flow = my_min(flow, C[Dad][Node] - F[Dad][Node]);
                    Node = Dad;
                }

                ans += flow;

                F[it][D] += flow, F[D][it] -= flow;

                Node = it;
                while(Node != S)
                {
                    int Dad = father[Node];
                    F[Dad][Node] += flow, F[Node][Dad] -= flow;
                    Node = Dad;
                }
            }
    }

    return ans;
}

static inline void Solve ()
{
    MaxFlow(S, D);

    int ans = 0;

    for(int i = 1; i <= N; ++i)
        if(F[Codif_Node[i]][D] == 2 * K)
            ans += L[i];

    cout << ans << '\n';

    return;
}

int main ()
{
    Read();

    Solve();

    return 0;
}
