#include <bits/stdc++.h>
#include "sqsort.h"

using namespace std;

const int NMAX = 2e3 + 1;

typedef pair < int, int > PII;

int M = 0;

PII Heap[NMAX * NMAX];

map < pair < PII, PII >, bool > Sel;
map < pair < PII, PII >, bool > mp;

static inline bool Ask (int a, int b, int c, int d)
{
    if(Sel[ {{a, b}, {c, d}}])
    return mp[ {{a, b}, {c, d}}];

    Sel[ {{a, b}, {c, d}}] = 1;

    return (mp[ {{a, b}, {c, d}}] = cmp(a, b, c, d));
}

static inline void HeapUp (int Node)
{
    if(Node == 1)
        return;

    int father = (Node >> 1);

    if(Ask(Heap[Node].first, Heap[Node].second, Heap[father].first, Heap[father].second))
        swap(Heap[Node], Heap[father]), HeapUp(father);

    return;
}

static inline void HeapDown (int Node)
{
    int Left = (Node << 1), Right = ((Node << 1) + 1);

    if(Left > M && Right > M)
        return;

    if(Left <= M && Right <= M)
    {
        if(Ask(Heap[Left].first, Heap[Left].second, Heap[Right].first, Heap[Right].second))
        {
            if(Ask(Heap[Left].first, Heap[Left].second, Heap[Node].first, Heap[Node].second))
            {
                swap(Heap[Node], Heap[Left]);

                HeapDown(Left);
            }
        }
        else
        {
            if(Ask(Heap[Right].first, Heap[Right].second, Heap[Node].first, Heap[Node].second))
            {
                swap(Heap[Node], Heap[Right]);

                HeapDown(Right);
            }
        }

        return;
    }

    if(Left <= M)
    {
        if(Ask(Heap[Left].first, Heap[Left].second, Heap[Node].first, Heap[Node].second))
        {
            swap(Heap[Node], Heap[Left]);

            HeapDown(Left);
        }

        return;
    }

    if(Right <= M)
    {
        if(Ask(Heap[Right].first, Heap[Right].second, Heap[Node].first, Heap[Node].second))
        {
            swap(Heap[Node], Heap[Right]);

            HeapDown(Right);
        }

        return;
    }

    return;
}

vector < PII > solve (int n)
{
    for(int i = 0; i < n; ++i)
        for(int j = i; j < n; ++j)
        {
            Heap[++M] = {i, j};

            HeapUp(M);
        }

    vector < PII > ans;

    int Total = ((n * (n + 1)) >> 1);

    for(int i = 1; i <= Total; ++i)
    {
        ans.push_back(Heap[1]);

        swap(Heap[1], Heap[M]), --M;

        HeapDown(1);
    }

    return ans;
}
