#include <bits/stdc++.h>
#include "sqsort.h"

using namespace std;

const int NMAX = 2e3 + 1;

typedef pair < int, int > PII;

int M = 0;

PII Heap[NMAX * NMAX];

int V[NMAX];

static inline void HeapUp (int Node)
{
    if(Node == 1)
        return;

    int father = (Node >> 1);

    if(cmp(Heap[Node].first, Heap[Node].second, Heap[father].first, Heap[father].second))
        swap(Heap[Node], Heap[father]), HeapUp(father);

    return;
}

static inline void HeapDown (int Node)
{
    int Left = (Node << 1), Right = ((Node << 1) + 1);

    if(Left > M && Right > M)
        return;

    if(Left <= M && Right <= M)
    {
        if(cmp(Heap[Left].first, Heap[Left].second, Heap[Right].first, Heap[Right].second))
        {
            if(cmp(Heap[Left].first, Heap[Left].second, Heap[Node].first, Heap[Node].second))
            {
                swap(Heap[Node], Heap[Left]);

                HeapDown(Left);
            }
        }
        else
        {
            if(cmp(Heap[Right].first, Heap[Right].second, Heap[Node].first, Heap[Node].second))
            {
                swap(Heap[Node], Heap[Right]);

                HeapDown(Right);
            }
        }

        return;
    }

    if(Left <= M)
    {
        if(cmp(Heap[Left].first, Heap[Left].second, Heap[Node].first, Heap[Node].second))
        {
            swap(Heap[Node], Heap[Left]);

            HeapDown(Left);
        }

        return;
    }

    if(Right <= M)
    {
        if(cmp(Heap[Right].first, Heap[Right].second, Heap[Node].first, Heap[Node].second))
        {
            swap(Heap[Node], Heap[Right]);

            HeapDown(Right);
        }

        return;
    }

    return;
}

void Sort (int n)
{
    for(int i = 0; i < n; ++i)
        Heap[++M] = {i, i}, HeapUp(M);

    int Total = n;

    for(int i = 1; i <= Total; ++i)
    {
        V[i - 1] = Heap[1].first;

        swap(Heap[1], Heap[M]), --M;

        HeapDown(1);
    }

    return;
}

vector < PII > solve (int n)
{
    Sort(n);

    M = 0;

    for(int i = 0; i < n; ++i)
        for(int j = i; j < n; ++j)
        {
            if(i == j)
            {
                if(i == 0 || i == (n - 1))
                    continue;
            }

            Heap[++M] = {V[i], V[j]}, HeapUp(M);
        }

    vector < PII > ans;

    ans.push_back({V[0], V[0]});

    int Total = ((n * (n + 1)) >> 1) - 2;

    for(int i = 1; i <= Total; ++i)
    {
        ans.push_back(Heap[1]);

        swap(Heap[1], Heap[M]), --M;

        HeapDown(1);
    }

    ans.push_back({V[n - 1], V[n - 1]});

    return ans;
}
