#include <bits/stdc++.h>

#ifdef LOCAL

#else
#include "sqsort.h"
#endif // LOCAL

using namespace std;

const int N = 2000;
int n;
int x[N];
int qu;

#ifdef LOCAL
bool cmp(int a, int b, int c, int d)
{
    qu++;
    return x[a] + x[b] < x[c] + x[d];
}
#endif // LOCAL

int decide_winner(int f, int g, vector<int> &t, vector<int> &pointer, int n, vector<int> &pos)
{
    if (t[f] == t[g]) return t[f];
    if (pointer[t[f]] == n) return t[g];
    if (pointer[t[g]] == n) return t[f];
    if (cmp(pos[t[f]], pos[pointer[t[f]]], pos[t[g]], pos[pointer[t[g]]])) return t[f];
    return t[g];
}

std::vector<std::pair<int, int> > solve(int n)
{
    vector<int> p(n);
    iota(p.begin(), p.end(), 0);
    sort(p.begin(), p.end(), [&](int x, int y){
         return cmp(x, x, y, y);
         });
    //for (int i = 0; i < p.size(); i++)
    //    cout << p[i] << " ";
    //cout << endl;
    vector<int> pos(n);
    for (int i = 0; i < p.size(); i++)
        pos[i] = p[i];
    vector<int> pointer(n);
    iota(pointer.begin(), pointer.end(), 0);
    vector<pair<int, int> > res;

    int sz = 1;
    while (sz < n) sz *= 2;

    int doubled = sz - n;

    vector<int> t(sz - 1);
    for (int i = 0; i < doubled; i++)
    {
        t.push_back(i);
        t.push_back(i);
    }
    for (int i = doubled; i < n; i++)
    {
        t.push_back(i);
    }
    for (int i = sz - 2; i >= 0; i--)
    {
        t[i] = decide_winner(2 * i + 1, 2 * i + 2, t, pointer, n, pos);
    }
    while (pointer[t[0]] != n)
    {
        res.push_back({pos[t[0]], pos[pointer[t[0]]]});
        pointer[t[0]]++;
        int V = 0;
        vector<int> path;
        while (V < sz - 1)
        {
            if (t[2 * V + 1] == t[2 * V + 2]) break;
            path.push_back(V);
            if (t[2 * V + 1] == t[V]) V = 2 * V + 1;
            else V = 2 * V + 2;
        }
        reverse(path.begin(), path.end());
        for (auto e : path)
        {
            t[e] = decide_winner(2 * e + 1, 2 * e + 2, t, pointer, n, pos);
        }
    }
    return res;
}

#ifdef LOCAL
int main()
{
    cin >> n;
    for (int i = 0; i < n; i++) cin >> x[i];
    vector<pair<int, int> > res = solve(n);
    cout << qu << endl;
    for (int i = 0; i < res.size(); i++)
    {
        cout << res[i].first << " " << res[i].second << " " << x[res[i].first] + x[res[i].second] << "\n";
    }
}
#endif // LOCAL
