#include <bits/stdc++.h>

#ifdef LOCAL

#else
#include "sqsort.h"
#endif // LOCAL

using namespace std;

const int N = 2000;
int n;
int x[N];
int qu;

#ifdef LOCAL
bool cmp(int a, int b, int c, int d)
{
    qu++;
    return x[a] + x[b] < x[c] + x[d];
}
#endif // LOCAL

int decide_winnerD(int f, int g, vector<int> &t, vector<int> &pointer, int n, vector<int> &pos)
{
    if (t[f] == t[g]) return t[f];
    if (pointer[t[f]] == n) return t[g];
    if (pointer[t[g]] == n) return t[f];
    if (t[f] <= t[g] && pointer[t[f]] <= pointer[t[g]]) return t[f];
    if (t[f] >= t[g] && pointer[t[f]] >= pointer[t[g]]) return t[g];
    if (cmp(pos[t[f]], pos[pointer[t[f]]], pos[t[g]], pos[pointer[t[g]]])) return t[f];
    return t[g];
}

int decide_winnerU(int f, int g, vector<int> &t, vector<int> &pointer, int n, vector<int> &pos)
{
    if (t[f] == t[g]) return t[f];
    if (pointer[t[f]] == t[f] - 1) return t[g];
    if (pointer[t[g]] == t[g] - 1) return t[f];
    if (t[f] <= t[g] && pointer[t[f]] <= pointer[t[g]]) return t[g];
    if (t[f] >= t[g] && pointer[t[f]] >= pointer[t[g]]) return t[f];
    if (cmp(pos[t[f]], pos[pointer[t[f]]], pos[t[g]], pos[pointer[t[g]]])) return t[g];
    return t[f];
}

std::vector<std::pair<int, int> > solve(int n)
{
    vector<int> p(n);
    iota(p.begin(), p.end(), 0);
    sort(p.begin(), p.end(), [&](int x, int y){
         return cmp(x, x, y, y);
         });
    //for (int i = 0; i < p.size(); i++)
    //    cout << p[i] << " ";
    //cout << endl;
    vector<int> pos(n);
    for (int i = 0; i < p.size(); i++)
        pos[i] = p[i];
    vector<int> pointerD(n);
    iota(pointerD.begin(), pointerD.end(), 0);
    vector<int> pointerU(n, n - 1);
    vector<pair<int, int> > res;

    int sz = 1;
    while (sz < n) sz *= 2;

    int doubled = sz - n;

    vector<int> tD(sz - 1);
    vector<int> tU(sz - 1);
    for (int i = 0; i < doubled; i++)
    {
        tD.push_back(i);
        tD.push_back(i);
        tU.push_back(i);
        tU.push_back(i);
    }
    for (int i = doubled; i < n; i++)
    {
        tD.push_back(i);
        tU.push_back(i);
    }
    for (int i = sz - 2; i >= 0; i--)
    {
        tD[i] = decide_winnerD(2 * i + 1, 2 * i + 2, tD, pointerD, n, pos);
        tU[i] = decide_winnerU(2 * i + 1, 2 * i + 2, tU, pointerU, n, pos);
    }
    //cout << qu << endl;
    int turn = 0;
    vector<pair<int, int> > res1, res2;
    while (res1.size() + res2.size() < n * (n + 1) / 2)
    {
        //cout << "YES" << endl;
        //cout << res1.size() << " " << res2.size() << endl;
        if (res2.size() > n * (n + 1) / 100)
            turn = 0;
        if (turn == 0)
        {
            res2.push_back({pos[tU[0]], pos[pointerU[tU[0]]]});
            pointerU[tU[0]]--;
            int V = 0;
            vector<int> path;
            while (V < sz - 1)
            {
                if (tU[2 * V + 1] == tU[2 * V + 2]) break;
                path.push_back(V);
                if (tU[2 * V + 1] == tU[V]) V = 2 * V + 1;
                else V = 2 * V + 2;
            }
            reverse(path.begin(), path.end());
            for (auto e : path)
            {
                tU[e] = decide_winnerU(2 * e + 1, 2 * e + 2, tU, pointerU, n, pos);
            }
        }
        else
        {
            res1.push_back({pos[tD[0]], pos[pointerD[tD[0]]]});
            pointerD[tD[0]]++;
            int V = 0;
            vector<int> path;
            while (V < sz - 1)
            {
                if (tD[2 * V + 1] == tD[2 * V + 2]) break;
                path.push_back(V);
                if (tD[2 * V + 1] == tD[V]) V = 2 * V + 1;
                else V = 2 * V + 2;
            }
            reverse(path.begin(), path.end());
            for (auto e : path)
            {
                tD[e] = decide_winnerD(2 * e + 1, 2 * e + 2, tD, pointerD, n, pos);
            }
        }
        turn ^= 1;
    }
    reverse(res2.begin(), res2.end());
    for (auto e : res1) res.push_back(e);
    for (auto e : res2) res.push_back(e);
    return res;
}

#ifdef LOCAL
int main()
{
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        x[i] = 3 * i % n;
        //cin >> x[i];
    }
    vector<pair<int, int> > res = solve(n);
    cout << qu << endl;
    for (int i = 0; i < res.size(); i++)
    {
        ;//cout << res[i].first << " " << res[i].second << " " << x[res[i].first] + x[res[i].second] << "\n";
    }
}
#endif // LOCAL
