#include <iostream>
#include <string>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <algorithm>
#include <random>
#include <iomanip>
#include <functional>
#include <cassert>
#include <bitset>
#include <chrono>
 
using namespace std;
 
typedef long long ll;

const int md = 1e9 + 7;

void add(int &a, int b) {
  a += b;
  if (a >= md) a -= md;
}

void sub(int &a, int b) {
  a -= b;
  if (a < 0) a += md;
}

int mul(int a, int b) {
  return ((ll)a * b) % md;
}

int power(int a, ll b) {
  int res = 1;
  while (b > 0) {
    if (b & 1) res = mul(res, a);
    a = mul(a, a);
    b >>= 1;
  }
  return res;
}

int inv(int x) {
  return power(x, md - 2);
}

const int N = 50 * 50 + 7;
int pw[N];
int f[N];

void init() {
  pw[0] = 1;
  for (int i = 1; i < N; ++i) pw[i] = mul(pw[i - 1], 2);
  f[0] = 1;
  for (int i = 1; i < N; ++i) f[i] = mul(f[i - 1], i);
}
 
int main() {
  ios_base::sync_with_stdio(false); cin.tie(0);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  init();
  int n, m;
  cin >> n >> m;
  if (n > m) swap(n, m);
  int ans = 0;
  if (n * m <= 20) {
    for (int mask = 0; mask < (1 << (n * m)); ++mask) {
      vector <vector <int>> a(n, vector <int> (m));
      for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
          a[i][j] = (mask >> (i * m + j)) & 1;
        }
      }
      vector <int> cntr(n), cntc(m);
      for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
          if (a[i][j]) ++cntr[i];
          if (a[i][j]) ++cntc[j];
        }
      }
      bool ok = true;
      for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
          if (a[i][j]) {
            if (cntr[i] == 1 && cntc[j] == 1) ok = false;
          } 
          if (!a[i][j]) {
            if (cntr[i] == m - 1 && cntc[j] == n - 1) ok = false;
          }
        }
      }
      if (ok) ++ans;
    }
  } else if (n >= 2) {
    vector <int> dp(n + 1);
    dp[0] = 1;
    for (int i = 1; i <= n; ++i) {
      dp[i] = dp[i - 1];
      dp[i] = mul(dp[i - 1], mul(n - i + 1, m - i + 1));
    }
    for (int i = 1; i <= n; ++i) {
      dp[i] = mul(dp[i], inv(f[i]));
    }
    
    int bad = 0;
    for (int cnt = 1; cnt <= n; ++cnt) {
      int free = (n - cnt) * (m - cnt); 
      int cur = mul(dp[cnt], pw[free]);
      if (cnt % 2 == 0) sub(bad, cur);
      else add(bad, cur);
    }
    bad = mul(bad, 2);
    ans = pw[n * m];
    sub(ans, bad);
    if (n == 2) add(ans, n * m);
  } else if (n == 1) {
    ans = pw[m];
    sub(ans, m);
    sub(ans, m);
  } 
  cout << ans << '\n';
}
