﻿#include "sqsort.h"
#include <algorithm>
//#include <set>
//#include <unordered_map>

using namespace std;

int N;

bool comp1(int a, int b) {
	return cmp(a, 0, b, 0);
}

bool comp2(pair <int, int> a, pair <int, int> b) {
	return cmp(a.first, a.second, b.first, b.second);
}

vector <int> ans1;

bool comp3(pair <int, int> a, pair <int, int> b) {
	if (min(a.first, a.second) == min(b.first, b.second))
		return max(a.first, a.second) < max(b.first, b.second);
	if (max(a.first, a.second) == max(b.first, b.second))
		return min(a.first, a.second) < min(b.first, b.second);
	if (max(a.first, a.second) == min(b.first, b.second))
		return true;
	if (min(a.first, a.second) == max(b.first, b.second))
		return false;
	return comp2({ans1[a.first], ans1[a.second]}, {ans1[b.first], ans1[b.second]});
}

bool table[2000][2000];

int indexer[2000];

std::vector<std::pair<int, int>> solve(int n) {
	N = n;
	ans1.resize(n);
	for (int i = 0; i < n; ++i) {
		ans1[i] = i;
	}
	sort(ans1.begin(), ans1.end(), comp1);
	for (int i = 0; i < n; ++i)
		indexer[i] = i;
	int index = 0;
	vector <pair <int, int>> sorter;
	for (int i = 0; i < n; ++i) {
		while (indexer[i] < n) {
			if (i == n - 1) {
				table[n - 1][n - 1] = n * (n + 1) - 1;
				break;
			}
			int j = i + 1;
			while (indexer[j] < indexer[j - 1]) {
				++j;
			}
			--j;
			while (j > i) {
				sorter.push_back({ j, indexer[j] });
				++indexer[j];
				if (indexer[j] - j == indexer[i] - i + 1){
					--j;
				}
			}
			sorter.push_back({ i, indexer[i] });
			++indexer[i];
			sort(sorter.begin(), sorter.end(), comp3);
			for (auto el : sorter) {
				table[el.first][el.second] = index;
				++index;
				if (el.first == i)
					break;
			}
		}
	}
	vector <pair <int, int>> answer(n * (n + 1) / 2);
	for (int i = 0; i < n; ++i) {
		for (int j = i; j < n; ++j){
			answer[table[i][j]] = { min(ans1[i], ans1[j]), max(ans1[i], ans1[j]) };
		}
	}
	return answer;
}