#include <iostream>
#include <vector>
#include <queue>
using namespace std;

bool cmp_doorak(pair <int, int> x, pair <int, int> y, vector <int>& d) {
	return d[x.first] + d[x.second] < d[y.first] + d[y.second];
}

vector <pair<int, int> > mergesort(int l, int r, vector <pair <int, int> >& res, vector <int>& d) {
	if (r == l + 1)
		return vector <pair <int, int> >(1, res[l]);
	else {
		int m = (l + r) / 2;
		vector <pair<int, int> > left = mergesort(l, m, res, d);
		vector <pair<int, int> > right = mergesort(m, r, res, d);
		vector <pair <int, int> > ret;
		int i = l, j = m;
		while (i < m && j < r) {
			if (cmp_doorak(left[i], right[j], d)) {
				ret.push_back(left[i]);
				++i;
			}
			else {
				ret.push_back(right[j]);
				++j;
			}
		}
		while (i < m) {
			ret.push_back(left[i]);
			++i;
		}
		while (j < r) {
			ret.push_back(right[j]);
			++j;
		}
		return ret;
	}
}

vector <pair<int, int> > solve(int n) {
	vector <vector <int> > g(n);
	vector <int> ka4(n, 0);
	vector <pair <int, int> > res;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (cmp(i, i, j, j)) {
				g[i].push_back(j);
				++ka4[i];
			}
			if (j >= i)
				res.push_back(make_pair(i, j));
		}
	}
	const int inff = 1000006;
	vector <int> d(n, inff);
	queue <int> q;
	for (int i = 0; i < n; ++i) {
		if (ka4[i] == 0) {
			d[i] = 0;
			q.push(i);
		}
	}
	while (!q.empty()) {
		int u = q.front();
		q.pop();
		for (int v : g[u]) {
			if (d[v] == inff) {
				d[v] = d[u] + 1;
				q.push(v);
			}
		}
	}
	return mergesort(0, res.size(), res, d);
}