#include <vector>
#include <queue>
#include "sqsort.h"
using namespace std;

bool cmp_doorak(pair <int, int> x, pair <int, int> y, vector <int>& d) {
	return d[x.first] + d[x.second] < d[y.first] + d[y.second];
}

vector <pair<int, int> > mergesort(int l, int r, vector <pair <int, int> >& res, vector <int>& d) {
	if (r == l + 1)
		return vector <pair <int, int> >(1, res[l]);
	else {
		int m = (l + r) / 2;
		vector <pair<int, int> > left = mergesort(l, m, res, d);
		vector <pair<int, int> > right = mergesort(m, r, res, d);
		vector <pair <int, int> > ret;
		int i = 0, j = 0;
		while (i < left.size() && j < right.size()) {
			if (cmp_doorak(left[i], right[j], d)) {
				ret.push_back(left[i]);
				++i;
			}
			else {
				ret.push_back(right[j]);
				++j;
			}
		}
		while (i < left.size()) {
			ret.push_back(left[i]);
			++i;
		}
		while (j < right.size()) {
			ret.push_back(right[j]);
			++j;
		}
		return ret;
	}
}

void dfs(int root, vector <int>& g, deque <int>& topsort, vector <bool>& used;) {
	used[root] = 1;
	for (int v : g[root]) {
		if (!used[v])
			dfs(v, g, topsort, used);
	}
	topsort.push_front(root);
}

vector <pair<int, int> > solve(int n) {
	vector <vector <int> > g(n);
	vector <int> ka4(n, 0);
	vector <pair <int, int> > res;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (cmp(i, i, j, j)) {
				g[i].push_back(j);
				++ka4[i];
			}
			if (j >= i)
				res.push_back(make_pair(i, j));
		}
	}
	vector <int> d(n);
	vector <bool> used(n, 0); 
	for (int i = 0; i < n; ++i) {
		if (!used[i] && ka4[i] == 0) {
			deque <int> topsort;
			dfs(i, g, topsort, used);
			for (int j = 0; j < topsort.size(); ++j)
				d[topsort[j]] = j;
		}
	}
	return mergesort(0, res.size(), res, d);
}