#include <vector>
#include <queue>
#include "sqsort.h"
using namespace std;

bool cmp_doorak(pair <int, int> x, pair <int, int> y) {
	return cmp(x.first, x.second, y.first, y.second);
}

vector <pair<int, int> > mergesort(int l, int r, vector <pair <int, int> >& res) {
	if (r == l + 1)
		return vector <pair <int, int> >(1, res[l]);
	else {
		int m = (l + r) / 2;
		vector <pair<int, int> > left = mergesort(l, m, res);
		vector <pair<int, int> > right = mergesort(m, r, res);
		vector <pair <int, int> > ret;
		int i = 0, j = 0;
		while (i < left.size() && j < right.size()) {
			if (cmp_doorak(left[i], right[j])) {
				ret.push_back(left[i]);
				++i;
			}
			else {
				ret.push_back(right[j]);
				++j;
			}
		}
		while (i < left.size()) {
			ret.push_back(left[i]);
			++i;
		}
		while (j < right.size()) {
			ret.push_back(right[j]);
			++j;
		}
		return ret;
	}
}

vector <pair<int, int> > solve(int n) {
	vector <vector <int> > g(n);
	vector <int> ka4(n, 0);
	vector <pair <int, int> > res;
	for (int i = 0; i < n; ++i) {
		for (int j = i; j < n; ++j) 
			res.push_back(make_pair(i, j));
	}
	return mergesort(0, res.size(), res);
}