#include "sqsort.h"

void merge(std::vector<std::pair<int, int>> &pairs, int l, int r) {
    if (r - l <= 1) return;
    int m = (l + r) / 2;
    int pos1 = 0, pos2 = 0;
    std::pair<int, int> temp[r - l];
    while (pos1 + l < m && pos2 + m < r) {
        if (cmp(pairs[pos1].first, pairs[pos1].second,
                pairs[pos2].first, pairs[pos2].second)) {
            temp[pos1 + pos2] = std::make_pair(pairs[pos1].first, pairs[pos1].second);
            pos1++;
        } else {
            temp[pos1 + pos2] = std::make_pair(pairs[pos2].first, pairs[pos2].second);
            pos2++;
        }
    }
    while (pos1 + l < m) {
        temp[pos1 + pos2] = std::make_pair(pairs[pos1].first, pairs[pos1].second);
        pos1++;
    }
    while (pos2 + m < r) {
        temp[pos1 + pos2] = std::make_pair(pairs[pos2].first, pairs[pos2].second);
        pos2++;
    }
    for (int i = 0; i < r - l; i++) {
        pairs[i + l] = temp[i];
    }
    delete temp;
}

void merge_sort(std::vector<std::pair<int, int>> &pairs, int l, int r) {
    if (r - l <= 1) return;
    merge_sort(pairs, l, (l + r) / 2);
    merge_sort(pairs, (l + r) / 2, r);
    merge(pairs, l, r);
}

std::vector<std::pair<int, int>> solve(int n) {
    std::vector<std::pair<int, int>> pairs;
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            pairs.push_back(std::make_pair(i, j));
        }
    }
    merge_sort(pairs, 0, n);
    return pairs;
}

//std::vector<std::pair<int, int>> solve(int n) {
//    std::vector<std::pair<int, int>> pairs;
//    for (int i = 0; i < n; i++) {
//        for (int j = i; j < n; j++) {
//            pairs.push_back(std::make_pair(i, j));
//        }
//    }
//    int sz = (int) pairs.size();
//    for (int i = sz - 1; i >= 1; i--) {
//        for (int j = i - 1; j >= 0; j--) {
//            if (cmp(pairs[i].first, pairs[i].second,
//                    pairs[j].first, pairs[j].second)) {
//                std::swap(pairs[i], pairs[j]);
//            }
//        }
//    }
//    return pairs;
//}