#include "sqsort.h"
#include "set"
#include "map"

map<std::pair<int, int>, set<std::pair<int, int>>> more;

void merge(std::vector<std::pair<int, int>> &pairs, int l, int r) {
    if (r - l <= 1) return;
    int m = (l + r) / 2;
    int pos1 = 0, pos2 = 0;
    std::pair<int, int> temp[r - l];
    while (pos1 + l < m && pos2 + m < r) {
        if (more.count(pairs[l + pos1]) && more[pairs[l + pos1]].count(pairs[m + pos2])) {
            temp[pos1 + pos2] = std::make_pair(pairs[l + pos1].first, pairs[l + pos1].second);
            pos1++;
            continue;
        }
        if (more.count(pairs[m + pos2]) && more[pairs[m + pos2]].count(pairs[l + pos1])) {
            temp[pos1 + pos2] = std::make_pair(pairs[m + pos2].first, pairs[m + pos2].second);
            pos2++;
            continue;
        }
        if (cmp(pairs[l + pos1].first, pairs[l + pos1].second,pairs[m + pos2].first, pairs[m + pos2].second)) {
            temp[pos1 + pos2] = std::make_pair(pairs[l + pos1].first, pairs[l + pos1].second);
            if (!more.count(pairs[l + pos1])) more[pairs[l + pos1]] = set<std::pair<int, int>> ();
            more[pairs[l + pos1]].insert(pairs[m + pos2]);
            pos1++;
        } else {
            temp[pos1 + pos2] = std::make_pair(pairs[m + pos2].first, pairs[m + pos2].second);
            if (!more.count(pairs[m + pos2])) more[pairs[m + pos2]] = set<std::pair<int, int>> ();
            more[pairs[m + pos2]].insert(pairs[l + pos1]);
            pos2++;
        }
    }
    while (pos1 + l < m) {
        temp[pos1 + pos2] = std::make_pair(pairs[l + pos1].first, pairs[l + pos1].second);
        pos1++;
    }
    while (pos2 + m < r) {
        temp[pos1 + pos2] = std::make_pair(pairs[m + pos2].first, pairs[m + pos2].second);
        pos2++;
    }
    for (int i = 0; i < r - l; i++) {
        pairs[i + l] = {temp[i].first, temp[i].second};
    }
}

void merge_sort(std::vector<std::pair<int, int>> &pairs, int l, int r) {
    if (r - l <= 1) return;
    merge_sort(pairs, l, (l + r) / 2);
    merge_sort(pairs, (l + r) / 2, r);
    merge(pairs, l, r);
}

std::vector<std::pair<int, int>> solve(int n) {
    std::vector<std::pair<int, int>> pairs;
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            pairs.push_back(std::make_pair(i, j));
        }
    }
    merge_sort(pairs, 0, (int) pairs.size());
    return pairs;
}