#include "sqsort.h"

std::vector<std::vector<int>> compare(2005, std::vector<int> (2005));

void merge(std::vector<std::pair<int, int>> &pairs, int l, int r) {
    if (r - l <= 1) return;
    int m = (l + r) / 2;
    int pos1 = 0, pos2 = 0;
    std::pair<int, int> temp[r - l];
    while (pos1 + l < m && pos2 + m < r) {
        if (compare[pairs[l + pos1].first][pairs[m + pos2].first] && compare[pairs[l + pos1].second][pairs[m + pos2].second]) {
            temp[pos1 + pos2] = std::make_pair(pairs[l + pos1].first, pairs[l + pos1].second);
            pos1++;
            continue;
        }
        if (compare[pairs[l + pos1].first][pairs[m + pos2].second] && compare[pairs[l + pos1].second][pairs[m + pos2].first]) {
            temp[pos1 + pos2] = std::make_pair(pairs[l + pos1].first, pairs[l + pos1].second);
            pos1++;
            continue;
        }
        if (compare[pairs[m + pos2].first][pairs[l + pos1].first] && compare[pairs[m + pos2].second][pairs[l + pos1].second]) {
            temp[pos1 + pos2] = std::make_pair(pairs[m + pos2].first, pairs[m + pos2].second);
            pos2++;
            continue;
        }
        if (compare[pairs[m + pos2].first][pairs[l + pos1].second] && compare[pairs[m + pos2].second][pairs[l + pos1].first]) {
            temp[pos1 + pos2] = std::make_pair(pairs[m + pos2].first, pairs[m + pos2].second);
            pos2++;
            continue;
        }
        if (!compare[pairs[l + pos1].first][pairs[m + pos2].first] && !compare[pairs[l + pos1].second][pairs[m + pos2].second]) {
            temp[pos1 + pos2] = std::make_pair(pairs[m + pos2].first, pairs[m + pos2].second);
            pos2++;
            continue;
        }
        if (!compare[pairs[l + pos1].first][pairs[m + pos2].second] && !compare[pairs[l + pos1].second][pairs[m + pos2].first]) {
            temp[pos1 + pos2] = std::make_pair(pairs[m + pos2].first, pairs[m + pos2].second);
            pos2++;
            continue;
        }
        if (!compare[pairs[m + pos2].first][pairs[l + pos1].first] && !compare[pairs[m + pos2].second][pairs[l + pos1].second]) {
            temp[pos1 + pos2] = std::make_pair(pairs[l + pos1].first, pairs[l + pos1].second);
            pos1++;
            continue;
        }
        if (compare[pairs[m + pos2].first][pairs[l + pos1].second] && compare[pairs[m + pos2].second][pairs[l + pos1].first]) {
            temp[pos1 + pos2] = std::make_pair(pairs[l + pos1].first, pairs[l + pos1].second);
            pos1++;
            continue;
        }
        if (cmp(pairs[l + pos1].first, pairs[l + pos1].second,pairs[m + pos2].first, pairs[m + pos2].second)) {
            temp[pos1 + pos2] = std::make_pair(pairs[l + pos1].first, pairs[l + pos1].second);
            pos1++;
        } else {
            temp[pos1 + pos2] = std::make_pair(pairs[m + pos2].first, pairs[m + pos2].second);
            pos2++;
        }
    }
    while (pos1 + l < m) {
        temp[pos1 + pos2] = std::make_pair(pairs[l + pos1].first, pairs[l + pos1].second);
        pos1++;
    }
    while (pos2 + m < r) {
        temp[pos1 + pos2] = std::make_pair(pairs[m + pos2].first, pairs[m + pos2].second);
        pos2++;
    }
    for (int i = 0; i < r - l; i++) {
        pairs[i + l] = {temp[i].first, temp[i].second};
    }
}

void merge_sort(std::vector<std::pair<int, int>> &pairs, int l, int r) {
    if (r - l <= 1) return;
    merge_sort(pairs, l, (l + r) / 2);
    merge_sort(pairs, (l + r) / 2, r);
    merge(pairs, l, r);
}

std::vector<std::pair<int, int>> solve(int n) {
    std::vector<std::pair<int, int>> pairs;
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            pairs.push_back(std::make_pair(i, j));
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            bool x = cmp(0, i, 0, j);
            compare[i][j] = x;
            compare[j][i] = !x;
        }
    }
    merge_sort(pairs, 0, (int) pairs.size());
    return pairs;
}