#include "sqsort.h"
using namespace std;
const int MAX_N = 5e6 + 7;
set<int> g[MAX_N];

bool cmp(int a, int b, int c, int d);

std::vector<std::pair<int, int>> solve(int n) {
    int step[n * n];
    fill(step, step + n * n, 0);
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            for (int k = i; k < n; ++k) {
                for (int t = i; t < n; ++t) {
                    if (cmp(i, j, k, t)) {
                        g[i * n + j].insert(k * n + t);
                        g[i * n + j].insert(t * n + k);
                        g[j * n + i].insert(k * n + t);
                        g[j * n + i].insert(t * n + k);
                        step[k * n + t] += 2;
                        step[t * n + k] += 2;
                    } else {
                        g[k * n + t].insert(i * n + j);
                        g[k * n + t].insert(j * n + i);
                        g[t * n + k].insert(i * n + j);
                        g[t * n + k].insert(j * n + i);
                        step[i * n + j] += 2;
                        step[j * n + i] += 2;
                    }
                }
            }
        }
    }
    set<pair<int, int> > st;
    for (int i = 0; i < n * n; ++i) {
        st.insert({step[i], i});
    }
    set<pair<int, int>> used;
    vector<pair<int, int>> ans;
    while (!st.empty()) {
        pair<int, int> val = *st.begin();
        st.erase(val);
        int v = val.second;
        int x = v / n, y = v % n;
        if (used.count({x, y}) || used.count({y, x}))continue;
        ans.push_back({x, y});
        used.insert({x, y});
        for (int to : g[v]) {
            x = to / n, y = to % n;
            int other = y * n + x;
            st.erase({step[to], to});
            st.erase({step[other], other});
            step[to] -= 2, step[other] -= 2;
            st.insert({step[to], to});
            st.insert({step[other], other});
        }
    }
    return ans;
}
