#include "sqsort.h"
#include "bits/stdc++.h"

using namespace std;

bool cmp(int a, int b, int c, int d);

std::vector<std::pair<int, int>> solve(int n) {
    int step[n * n];
    vector<pair<int, int>> a;
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            a.push_back({i, j});
        }
    }
    set<int> g[n * n];
    fill(step, step + n * n, 0);
    for (int e = 0; e < n * n; ++e) {
        for (int r = e; r < n * n; ++r) {
            int i = a[e].first, j = a[e].second, k = a[r].first, t = a[r].second;
            if (cmp(i, j, k, t)) {
                g[i * n + j].insert(k * n + t);
                g[i * n + j].insert(t * n + k);
                g[j * n + i].insert(k * n + t);
                g[j * n + i].insert(t * n + k);
                step[k * n + t] += 2;
                step[t * n + k] += 2;
            } else {
                g[k * n + t].insert(i * n + j);
                g[k * n + t].insert(j * n + i);
                g[t * n + k].insert(i * n + j);
                g[t * n + k].insert(j * n + i);
                step[i * n + j] += 2;
                step[j * n + i] += 2;
            }
        }
    }
    set<pair<int, int> > st;
    for (int i = 0; i < n * n; ++i) {
        st.insert({step[i], i});
    }
    set<pair<int, int>> used;
    vector<pair<int, int>> ans;
    while (!st.empty()) {
        pair<int, int> val = *st.begin();
        st.erase(val);
        int v = val.second;
        int x = v / n, y = v % n;
        if (used.count({x, y}) || used.count({y, x}))continue;
        ans.push_back({x, y});
        used.insert({x, y});
        for (int to : g[v]) {
            x = to / n, y = to % n;
            int other = y * n + x;
            st.erase({step[to], to});
            st.erase({step[other], other});
            step[to] -= 2, step[other] -= 2;
            st.insert({step[to], to});
            st.insert({step[other], other});
        }
    }
    return ans;
}

/*
void gen() {
    n = rand() % 100 + 10;
    z.resize(n);
    for (int i = 0; i < n; ++i) {
        z[i] = rand();
    }
}
*/

/*
signed main() {
    while (true) {
        gen();
        // z[0] = 1, z[1] = 2, z[2] = 4, z[3] = 0;
        vector<pair<int, int>> ans = solve(n);
        int f = z[ans[0].first] + z[ans[0].second];
        for (int i = 1; i < ans.size(); ++i) {
            if (f > z[ans[i].first] + z[ans[i].second]) {
                for (int j = 0; j < n; ++j) {
                    cout << z[j] << " ";
                }
                cout << endl;
                for (int j = 0; j < ans.size(); ++j) {
                    cout << ans[j].first << " " << ans[j].second << endl;
                }
                exit(0);
            }
        }
    }
}*/
