//#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,abm,mmx,popcnt")
#define _GLIBCXX_DEBUG
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ldb;

const int INF = 1e9 + 228;

int solve(vector<int> &arr, int K) {
    int n = arr.size();
    vector<vector<vector<int>>> dp(n + 1);
    dp[0].resize(n + 1, vector<int> (n + 1, -INF));
    dp[0][0][0] = 0;
    for (int i = 1; i <= n; i++) {
        if (i >= 3) {
            vector<vector<int>>().swap(dp[i - 3]);
        }
        dp[i].resize(n + 1, vector<int> (n + 1, -INF));
        for (int j = 0; j <= n; j++) {
            for (int k = 0; k <= n; k++) {
                // take new
                if (i >= 2 && j >= 1 && k >= 1) {
                    dp[i][j][k] = max(dp[i][j][k], dp[i - 2][j - 1][k - 1] + arr[i - 1]);
                }
                // take old
                if (i >= 1 && j >= 1 && k >= 1) {
                    dp[i][j][k] = max(dp[i][j][k], dp[i - 1][j - 1][k] + arr[i - 1]);
                }
                // not take
                if (true) {
                    dp[i][j][k] = max(dp[i][j][k], dp[i - 1][j][k]);
                }
            }
        }
    }
    int ans = 0;
    for (int j = 0; j <= n; j++) {
        for (int k = 0; k <= n; k++) {
            int need = (j - k) * K;
            int fre = (n - j + k);
            if (need <= fre) {
                ans = max(ans, dp.back()[j][k]);
            }
        }
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, k;
    cin >> n >> k;
    vector<int> t(n), l(n);
    for (int i = 0; i < n; i++) {
        cin >> t[i] >> l[i];
    }
    vector<int> revt(n);
    for (int i = 0; i < n; i++) {
        revt[t[i]] = i;
    }
    vector<int> arr;
    int cur = 0;
    while (cur != n - 1) {
        arr.push_back(l[cur]);
        cur = t[cur];
    }
    cout << solve(arr, k) << endl;
}


/*
8 2
5 12
6 111
4 101
0 13
1 105
7 14
2 108
3 9
*/
