//#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,abm,mmx,popcnt")
#define _GLIBCXX_DEBUG
#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ldb;

const int INF = 1e9 + 228;

int solve2(int n, int K, vector<int> t, vector<int> l) {
    vector<int> arr;
    int cur = 0;
    while (arr.size() != n - 1) {
        arr.push_back(l[cur]);
        cur = t[cur];
    }
    n--;
    vector<vector<vector<int>>> dp(n + 1);
    dp[0].resize(n + 1, vector<int> (n + 1, -INF));
    dp[1].resize(n + 1, vector<int> (n + 1, -INF));
    dp[0][0][0] = 0;
    dp[1][0][0] = 0;
    dp[1][1][1] = arr[0];
    for (int i = 2; i <= n; i++) {
        if (i >= 3) {
            vector<vector<int>>().swap(dp[i - 3]);
        }
        dp[i].resize(n + 1, vector<int> (n + 1, -INF));
        for (int j = 0; j <= n; j++) {
            for (int k = 0; k <= n; k++) {
                // take new
                if (i >= 2 && j >= 1 && k >= 1) {
                    dp[i][j][k] = max(dp[i][j][k], dp[i - 2][j - 1][k - 1] + arr[i - 1]);
                }
                // take old
                if (i >= 1 && j >= 1 && k >= 1) {
                    dp[i][j][k] = max(dp[i][j][k], dp[i - 1][j - 1][k] + arr[i - 1]);
                }
                // not take
                if (true) {
                    dp[i][j][k] = max(dp[i][j][k], dp[i - 1][j][k]);
                }
            }
        }
    }
    int ans = 0;
    for (int j = 0; j <= n; j++) {
        for (int k = 0; k <= n; k++) {
            int need = (j - k) * K;
            int fre = (n + 1 - j - k);
            if (need <= fre) {
                ans = max(ans, dp.back()[j][k]);
            }
        }
    }
    return ans;
}

int solve1(int n, int k, vector<int> t, vector<int> l) {
    vector<int> revt(n);
    for (int i = 0; i < n; i++) {
        revt[t[i]] = i;
    }
    int ans = 0;
    for (int mask = 0; mask < (1 << n); mask++) {
        bool bad = false;
        int cur_cost = 0;
        int nott = 0;
        int need = 0;
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) {
                cur_cost += l[i];
                if (mask & (1 << revt[i])) {
                    need += k;
                }
                if ((mask & (1 << t[i]))==0)
                    nott--;
            } else {
                nott++;
            }
        }
        if (bad)
            continue;

        if (need <= nott)
            ans = max(ans, cur_cost);
    }
    return ans;
}

/*mt19937 rd(179);
int randint(int a, int b) {
    return rd() % (b - a + 1) + a;
}


void stress() {
    while (true) {
        int n = randint(2, 5);
        int k = randint(1, n / 2);
        vector<int> t2(n);
        iota(t2.begin(), t2.end(), 0);
        shuffle(t2.begin() + 1, t2.end(), rd);
        vector<int> t(n);
        for (int i = 0; i < n; i++) {
            t[t2[i]] = t2[(i + 1) % n];
        }
        vector<int> l(n);
        for (int i = 0; i < n; i++) {
            l[i] = randint(0, 10);
        }
        l[t2.back()] = 0;
        int ans1 = solve1(n, k, t, l);
        int ans2 = solve2(n, k, t, l);
        if (ans1 != ans2) {
            cout << "WA" << endl;
            cout << n << " " << k << endl;
            for (int i = 0; i < n; i++) {
                cout << t[i] << " " << l[i] << endl;
            }
            cout << "Correct:" << endl;
            cout << ans1 << endl;
            cout << "Bad:" << endl;
            cout << ans2 << endl;
            exit(0);
        }
        cout << "OK" << endl;
    }
}*/

int main() {
    //stress();
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, k;
    cin >> n >> k;
    vector<int> t(n), l(n);
    for (int i = 0; i < n; i++) {
        cin >> t[i] >> l[i];
    }
    int ans2 = solve2(n, k, t, l);
    cout << ans2 << endl;
}


/*
8 2
5 12
6 111
4 101
0 13
1 105
7 14
2 108
3 9
*/
