#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,abm,mmx,popcnt")
#include <iostream>
#include <vector>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ldb;

int ANS = -1;

clock_t start_time;

void solve_stupid(int n, int m) {
    if (n * m > 25) {
        cout << ANS << endl;
        return  0;
    }
    int ans = 0;
    int cntbad = 0;
    for (int mask = 0; mask < (1 << (n * m)); mask++) {
        if (clock() - start_time > CLOCKS_PER_SEC * 0.2) {
            cout << ANS << endl;
            exit(0);
        }
        vector<vector<int>> arr(n, vector<int> (m));
        for (int i = 0; i < n * m; i++) {
            if (mask & (1 << i)) {
                arr[i / m][i % m] = 1;
            }
        }
        bool bad = false;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                int cnt1 = 0;
                for (int i1 = 0; i1 < n; i1++) {
                    if (i1 == i)
                        continue;
                    if (arr[i][j] == arr[i1][j])
                        cnt1++;
                }
                for (int j1 = 0; j1 < m; j1++) {
                    if (j1 == j)
                        continue;
                    if (arr[i][j] == arr[i][j1]) {
                        cnt1++;
                    }
                }
                if (!cnt1) {
                    bad = true;
                    cntbad++;
                }
            }
        }
        if (!bad)
            ans++;
    }
    cout << ans << endl;;
}

const int MOD = 1e9 + 7;

int mul(int a, int b) {
    return 1LL * a * b % MOD;
}

int add(int a, int b) {
    return (a + b) % MOD;
}

int sub(int a, int b) {
    return (a - b + MOD) % MOD;
}

int pow(int a, int b) {
    int ans = 1;
    while (b) {
        if (b & 1) {
            ans = mul(ans, a);
        }
        b >>= 1;
        a = mul(a, a);
    }
    return ans;
}

int divv(int a, int b) {
    return mul(a, pow(b, MOD - 2));
}

int fact(int n) {
    int ans = 1;
    for (int i = 1; i <= n; i++) {
        ans = mul(ans, i);
    }
    return ans;
}

int C(int n, int k) {
    return divv(fact(n), mul(fact(k), fact(n - k)));
}

int solve2(int n, int m) {
    int ans = 0;
    for (int k = 1; k <= min(n, m); k++) {
        int sign = 1;
        if (k % 2 == 0)
            sign = MOD-1;
        int kek = pow(2, (n - k) * (m - k));
        kek = mul(kek, C(n, k));
        kek = mul(kek, C(m, k));
        kek = mul(kek, fact(k));
        kek = mul(kek, sign);
        ans = add(ans, kek);
    }
    int b = pow(2, n * m);
    ans = sub(b, mul(2, ans));
    return ans;
}

int main() {
    start_time = clock();
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    //n = m = 3;
    ANS = solve2(n, m);
    solve_stupid(n, m);
}
