#include <vector>
#include <algorithm>
#include <map>
#include <set>

#include "sqsort.h"

using namespace std;

using ll = long long;
using vl = vector<ll>;
using vvl = vector<vl>;

vector<pair<int, int> > solve(int n) {
	// at first I need to find the maximum value - I can do it with O(n)
	vector<int> a(n, -1);
	vector<bool> used(n, 0);
	for (int _count = 0; _count < n; ++_count) {
		ll cur_max = -1;
		for (int i = 0; i < n; ++i) {
			if (!used[i]) {
				if (cur_max == -1) {
					cur_max = i;
				}
				else {
					if (cmp(0, cur_max, 0, i)) {
						cur_max = i;
					}
				}
			}
		}
		a[n - 1 - _count] = cur_max;
		used[cur_max] = 1;
	}
	// sorted: A[a[0]] <= A[a[1]] <= ... <= A[a[n-1]];
	vector<pair<int, int> > answer(0);
	vector<int> ptr(n);
	for (int i = 0; i < n; ++i) {
		ptr[i] = i;
	}
	for (int i = 0; i < n; ++i) {
		answer.emplace_back(a[i], a[i]);
		if (i == n - 1) {
			break;
		}
		pair<ll, ll> cur_min = { -1, -1 };
		while (cur_min.first != cur_min.second) {
			pair<ll, ll> cur_min = { i + 1, i + 1 };
			for (int j = 0; j <= i; ++j) {
				if (ptr[j] != n) {
					if (cmp(a[j], a[ptr[j]], a[cur_min.first], a[cur_min.second])) {
						cur_min = { j, ptr[j] };
					}
				}
			}
			if (cur_min.first != cur_min.second) {
				++ptr[cur_min.first];
			}
			answer.emplace_back(a[cur_min.first], a[cur_min.second]);
		}
		answer.emplace_back(a[i + 1], a[i + 1]);
	}
	return answer;
}