#include "sqsort.h"
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,sse4")
//#define int long long
#define pii pair<int, int>
#define x first
#define y second
#define all(a) (a.begin()), (a.end())

using namespace std;

const int N = 2e3 + 10;

map<pair<pii, pii>, bool> mp;
//bool ls[N][N][2];

bool mycmp(const pii &p1, const pii &p2)
{
//	if (ls[p1.x][p2.x][0] && ls[p1.y][p2.y][1])
	//	return true;

//	if (!ls[p1.x][p2.x][0] && !ls[p1.y][p2.y][1])
	//	return false;

	if (mp.find(make_pair(p1, p2)) != mp.end())
		return mp[make_pair(p1, p2)];

	return mp[make_pair(p1, p2)] = cmp(p1.x, p1.y, p2.x, p2.y);
}

void preproc(int n)
{
	vector<pii> v1(n);
	vector<pii> v2(n);

	for (int i = 0; i < n; ++i)
	{
		v1[i] = { 0, i };
		v2[i] = { i, 0 };
	}

	stable_sort(all(v1), mycmp);
	stable_sort(all(v2), mycmp);

	for(int i = 0; i < n; ++i)
		for (int j = i; j < n; ++j)
		{
			int ind1 = v1[i].y;
			int ind2 = v1[j].y;
			ls[ind1][ind2][0] = true;
			ls[ind2][ind1][0] = false;
			ind1 = v2[i].x;
			ind2 = v2[j].x;
			ls[ind1][ind2][1] = true;
			ls[ind2][ind1][1] = false;
		}
}

std::vector<std::pair<int, int>> solve(int n)
{
	preproc(n);
	vector<pii> rv;

	rv.reserve(n * (n + 1) / 2 + 10);

	for (int i = 0; i < n; ++i)
		for (int j = i; j < n; ++j)
			rv.emplace_back(i, j);

	stable_sort(all(rv), mycmp);

	return move(rv);
}