#include <bits/stdc++.h>
#include<limits.h>
using namespace std;
const int INF = 2*1e9;
const int NMAX = 2*1e4 +5;
struct Dinic{
	struct Edge{
		int x;
		int f,cap;
		int rev;
	};
	vector<vector<Edge>> gr;
	vector<int> ind;
	vector<int> lvl;
	int S, D;
	int n;
	Dinic(int _n,int _S,int _D){
		n = _n;
		gr.resize(n+1, vector<Edge>(0));
		ind.resize(n+1,0);
		lvl.resize(n+1,0);
		S = _S;
		D = _D;
	}
	bool bfs_level(){
		queue<int> q;
		for(int i=1;i<=n;i++){
			lvl[i] = -1;
		}
		q.push(S);
		lvl[S] = 0;
		while(q.size()){
			int nod = q.front();
			q.pop();
			for(auto x:gr[nod]){
				if(lvl[x.x] == -1 && x.f<x.cap){
					q.push(x.x);
					lvl[x.x] = lvl[nod] + 1;
				}
			}
		}
		if(lvl[D] == -1)
			return false;
		return true;
	}
	int dfs_sflow(int nod,int cflow){
		if(nod == D)
			return cflow;
		if(cflow == 0)
			return 0;
		for(int i = ind[nod];i<gr[nod].size();i++,ind[nod]++){
			auto vec = gr[nod][i];
			if(lvl[vec.x] == lvl[nod] + 1 ){
				int snt = dfs_sflow(vec.x,min(cflow, vec.cap - vec.f));
				if(snt > 0){
					gr[nod][i].f+=snt;
					gr[vec.x][vec.rev].f -= snt;
					return snt;
				}
			}
		}
		return 0;
	}
	void add_edge(int x,int y,int cap){
		int xpoz = gr[x].size();
		int ypoz = gr[y].size();
		gr[x].push_back({y, 0, cap, ypoz});
		gr[y].push_back({x, 0, 0, xpoz});
	}
	int maxflow(){
		int flow = 0;
		while(bfs_level()){
			for(int i=1;i<=n;i++)
				ind[i] = 0;
			int newflow = 0;
			while((newflow = dfs_sflow(S, INF)) > 0){
				flow += newflow;
			}
		}
		return flow;
	}
};
const int N = 1e4+5;
int t[N],l[N];
int main()
{
	freopen(".in","r",stdin);
	int n, k;
	cin>>n>>k;
	for(int i=1;i<=n;i++){
		cin>>t[i]>>l[i];
		t[i]++;
	}
	int s= 5*n+1, d= 5*n+2;
	Dinic netw(5*n + 3, s, d);
	for(int i=1;i<=n;i++){
		netw.add_edge(s, i, k*NMAX);
		netw.add_edge(i, i+3*n, k*NMAX);
		netw.add_edge(i, i+4*n, NMAX);
	}
	for(int i=1;i<=n;i++){
		netw.add_edge(i+n,i+2*n, 2*k*NMAX);
		netw.add_edge(i+2*n, d, l[i]);
	}
	for(int i=1;i<=n;i++){
		for(int j=1;j<=n;j++){
			if(j == i || t[j] == i){
				netw.add_edge(i +3*n, n+j, k*NMAX);
			}
			else{
				netw.add_edge(i + 4*n, n+j, NMAX);
			}
		}
	}
	cout<<netw.maxflow();
	return 0;
}
