#include <bits/stdc++.h>

//#define HOME


#ifndef HOME
#include "sqsort.h"
#endif // HOME


#ifdef HOME
static const int HARD_LIMIT = 50000000;

static int n;
static std::vector<int> a;

static bool valid_pos(int i) {
	return 0 <= i && i < n;
}

static int Q;
bool cmp(int a_, int b, int c, int d) {
	if(!valid_pos(a_) || !valid_pos(b) || !valid_pos(c) || !valid_pos(d)) {
		std::cerr << "Invalid query." << std::endl;
		std::cout << -1 << std::endl;
		exit(0);
	}

	Q++;
	if(Q > HARD_LIMIT) {
		std::cerr << "Too many queries." << std::endl;
		std::cout << -1 << std::endl;
		exit(0);
	}

	return a[a_] + a[b] < a[c] + a[d];
}

static bool check_valid(const std::vector<std::pair<int, int>> &a) {
	if(n * (n + 1) / 2 != (int)a.size()) {
		return false;
	}

	std::vector<std::vector<bool>> used(n, std::vector<bool>(n, false));
	for(int i = 0; i < (int)a.size(); i++) {
		if(!valid_pos(a[i].first) || !valid_pos(a[i].second) || used[a[i].first][a[i].second]) {
			return false;
		}

		used[a[i].first][a[i].second] = true;
		used[a[i].second][a[i].first] = true;
	}

	return true;
}
#endif // HOME

using namespace std;
const int N = 5000;
const int MX = 500;
#define pb push_back
int order[1 + N];
struct Calc {
    int x;
    int y;
    int sgn;
};
int globalN;
map <pair <int, int>, vector <Calc>> memo;
bool comparator (pair <int, int> a, pair <int, int> b) {
    if (order[a.first] <= order[b.first] && order[a.second] <= order[b.second])
        return 1;
    if (order[a.first] >= order[b.first] && order[a.second] >= order[b.second])
        return 0;
    if (globalN <= MX)
        for (Calc c : memo[a]) {
            if (order[c.x] >= order[b.first] && order[c.y] >= order[b.second] && c.sgn == 0)
                return 0;
            if (order[c.x] <= order[b.first] && order[c.y] <= order[b.second] && c.sgn == 1)
                return 1;
        }
    int ans = cmp (a.first, a.second, b.first, b.second);
    if (globalN <= MX) {
        memo[a].pb ({b.first, b.second, ans});
        memo[b].pb ({a.first, a.second, not ans});
    }
    return ans;
}

bool kk (int a, int b) {
    return cmp (0, a, 0, b);
}

vector <pair <int, int>> solve (int n) {
    globalN = n;
    vector <pair <int, int>> pairs;
    vector <int> ord;
    for (int i = 0; i < n; i++)
        ord.pb (i);
    sort (ord.begin (), ord.end (), kk);
    for (int i = 0; i < n; i++)
        order[ord[i]] = i;
    for (int i = 0; i < n; i++)
        for (int j = i; j < n; j++)
            pairs.pb ({i, j});
    sort (pairs.begin (), pairs.end (), comparator);
    return pairs;
}
#ifdef HOME
int main() {
	std::cin >> n;
	a.resize(n);
	for(int i = 0; i < n; i++) {
		a[i] = 3 * i % n;
	}

	Q = 0;
	std::vector<std::pair<int, int>> ret = solve(n);

	if(!check_valid(ret)) {
		std::cerr << "Invalid output." << std::endl;
		std::cout << -1 << std::endl;
		return 0;
	}

	for(int i = 1; i < (int) ret.size(); i++) {
		if(a[ret[i].first] + a[ret[i].second] < a[ret[i - 1].first] + a[ret[i - 1].second]) {
			std::cerr << "Output not sorted." << std::endl;
			std::cout << -1 << std::endl;
			return 0;
		}
	}

	std::cerr << "Correct!" << std::endl;
	std::cout << Q << std::endl;
	return 0;
}
#endif
