#include <iostream>
#include <vector>
using namespace std;

const int MAXS = 1250;
const int MOD = 1000000007;

int N, M, S;
vector<vector<int>> states;

int mat[MAXS][MAXS], beg[MAXS], fin[MAXS], res[MAXS][MAXS];

void genStates()
{
    int p = 1 << (2 * N);

    for (int mask = 0; mask < p; ++ mask)
    {
        vector<int> state;
        int x = mask;
        for (int i = p; i >= 2; i >>= 2)
        {
            int num = 0;
            if (x & (i >> 1)) num += 2;
            if (x & (i >> 2)) num += 1;
            state.push_back(num);
        }

        // check validity
        bool valid = true;
        for (int i = 1; i < N; ++ i)
        {
            if (state[i] == 0 and state[i - 1] == 2) valid = false;
            if (state[i] == 2 and state[i - 1] == 0) valid = false;
            if (state[i] == 2 and state[i - 1] == 2) valid = false;
            if (state[i] == 1 and state[i - 1] == 3) valid = false;
            if (state[i] == 3 and state[i - 1] == 1) valid = false;
            if (state[i] == 3 and state[i - 1] == 3) valid = false;
            if (valid == false) break;
        }
        if (valid == false) continue;

        bool start = true;
        for (int i = 0; i < N; ++ i)
        {
            if (state[i] == 0 and (i == 0 or state[i - 1] != 0) and (i == N - 1 or state[i + 1] != 0)) start = false;
            if (state[i] == 1 and (i == 0 or state[i - 1] != 1) and (i == N - 1 or state[i + 1] != 1)) start = false;
            if (start == false) break;
        }

        bool finish = true;
        for (int i = 0; i < N; ++ i)
        {
            if (state[i] > 1)
            {
                finish = false;
                break;
            }
        }

        beg[states.size()] = (start) ? 1 : 0;
        fin[states.size()] = (finish) ? 1 : 0;


        if (valid)
        {
            states.push_back(state);
            /*for (int e : state) cout << e << ' ';

            if (start) cout << "beg ";
            if (finish) cout << "fin ";

            cout << endl;*/
        }
    }

    S = states.size();
    // cout << states.size() << endl;
}

void genMatrix()
{
    for (int i = 0; i < S; ++ i)
    {
        for (int j = 0; j < S; ++ j)
        {
            bool flag = true;
            for (int k = 0; k < N; ++ k)
            {
                if (states[i][k] == 2 and states[j][k] != 0) flag = false;
                if (states[i][k] == 3 and states[j][k] != 1) flag = false;
                if (states[i][k] == 0 and states[j][k] == 2) flag = false;
                if (states[i][k] == 1 and states[j][k] == 3) flag = false;

                bool isonly = false;
                if ((states[j][k] == 0 or states[j][k] == 1) and (k == 0 or states[j][k - 1] != states[j][k]) and (k == N - 1 or states[j][k + 1] != states[j][k])) isonly = true;
                if (isonly and (states[i][k] % 2) != (states[j][k] % 2)) flag = false;

                if (flag == false) break;
            }
            mat[i][j] = (flag) ? 1 : 0;
            cout << mat[i][j] << ' ';
        }
        cout << endl;
    }
}

void multMatrix()
{
    for (int i = 0; i < S; ++ i)
    {
        for (int j = 0; j < S; ++ j)
        {
            if (M == 2 and fin[j] == 0) continue;
            res[i][j] = mat[i][j];
        }
    }

    for (int t = 2; t < M; ++ t)
    {
        int tmp[MAXS][MAXS];
        for (int i = 0; i < S; ++ i)
        {
            for (int j = 0; j < S; ++ j)
            {
                tmp[i][j] = 0;
            }
        }

        if (t == M - 1)
        {
            for (int j = 0; j < M; ++ j)
            {
                if (fin[j] == 1) continue;
                for (int i = 0; i < M; ++ i)
                {
                    mat[i][j] = 0;
                }
            }
        }

        for (int i = 0; i < S; ++ i)
        {
            for (int j = 0; j < S; ++ j)
            {
                for (int k = 0; k < S; ++ k)
                {
                    tmp[i][k] = (tmp[i][k] + 1ll * mat[i][j] * res[j][k]) % MOD;
                }
            }
        }

        for (int i = 0; i < S; ++ i)
        {
            for (int j = 0; j < S; ++ j)
            {
                res[i][j] = tmp[i][j];
            }
        }
    }
}

int main()
{
    cin >> N >> M;
    if (N < M) swap(N, M);

    genStates();
    genMatrix();
    multMatrix();

    /*cout << "-------------" << endl;

    for (int i = 0; i < S; ++ i)
    {
        for (int j = 0; j < S; ++ j)
        {
            cout << res[i][j] << ' ' ;
        }
        cout << endl;
    }*/

    long long ans = 0;
    for (int i = 0; i < S; ++ i)
    {
        if (beg[i] == 0) continue;
        for (int j = 0; j < S; ++ j)
        {
            ans = (ans + res[i][j]) % MOD;
            // if (res[i][j] != 0) cout << "!" << i << ' ' << j << endl;
        }
    }

    cout << ans << endl;
    return 0;
}
