#include<bits/stdc++.h>
#include "sqsort.h"

using namespace std;

const int nmax=2e3+42;

/*
static const int HARD_LIMIT = 50000000;

static int n;
static std::vector<int> a;

static bool valid_pos(int i) {
	return 0 <= i && i < n;
}

static int Q;
bool cmp(int a_, int b, int c, int d) {
	if(!valid_pos(a_) || !valid_pos(b) || !valid_pos(c) || !valid_pos(d)) {
		std::cerr << "Invalid query." << std::endl;
		std::cout << -1 << std::endl;
		exit(0);
	}

	Q++;
	if(Q > HARD_LIMIT) {
		std::cerr << "Too many queries." << std::endl;
		std::cout << -1 << std::endl;
		exit(0);
	}

	return a[a_] + a[b] < a[c] + a[d];
}

static bool check_valid(const std::vector<std::pair<int, int>> &a) {
	if(n * (n + 1) / 2 != (int)a.size()) {
		return false;
	}

	std::vector<std::vector<bool>> used(n, std::vector<bool>(n, false));
	for(int i = 0; i < (int)a.size(); i++) {
		if(!valid_pos(a[i].first) || !valid_pos(a[i].second) || used[a[i].first][a[i].second]) {
			return false;
		}

		used[a[i].first][a[i].second] = true;
		used[a[i].second][a[i].first] = true;
	}

	return true;
}
*/

int where[nmax];

bool my_cmp(pair<int, int> a,pair<int, int> b)
{
    return cmp(a.first,a.second,b.first,b.second);
}

bool majority(pair<int,int> a,pair<int,int> b)
{
    if(where[a.first]<=where[b.first]&&where[a.second]<=where[b.second])return 1;
    if(where[a.first]<=where[b.second]&&where[a.second]<=where[b.first])return 1;
    return 0;
}
bool faster_cmp(pair<int, int> a,pair<int, int> b)
{
    if(majority(a,b))return 1;
    if(majority(b,a))return 0;

    return my_cmp(a,b);
}

int order[nmax];

vector< pair<int,int> > quick_sort(int l,int r,vector< pair<int,int> > cur)
{
    if(l>r)
    {
        sort(cur.begin(),cur.end(),faster_cmp);
        return cur;
    }

    int av=(l+r)/2;

    vector< pair<int,int> > groups[2]={{},{}};

    pair<int,int> pivot={order[av],order[av]};

    for(auto k:cur)
        if(k==pivot)continue;
        else groups[faster_cmp(pivot,k)].push_back(k);

    groups[0]=quick_sort(l,av-1,groups[0]);

    groups[0].push_back(pivot);

    groups[1]=quick_sort(av+1,r,groups[1]);

    for(auto k:groups[1])
        groups[0].push_back(k);

    /*
    cout<<"groups "<<l<<" "<<r<<endl;
    for(auto k:groups[0])cout<<k.first<<" "<<k.second<<endl;
    cout<<"---"<<endl;
    */

    return groups[0];
}
std::vector<std::pair<int, int>> solve(int n)
{
    vector< pair<int,int> > help={};
    for(int i=0;i<n;i++)
        help.push_back({0,i});
    sort(help.begin(),help.end(),my_cmp);

    for(int i=0;i<n;i++)where[help[i].second]=i,order[i]=help[i].second;

    vector< pair<int,int> > ret={};
    for(int i=0;i<n;i++)
        for(int j=i;j<n;j++)
            ret.push_back({i,j});

    //sort(ret.begin(),ret.end(),faster_cmp);

    return quick_sort(0,n-1,ret);
}
/*
int main() {
	std::cin >> n;
	a.resize(n);
	for(int i = 0; i < n; i++) {
		a[i] = 3 * i % n;
	}

	Q = 0;
	std::vector<std::pair<int, int>> ret = solve(n);

	if(!check_valid(ret)) {
		std::cerr << "Invalid output." << std::endl;
		std::cout << -1 << std::endl;
		return 0;
	}

	for(int i = 1; i < (int) ret.size(); i++) {
		if(a[ret[i].first] + a[ret[i].second] < a[ret[i - 1].first] + a[ret[i - 1].second]) {
			std::cerr << "Output not sorted." << std::endl;
			std::cout << -1 << std::endl;
			return 0;
		}
	}

	std::cerr << "Correct!" << std::endl;
	std::cout << Q << std::endl;
	return 0;
}
*/
