#include<bits/stdc++.h>
#include "sqsort.h"

using namespace std;

const int nmax=2e3+42;
/*
static const int HARD_LIMIT = 50000000;

static int n;
static std::vector<int> a;

static bool valid_pos(int i) {
	return 0 <= i && i < n;
}

static int Q;
bool cmp(int a_, int b, int c, int d) {
	if(!valid_pos(a_) || !valid_pos(b) || !valid_pos(c) || !valid_pos(d)) {
		std::cerr << "Invalid query." << std::endl;
		std::cout << -1 << std::endl;
		exit(0);
	}

	Q++;
	if(Q > HARD_LIMIT) {
		std::cerr << "Too many queries." << std::endl;
		std::cout << -1 << std::endl;
		exit(0);
	}

	return a[a_] + a[b] < a[c] + a[d];
}

static bool check_valid(const std::vector<std::pair<int, int>> &a) {
	if(n * (n + 1) / 2 != (int)a.size()) {
		return false;
	}

	std::vector<std::vector<bool>> used(n, std::vector<bool>(n, false));
	for(int i = 0; i < (int)a.size(); i++) {
		if(!valid_pos(a[i].first) || !valid_pos(a[i].second) || used[a[i].first][a[i].second]) {
			return false;
		}

		used[a[i].first][a[i].second] = true;
		used[a[i].second][a[i].first] = true;
	}

	return true;
}
*/

int where[nmax];

vector< pair<short,short> > adj[nmax][nmax];
int in[nmax][nmax];

void add_edge(int a,int b,int c,int d)
{
    //cout<<"add edge "<<a<<" "<<b<<" "<<c<<" "<<d<<endl;

    adj[a][b].push_back({c,d});
    in[c][d]++;
}

bool my_cmp(pair<int, int> a,pair<int, int> b)
{
    int mem=cmp(a.first,a.second,b.first,b.second);

    if(mem==0)swap(a,b);

    add_edge(a.first,a.second,b.first,b.second);

    return mem;
}

bool dumb_cmp(pair<int, int> a,pair<int, int> b)
{
    return cmp(a.first,a.second,b.first,b.second);
}

bool majority(pair<int,int> a,pair<int,int> b)
{
    if(where[a.first]<=where[b.first]&&where[a.second]<=where[b.second])return 1;
    if(where[a.first]<=where[b.second]&&where[a.second]<=where[b.first])return 1;
    return 0;
}
bool faster_cmp(pair<int, int> a,pair<int, int> b)
{
    if(majority(a,b))return 1;
    if(majority(b,a))return 0;

    return my_cmp(a,b);
}

int order[nmax];

int pointer=0;

pair<short, pair<short,short> > active[nmax*nmax];

void push(pair<int, pair<int,int> > cur)
{
    pointer++;
    active[pointer]=cur;

    int help=pointer;

    while(help>1&&active[help].first>active[help-1].first)
    {
        swap(active[help],active[help-1]);
        help--;
    }
    /*
    cout<<"pushed "<<pointer<<endl;
    for(int i=1;i<=pointer;i++)cout<<active[i].first<<" "<<active[i].second.first<<" "<<active[i].second.second<<endl;
    cout<<"---"<<endl;
    */
}
std::vector<std::pair<int, int>> solve(int n)
{
    vector< pair<int,int> > help={};
    for(int i=0;i<n;i++)
        help.push_back({0,i});

    sort(help.begin(),help.end(),dumb_cmp);

    for(int i=0;i<n;i++)where[help[i].second]=i,order[i]=help[i].second;

    //cout<<"order: ";for(int i=0;i<n;i++)cout<<order[i]<<" ";cout<<endl;

    for(int i=0;i<n;i++)
        for(int j=i;j<n;j++)
        {
            if((i+1)<n&&i+1<=j)add_edge(order[i],order[j],order[i+1],order[j]);
            if((j+1)<n)add_edge(order[i],order[j],order[i],order[j+1]);
        }

    push({1,{order[0],order[0]}});

    vector< pair<int,int> > ret={};

    while(pointer)
    {
        while(pointer>=2)
        {
            pair<int, pair<int,int> > LHS=active[pointer];

            pair<int, pair<int,int> > RHS=active[pointer-1];

            pointer=pointer-2;

            if(my_cmp(LHS.second,RHS.second))
            {
                LHS.first++;
                push(LHS);
            }
            else
            {
                RHS.first++;
                push(RHS);
            }
        }

        pair<int, pair<int,int> > tp=active[1];

        ret.push_back({min(tp.second.first,tp.second.second),max(tp.second.first,tp.second.second)});

        //cout<<"found "<<tp.second.first<<" "<<tp.second.second<<endl;

        pointer=0;

        for(auto k:adj[tp.second.first][tp.second.second])
        {
            in[k.first][k.second]--;
            if(in[k.first][k.second]==0)push({adj[k.first][k.second].size(),{k}});
        }
    }

    return ret;
}
/*
int main() {
	std::cin >> n;
	a.resize(n);
	for(int i = 0; i < n; i++) {
		a[i] = 3 * i % n;
	}

	Q = 0;
	std::vector<std::pair<int, int>> ret = solve(n);

	if(!check_valid(ret)) {
		std::cerr << "Invalid output." << std::endl;
		std::cout << -1 << std::endl;
		return 0;
	}

	for(int i = 1; i < (int) ret.size(); i++) {
		if(a[ret[i].first] + a[ret[i].second] < a[ret[i - 1].first] + a[ret[i - 1].second]) {
			std::cerr << "Output not sorted." << std::endl;
			std::cout << -1 << std::endl;
			return 0;
		}
	}

	std::cerr << "Correct!" << std::endl;
	std::cout << Q << std::endl;
	return 0;
}
*/
