#include <bits/stdc++.h>
#include "sqsort.h"
#define pb push_back
#define f first
#define s second

using namespace std;

const int MAXN = 2000;
const int block = 50;
int p[MAXN+10];
vector<pair<int, int>> b[block];

struct csort {
    bool operator()(pair<int, int> l, pair<int, int> r) {
        return cmp(l.f, l.s, r.f, r.s);
    }
};

bool cmp(pair<int, int> l, pair<int, int> r) {
    //cerr<<l.f<<' '<<l.s<<" ? "<<r.f<<' '<<r.s<<" = "<<cmp(l.f, l.s, r.f, r.s)<<endl;
    return cmp(l.f, l.s, r.f, r.s);
}

void build(int n, vector<pair<int, int>> &t) {
    int bl = 0, d = ceil((double)n/block);
    for (int i=0; i<n; i++) {
        if ((i+1) % d == 0) {
            bl++;
        }
        b[bl].pb(t[i]);
    }
}

void rebuild(int n) {
    vector<pair<int, int>> temp;
    for (int i=0; i<block; i++) {
        for (int j=0; j<b[i].size(); j++) {
            temp.pb(b[i][j]);
        }
        b[i].clear();
    }
    build(n, temp);
}

pair<int, int> remSmallest() {
    int s = 0;
    while (!b[s].size()) {
        s++;
    }
    pair<int, int> a = b[s][0];
    b[s].erase(b[s].begin());
    return a;
}

void output() {
    //cerr<<"OUTPUT: "<<endl;
    for (int i=0; i<block; i++) {
        for (int j=0; j<b[i].size(); j++) {
            //cerr<<b[i][j].first<<' '<<b[i][j].second<<endl;
        }
    }
}

void add(pair<int, int> a) {
    vector<int> nemp;
    for (int i=0; i<block; i++) {
        if (b[i].size()) {
            nemp.pb(i);
        }
    }
    //cerr<<"neemp"<<nemp.size()<<endl;

    if (nemp.empty()) {
        b[0].pb(a);
        return;
    }
    int l = 0, r = nemp.size() - 1;
    int la;
    while (l != r) {
        int mid = (l+r+1) / 2;
        if (la = cmp(b[nemp[mid]][0], a)) {
            l = mid;
        } else {
            r = mid-1;
        }
    }
    //cerr<<"fbin "<<nemp[l]<<endl;

    int bl = nemp[l];
    l = 0, r = b[bl].size();
    if (la) {
        l = 1;
    }
    //cerr<<l<<' '<<r<<endl;
    while (l != r) {
        int mid = (l+r) / 2;
        if (cmp(b[bl][mid], a)) {
            l = mid + 1;
        } else {
            r = mid;
        }
    }
    //cerr<<"sbin "<<l<<endl;
    b[bl].insert(b[bl].begin()+l, a);
}

vector<pair<int, int>> solve(int n) {
    int all = n*(n+1)/2;
    vector<pair<int, int>> ans(all);
    vector<pair<int, int>> num(n);

    int wh = 0;
    for (int i=0; i<n; i++) {
        num[i] = {i, i};
    }
    sort(num.begin(), num.end(), csort());
    //cerr<<"sorted"<<endl;
    build(n, num);
    //cerr<<"build"<<endl;
    for (int i=0; i<n; i++) {
        p[num[i].f] = i;
    }

    for (int i=0; i<all; i++) {
        //output();
        if ((i+1) % block == 0) {
            //cerr<<"rebuilding"<<endl;
            //rebuild(n);
        }
        ans[wh] = remSmallest();
        //cerr<<"small"<<endl;
        int inc = ans[wh++].f;
        p[inc]++;
        if (p[inc] < n) {
            //cerr<<"adding"<<endl;
            add({inc, num[p[inc]].f});
            //cerr<<"added"<<endl;
        }
    }

    return ans;
}

