#include <bits/stdc++.h>
#include "sqsort.h"
#define pb push_back
#define f first
#define s second

using namespace std;

const int MAXN = 2000;
const int block1 = 32;
const int block2 = 16;
const int block3 = 4;
int p[MAXN+10];
vector<pair<int, int>> b[block1 + 1][block2 + 1];
pair<int, int> sm[block1+1];

struct csort {
    bool operator()(pair<int, int> l, pair<int, int> r) {
        return cmp(l.f, l.s, r.f, r.s);
    }
};

bool cmp(pair<int, int> l, pair<int, int> r) {
    //cerr<<l.f<<' '<<l.s<<" ? "<<r.f<<' '<<r.s<<" = "<<cmp(l.f, l.s, r.f, r.s)<<endl;
    return cmp(l.f, l.s, r.f, r.s);
}

void build(int n, vector<pair<int, int>> &t) {
    for (int i=0; i<block1; i++) {
        sm[i] = {1e9, 1e9};
    }
    int bl1 = 0, bl2 = 0;
    for (int i=0; i<t.size(); i++) {
        if ((i+1) % block1 == 0) {
            bl1++;
            bl2 = 0;
            sm[bl1] = t[i];
        } else if ((i+1) % block2 == 0) {
            bl2++;
        }
        b[bl1][bl2].pb(t[i]);
    }
}

void rebuild(int n) {
    vector<pair<int, int>> temp;
    for (int i=0; i<block1; i++) {
        for (int j=0; j<block2; j++) {
            for (int z=0; z<b[i][j].size(); z++) {
                temp.pb(b[i][j][z]);
            }
            b[i][j].clear();
        }
    }
    build(n, temp);
}

pair<int, int> remSmallest() {
    int s = 0, s2 = 0;
    while (!b[s][s2].size()) {
        s2++;
        if (s2 == block2) {
            s2 = 0;
            s++;
        }
    }
    pair<int, int> a = b[s][s2][0];
    b[s][s2].erase(b[s][s2].begin());
    s2 = 0;
    while (s2 < block2 && b[s][s2].empty()) {
        s2++;
    }
    if (!b[s][s2].empty()) {
        sm[s] = b[s][s2][0];
    } else {
        sm[s] = {1e9, 1e9};
    }
    return a;
}

void output() {
    cerr<<"OUTPUT: "<<endl;
    for (int i=0; i<block1; i++) {
        for (int j=0; j<block2; j++) {
            for (int z=0; z<b[i][j].size(); z++) {
                cerr<<b[i][j][z].first<<' '<<b[i][j][z].second<<endl;
            }
        }
    }
}

void add(pair<int, int> a) {
    int l = 0, r = block1 - 1;
    while (l != r) {
        int mid = (l+r+1) / 2;
        if (sm[mid].f != 1e9 && cmp(sm[mid], a)) {
            l = mid;
        } else {
            r = mid-1;
        }
    }

    int bl1 = l;
    //cerr<<bl1<<endl;
    vector<int> nemp;
    for (int j=0; j<block2; j++) {
        if (b[bl1][j].size()) {
            nemp.pb(j);
        }
    }
    if (nemp.empty()) {
        b[bl1][0].pb(a);
        sm[bl1] = a;
        return;
    }
    l = 0, r = nemp.size() - 1;
    while (l != r) {
        int mid = (l+r+1) / 2;
        if (cmp(b[bl1][nemp[mid]][0], a)) {
            l = mid;
        } else {
            r = mid-1;
        }
    }
    //cerr<<"fbin "<<nemp[l]<<endl;

    int bl2 = nemp[l];
    //cerr<<bl2<<endl;
    l = 0, r = b[bl1][bl2].size();
    //cerr<<l<<' '<<r<<endl;
    while (l != r) {
        int mid = (l+r) / 2;
        if (cmp(b[bl1][bl2][mid], a)) {
            l = mid + 1;
        } else {
            r = mid;
        }
    }
    //cerr<<"sbin "<<l<<endl;
    b[bl1][bl2].insert(b[bl1][bl2].begin()+l, a);
    if (l == 0) {
        sm[bl1] = a;
    }
}

vector<pair<int, int>> solve(int n) {
    int all = n*(n+1)/2;
    vector<pair<int, int>> ans(all);
    vector<pair<int, int>> num(n);

    int wh = 0;
    for (int i=0; i<n; i++) {
        num[i] = {i, i};
    }
    sort(num.begin(), num.end(), csort());
    //cerr<<"sorted"<<endl;
    build(n, num);
    //cerr<<"build"<<endl;
    for (int i=0; i<n; i++) {
        p[num[i].f] = i;
    }

    for (int i=0; i<all; i++) {
        //output();
        if ((i+1) % block1 == 0) {
            //cerr<<"rebuilding"<<endl;
            rebuild(n);
        }
        ans[wh] = remSmallest();
        //cerr<<"small"<<endl;
        int inc = ans[wh++].f;
        p[inc]++;
        if (p[inc] < n) {
            //cerr<<"adding"<<endl;
            add({inc, num[p[inc]].f});
            //cerr<<"added"<<endl;
        }
    }

    return ans;
}
