#include "sqsort.h"
#include <iostream>
#include <algorithm>
#include <numeric>
#include <iterator>
#include <map>

#define IDX(v) std::distance(indexes.begin(), std::find(indexes.begin(), indexes.end(), v))

using pvec = std::vector<std::pair<int, int>>;

std::vector<int> indexes;

bool custom_cmp(int a, int b, int c, int d) {
    if (a == c) {
        return IDX(b) < IDX(d);
    }
    if (b == d) {
        return IDX(a) < IDX(c);
    }

    return cmp(a, b, c, d);
}

pvec solve(int n) {
    pvec res;

    indexes.resize(n);
    std::iota(indexes.begin(), indexes.end(), 0);

    std::sort(indexes.begin(), indexes.end(),
              [&](const auto& x, const auto& y) {
                  return cmp(x, x, y, y);
              });

    // Generate result array
    for (auto a = 0; a < n; ++a) {
        for (auto b = a; b < n; ++b) {
            res.emplace_back(a, b);
        }
    }

    // Sort result array
    std::sort(res.begin(), res.end(),
              [&](const auto& x, const auto& y) {
                  return custom_cmp(x.first, x.second, y.first, y.second);
              });

    return res;
}
