#include"sqsort.h"
//using namespace std;

void merge(std::vector<std::pair<int,int > > &g,int l,int r)
{
	int m = (l+r)/ 2;
	int n1 = m - l + 1;
	int n2 = r - m;
	std::pair<int,int> lt[n1],rt[n2];
	for(int i = 0; i < n1; i++)
	{
		lt[i].first = g[l+i].first;
		lt[i].second = g[l+i].second;
	} 
	for(int j = 0; j < n2; j++)
	{
		rt[j].first = g[m+1+j].first;
		rt[j].second = g[m+1+j].second;
	} 
	int i,j,k;
	i = j = 0;
	k = l;
	while(i < n1 && j <n2)
	{
		if(cmp(lt[i].first,lt[i].second,rt[j].first,rt[j].second) == true)
		{
			g[k].first = lt[i].first;
			g[k].second = lt[i].second;
			i++;
		}
		else
		{
			g[k].first = rt[j].first;
			g[k].second = rt[j].second;
			j++;
		}
		k++;
	}
	while(i < n1)
	{
		g[k].first = lt[i].first;
		g[k].second = lt[i].second;
		i++;
		k++;
	}
	while(j < n2)
	{
		g[k].first = rt[j].first;
		g[k].second = rt[j].second;
		j++;
		k++;
	}
}

void mergeSort(std::vector<std::pair<int,int > > &g,int l,int r)
{
	if(l<r)
	{
		int m = (l+r)/2;
		//divide
		mergeSort(g,l,m);
		mergeSort(g,m+1,r);
		//conquer
		merge(g,l,r);
	}
}

std::vector<std::pair<int, int> > solve(int n)
{
	std::vector<std::pair<int,int> > g;
	//compute
	for(int i = 0; i <n; i++)
	{
		for(int j = i; j < n; j++)
		{
			g.push_back(std::make_pair(i,j));
		}
	}
	mergeSort(g,0,g.size()-1);
	return g;
}
