#include "sqsort.h"
#include<algorithm>
#include<queue>
#include<iostream>
#include<set>

bool compare(std::pair<int, int> a, std::pair<int, int> b)
{
    return cmp(a.first, a.second, b.first, b.second);
}

//maps from lowest to highest  to actual value
std::vector<int> mapping;
//maps from actual value to lowest to highest
std::vector<int> backmapping;


struct nums
{
    int a, b;
    nums() {this->a = -1; this->b = -1;}
    nums(int a, int b) {this->a = a; this->b = b;}

    bool operator< (nums x) const
    {
        return cmp(mapping[this->a], mapping[this->b], mapping[x.a], mapping[x.b]);
    }
};

//bool operator< (nums a, nums b)
//{
//    return cmp(mapping[a.a], mapping[a.b], mapping[b.a], mapping[b.b]);
//}

//bool operator< (std::pair<int, int> a, std::pair<int, int> b)
//{
//    return cmp(mapping[a.first], mapping[a.second], mapping[b.first], mapping[b.second]);
//}

std::vector<std::pair<int, int>> solve(int n)
{
    std::vector<std::pair<int, int> > singles;


    for (int i=0; i<n; i++)
    {
        singles.emplace_back(i, i);
    }
    sort(singles.begin(), singles.end(), compare);
    for (int i=0; i<n; i++)
    {
        //std::cout<<singles[i].first<<std::endl;
        mapping.push_back(singles[i].first);
    }

    std::vector<std::pair<int, int> > ret;

    std::priority_queue<nums, std::vector<nums> > q;

    //ret.emplace_back(0, 0);
    //ret.emplace_back(0, 1);

    //q.emplace(1, 1);
    //q.emplace(0, 2);

    q.emplace(0, 0);

    std::set<std::pair<int, int> > checked;

    while (!q.empty())
    {
        nums t = q.top();
        //std::cout<<t.a<<" "<<t.b<<std::endl;
        q.pop();
        ret.emplace_back(t.a, t.b);
        if (t.b + 1 < n && !checked.count(std::make_pair(t.a, t.b + 1)))
        {
            checked.emplace(t.a, t.b + 1);
            q.emplace(t.a, t.b + 1);
        }
        if (t.a + 1 <= t.b && !checked.count(std::make_pair(t.a + 1, t.b)))
        {
            checked.emplace(t.a + 1, t.b);
            q.emplace(t.a + 1, t.b);
        }

    }

    for (int i=0; i<ret.size(); i++)
    {
        ret[i].first = mapping[ret[i].first];
        ret[i].second = mapping[ret[i].second];
    }

    return ret;
}
/**
0 0
0 1
1 1
1 2
2 2
2 3
3 3
3 4
4 4
2 4
1 3
1 4
0 2
0 3
0 4
*/
