#include <iostream>

using namespace std;

const int MAXN = 55;
const long long mod = 1e9 + 7;

long long fastPow(long long x, long long p)
{
    long long ans = 1, curr = x;

    while(p!=0)
    {
        if(p%2!=0) ans = (ans*curr)%mod;

        p/=2;
        curr = (curr*curr)%mod;
    }

    return ans;
}

long long inv(long long x)
{
    return fastPow(x, mod-2);
}

int n, m;
int selected[MAXN][MAXN];

void select(int i, int j, int sign)
{
    for(int k = 0;k<n;k++) selected[k][j] += sign;
    for(int k = 0;k<m;k++) selected[i][k] += sign;
    selected[i][j] -= sign;
}

int getNotSelected()
{
    int cnt = 0;
    for(int i = 0;i<n;i++)
        for(int j = 0;j<m;j++)
            cnt += (selected[i][j]==0);

    return cnt;
}

long long ans = 0;
void rec(int i, int j, int selectedCnt)
{
    if(j==m)
    {
        i++;
        j = 0;
    }
    if(i==n)
    {
        if(selectedCnt%2==0) ans += fastPow(2, getNotSelected())*((selectedCnt==0)?1:2);
        else ans -= fastPow(2, getNotSelected())*((selectedCnt==0)?1:2);

        ans = (ans+3*mod)%mod;

        return;
    }

    if(selected[i][j]==0)
    {
        select(i, j, +1);
        rec(i, j+1, selectedCnt+1);
        select(i, j, -1);
    }

    rec(i, j+1, selectedCnt);
}

int main()
{
    //ios::sync_with_stdio(false);
    //cin.tie(NULL);

    cin >> n >> m;
    rec(0, 0, 0);

    cout << ans << '\n';
}
