#include <iostream>
#include <functional>

#include "sqsort.h"
//#include "Lgrader.cpp"

using namespace std;

const int MAXN = 2005;

struct MyPair
{
    int i, j;

    MyPair(){}
    MyPair(int i, int j)
    {
        this->i = i;
        this->j = j;
    }
};

int numberSize[MAXN];

void initNumberSize(int n)
{
    vector <int> v;
    for(int i = 0;i<n;i++)
        v.push_back(i);

    sort(v.begin(), v.end(),
    [](int i, int j)
    {
        return cmp(i, i, j, j);
    });

    for(int i = 0;i<n;i++)
        numberSize[ v[i] ] = i;
}

vector<pair<int, int>> solve(int n)
{
    vector <MyPair> v;
    for(int i = 0;i<n;i++)
        for(int j = i;j<n;j++)
            v.push_back(MyPair(i, j));

    initNumberSize(n);

    sort(v.begin(), v.end(),
    [](MyPair A, MyPair B)
    {
        if(max(numberSize[A.i], numberSize[A.j])<min(numberSize[B.i], numberSize[B.j])) return true;
        if(min(numberSize[A.i], numberSize[A.j])>max(numberSize[B.i], numberSize[B.j])) return false;

        return cmp(A.i, A.j, B.i, B.j);
    });

    vector <pair <int, int>> ans;
    for(MyPair mp: v) ans.push_back({mp.i, mp.j});

    return ans;
}

