#include <bits/stdc++.h>
#include "sqsort.h"
using namespace std;
bool cmp(int a, int b, int c, int d);

mt19937 mt (52378);

vector <int> sorted, pos;

vector <int> merge1 (vector <int> a, vector <int> b){
    vector <int> ans;
    int sza = a.size (), szb = b.size (), la = 0, lb = 0;
    while (la < sza || lb < szb){
        if (la == sza) ans.push_back (b [lb ++]);
        else if (lb == szb) ans.push_back (a [la ++]);
        else{
            bool dali = cmp (a [la], a [la], a [la], b [lb]);
            if (dali) ans.push_back (a [la ++]);
            else ans.push_back (b [lb ++]);
        }
    }
    return ans;
}

vector <int> sort1 (int l, int r){
    if (l == r) return {l};
    int mid = l + r >> 1;
    return merge1 (sort1 (l, mid), sort1 (mid + 1, r));
}

bool used [2048][2048];

vector <pair <int, int> > merge2 (vector <pair <int, int> > a, vector <pair <int, int> > b, int n){
    int first = pos [a [0].first], last = pos [b.back ().first];
    for (int i = first; i <= last; i ++){
        for (int j = i; j < n; j ++){
            used [sorted [i]][sorted [j]] = 0;
        }
    }
    vector <pair <int, int> > ans;
    int sza = a.size (), szb = b.size (), la = 0, lb = 0;
    while (la < sza || lb < szb){
        if (la == sza) ans.push_back (b [lb ++]);
        else if (lb == szb) ans.push_back (a [la ++]);
        else{
            if (!used [sorted [pos [b [lb].first] - 1]][b [lb].second] || pos [b [lb].second] > pos [a [la].second]){
                ans.push_back (a [la]);
                used [a [la].first][a [la].second] = 1;
                la ++;
                continue;
            }
            bool dali = cmp (a [la].first, a [la].second, b [lb].first, b [lb].second);
            if (dali){
                ans.push_back (a [la]);
                used [a [la].first][a [la].second] = 1;
                la ++;
            }
            else{
                ans.push_back (b [lb]);
                used [b [lb].first][b [lb].second] = 1;
                lb ++;
            }
        }
    }
    return ans;
}

vector <pair <int, int> > sort2 (int l, int r, int n){
    if (l == r){
        vector <pair <int, int> > ans;
        for (int i = l; i < n; i ++){
            ans.push_back (make_pair (sorted [l], sorted [i]));
        }
        return ans;
    }
    int mid = l + r >> 1;
    return merge2 (sort2 (l, mid, n), sort2 (mid + 1, r, n), n);
}

vector <pair <int, int> > random_merge (vector <pair <int, int> > a, vector <pair <int, int> > b, int n){
    vector <int> ppos (n);
    vector <pair <int, int> > ans;
    int sza = a.size (), szb = b.size (), posa = 0;
    for (int i = 0; i < sza; i ++){
        auto p = a [i];
        if (p.first == a.back ().first) ppos [p.second] = i;
    }
    int l = ppos [b [0].first];
    for (auto p : b){
        int L = l, R = a.size () - 1;
        while (L < R){
            int mid = mt () % (R - L) + L + 1;
            bool dali = cmp (a [mid].first, a [mid].second, p.first, p.second);
            if (dali) L = mid;
            else R = mid - 1;
        }
        while (posa < L) ans.push_back (a [posa ++]);
        ans.push_back (p);
        l = max (L, ppos [sorted [pos [p.second] + 1]]);
    }
    while (posa < sza) ans.push_back (a [posa ++]);
    return ans;
}

vector <pair <int, int> > random_sort (int n){
    vector <pair <int, int> > ans;
    for (int i = 0; i < n; i ++) ans.push_back ({sorted [0], sorted [i]});
    for (int i = 1; i < n; i ++){
        vector <pair <int, int> > v;
        for (int j = i; j < n; j ++) v.push_back ({sorted [i], sorted [j]});
        ans = random_merge (ans, v, n);
    }
    return ans;
}

std::vector<std::pair<int, int>> solve(int n){
    sorted = sort1 (0, n - 1);
    pos.resize (n);
    for (int i = 0; i < n; i ++) pos [sorted [i]] = i;
    //return sort2 (0, n - 1, n);
    return random_sort (n);
}
/*
int main (){

    int n;
    cin >> n;
    for (int i = 0; i < n; i ++) cin >> seq [i];
    vector <pair <int, int> > res = solve (n);
    for (auto p : res) cout << p.first << ' ' << p.second << '\n';

}
*/
