#include <bits/stdc++.h>
#include "sqsort.h"

#pragma GCC optimize "-O3"

#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

mt19937 gen(50);

int rand(int l, int r) {
    return (l + gen() % (r - l + 1));
}

vector<pair<int, int>> pairs;

void solve(int low, int high) {
    if (low >= high) {
        return;
    }

    vector<pair<int, int>> lesser, bigger;
    int pos = rand(low, high);
//    trace(pos);
    pair<int, int> central = pairs[pos];

    for (int i = low; i <= high; i++) {
        if (i == pos) {
            continue;
        }

        if (cmp(pairs[i].first, pairs[i].second, pairs[pos].first, pairs[pos].second)) {
            lesser.emplace_back(pairs[i]);
        } else {
            bigger.emplace_back(pairs[i]);
        }
    }

    int ptr = low;
    int ptrLesser = 0;

    while (ptrLesser < (int)lesser.size()) {
        pairs[ptr++] = lesser[ptrLesser++];
    }

    int centralPos = ptr;
    pairs[ptr++] = central;

    int ptrBigger = 0;

    while (ptrBigger < (int)bigger.size()) {
        pairs[ptr++] = bigger[ptrBigger++];
    }

    solve(low, centralPos - 1);
    solve(centralPos + 1, high);
}

vector<pair<int, int>> solve(int n) {
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            pairs.emplace_back(i, j);
        }
    }

    solve(0, pairs.size() - 1);

    return pairs;
}
