#include <bits/stdc++.h>
#include "sqsort.h"

#pragma GCC optimize "-O3"

#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

vector<pair<int, int>> pairs;

void solve(int low, int high) {
    if (low == high) {
        return;
    }

    int middle = low + (high - low) / 2;

    solve(low, middle);
    solve(middle + 1, high);

    vector<pair<int, int>> sortedList;

    int ptrLeft = low, ptrRight = middle + 1;

    while (ptrLeft <= middle && ptrRight <= high) {
        if (cmp(pairs[ptrLeft].first, pairs[ptrLeft].second, pairs[ptrRight].first, pairs[ptrRight].second)) {
            sortedList.emplace_back(pairs[ptrLeft++]);
        } else {
            sortedList.emplace_back(pairs[ptrRight++]);
        }
    }

    while (ptrLeft <= middle) {
        sortedList.emplace_back(pairs[ptrLeft++]);
    }

    while (ptrRight <= high) {
        sortedList.emplace_back(pairs[ptrRight++]);
    }

    for (int i = low; i <= high; i++) {
        pairs[i] = sortedList[i - low];
    }
}

vector<pair<int, int>> solve(int n) {
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            pairs.emplace_back(i, j);
        }
    }

    solve(0, pairs.size() - 1);

    return pairs;
}
